﻿#SingleInstance Force
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 작성자 : DDART
;; 배포장소 : DDART AUTOMATION
;; https://auto.ddart.net
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
global _app := new CAutosenderApplication("sktdata_autosender", "1.18", "SKT 데이터선물 자동발송기 v1.18 (2022.04.01)")
return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Main program
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CAutosenderApplication extends CApplication
{
	InitApplication()
	{
		this.bRunnable := true
		this.lvReceiver := new CListView("수신정보")
		this.lvReceiver.ShowWindow()
		this.LoadReceiver()
		this.sizer.Add(this.lvReceiver)
		this.sizer.Add(this.tabLog)
		this.tabLog.ShowWindow()
	}
	InitSizerSplitter()
	{
		this.sizer.SetSplitterPos(1, (this.setting.spv_pos ? this.setting.spv_pos : this.h_toolbar + Floor(this.h_client / 2)))
		return true
	}
	AddHotKey()
	{
		this.hotkeys["F1"] := this.ID_HELP_HELP
		this.hotkeys["F2"] := this.ID_FILE_MAKEEXE
		this.hotkeys["F5"] := this.ID_OPTION_SETTING
		this.hotkeys["F7"] := this.ID_TOOL_EXECUTE
		this.hotkeys["F8"] := this.ID_TOOL_STOP
		this.hotkeys["^a"] := this.ID_EDIT_ADD
		this.hotkeys["^m"] := this.ID_EDIT_MODIFY
		this.hotkeys["F5"] := this.ID_EDIT_INIT
		this.hotkeys["Delete"] := this.ID_EDIT_DELETE
	}
	AddMenu()
	{
		this.menu.file := new CMenu("File")
		this.ID_FILE_MAKEEXE := this.menu.file.Add("실행파일 만들기(&M)`tF2")
		this.ID_FILE_EXIT := this.menu.file.Add("종료(&X)")
		
		this.menu.option := new CMenu("Option")
		this.ID_OPTION_SETTING := this.menu.option.Add("설정(&S)`tF5")
		this.menu.edit := new CMenu("Edit")
		this.ID_EDIT_ADD := this.menu.edit.Add("추가(&A)`tCtrl+A")
		this.ID_EDIT_MODIFY := this.menu.edit.Add("수정(&M)`tCtrl+M")
		this.ID_EDIT_DELETE := this.menu.edit.Add("삭제(&D)`tDel")
		this.ID_EDIT_UP := this.menu.edit.Add("위로(&U)")
		this.ID_EDIT_DOWN := this.menu.edit.Add("아래로")
		this.ID_EDIT_INIT := this.menu.edit.Add("초기화(&I)`tF5")
		this.menu.tool := new CMenu("Tool")
		this.ID_TOOL_EXECUTE := this.menu.tool.Add("실행(&R)`tF7") 
		this.ID_TOOL_STOP := this.menu.tool.Add("중지(&S)`tF8") 
		this.ID_TOOL_CHROMELAUNCH := this.menu.tool.Add("개발자 모드 크롬(&C)")
		
		this.menu.help := new CMenu("Help")
		this.ID_HELP_HELP := this.menu.help.Add("도움말(&H)`tF1")
		this.ID_HELP_UPDATE := this.menu.help.Add("업데이트 확인(&U)")
		this.menu.bar := new CMenu("MenuBar")
		this.menu.bar.Add("파일(&F)", this.menu.file)
		this.menu.bar.Add("편집(&E)", this.menu.edit)
		this.menu.bar.Add("도구(&T)", this.menu.tool)
		this.menu.bar.Add("옵션(&O)", this.menu.option)
		this.menu.bar.Add("도움말(&H)", this.menu.help)
		Gui, Menu, % this.menu.bar.name
	}
	AddToolbar()
	{
		buttons := Array()
		icons := Array()
		if (A_OSVersion = "WIN_7")
		{
			icons := [152, 151, 140, 16, 25, 156, 107]
		}
		else if (InStr(A_OSVersion, "WIN_8"))
		{
			icons := [123, 138, 127, 12, 18, 143, 94]
		}
		else if (this.GetWin10Version() >= 1803)
		{
			icons := [133, 36, 125, 12, 18, 136, 92]
		}
		else
		{
			icons := [119, 134, 123, 12, 18, 139, 90]
		}
		
		buttons.Push(new CToolbarButton(this.ID_EDIT_INIT, "초기화", icons[1]))
		buttons.Push(new CToolbarButton(this.ID_EDIT_DELETE, "삭 제", icons[2]))
		buttons.Push(new CToolbarButton(this.ID_EDIT_MODIFY, "수 정", icons[3]))
		buttons.Push(new CToolbarButton(this.ID_EDIT_ADD, "추 가", icons[4]))
		buttons.Push(new CToolbarButton(this.ID_EDIT_UP, "위 로", 247, "shell32.dll"))
		buttons.Push(new CToolbarButton(this.ID_EDIT_DOWN, "아래로", 248, "shell32.dll"))
		buttons.Push(new CToolbarButton(this.ID_OPTION_SETTING, "설 정", icons[5]))
		buttons.Push(new CToolbarButton(this.ID_TOOL_STOP, "중 지", icons[6]))
		buttons.Push(new CToolbarButton(this.ID_TOOL_EXECUTE, "실 행", icons[7]))
		il := IL_Create(buttons.MaxIndex(), 2, true)
		Loop, % buttons.MaxIndex()
		{
			IL_Add(il, buttons[A_Index].icofile, buttons[A_Index].icono)
		}
		this.toolbar.SetImageList(il)
		this.toolbar.SetButtonWidth(80 * this.m, 100 * this.m) 
		Loop, % buttons.MaxIndex()
		{
			this.toolbar.AddButton(A_Index -1, buttons[A_Index].id, buttons[A_Index].text)
		}
		this.toolbar.AutoSize()
		this.toolbar.SetMaxTextRows(1)
	}
	AppendLogBar(title)
	{
		this.AppendLog("_______________________________________________________________<" title ">______")
	}
	LoadSetting()
	{
		this.setting := new CAutosenderSetting()
		base.LoadSetting()
	}
	LoadReceiver()
	{
		col := 1
		this.lvReceiver.InsertCol(col++, "100 sort ", "이름")
		this.lvReceiver.InsertCol(col++, "200 sort center", "수신번호")
		this.lvReceiver.InsertCol(col++, "100 sort float right", "선물 용량(GB)")
		this.lvReceiver.InsertCol(col++, "100 float right", "보낸 용량(GB)")
		this.lvReceiver.InsertCol(col++, "100 float right", "남은 용량(GB)")
		Loop, % this.setting.receivers.MaxIndex()
		{
			rv := this.setting.receivers[A_Index]
			this.lvReceiver.Add("", rv.name, rv.phone, rv.total, rv.sent, rv.left)
		}
		this.OnContentChanged()
	}
	Run()
	{
		this.SetTimer(this.ID_TIMER_RUN, "Off")
		
		if (this.lvReceiver.GetCount())
		{
			this.InitLog()
			this.AppendLogBar("실행 시작")
			datasender := new CSTKDataSenderCR()
			if (datasender.Init(this.setting.fetcher))
			{
				this.AppendLog(datasender.GetBrowserInfo())
				this.AppendLogBar("자동선물 시작")
				if (datasender.AutoSend(this.lvReceiver))
				{
					this.AppendLogBar("자동선물 완료")
				}
				else
				{
					this.AppendLogBar("자동선물 중단")
					this.AppendLog(datasender.GetError())
				}
			}
			else
			{
				this.AppendLog(datasender.GetError())
			}		
			this.AppendLogBar("실행 종료")
		}
		else
		{
			this.AppendLog("수신자를 추가해주세요")
		}
		this.ResetRunState()
	}
	SaveReceiver()
	{
		this.setting.receivers := []
		Loop, % this.lvReceiver.GetCount()
		{
			row := A_Index
			receiver := {}
			col := 1
			receiver.name := this.lvReceiver.GetItemText(row, col++)
			receiver.phone := this.lvReceiver.GetItemText(row, col++)
			receiver.total := this.lvReceiver.GetItemText(row, col++)
			receiver.sent := this.lvReceiver.GetItemText(row, col++)
			receiver.left := this.lvReceiver.GetItemText(row, col++)
			this.setting.receivers.Push(receiver)
		}
	}
	SaveSetting()
	{
		this.setting.spv_pos := this.sizer.GetSplitterPos(1)
		this.SaveReceiver()
		base.SaveSetting()
	}
	UpdateButtons()
	{
		if (this.lvReceiver.GetCount() = 0)
		{
			this.bRunnable := false
		}
		base.UpdateButtons()
		this.EnableButton(this.menu.edit, this.ID_EDIT_INIT, !this.bRunning && this.bRunnable)
		row := iLast := iFirst := this.lvReceiver.GetNext(0)
		bSelected := false
		if (row)
		{
			bSelected := true
			while(row := this.lvReceiver.GetNext(row))
			{
				if (row != iLast + 1)
				{
					bSelected := false
				}
				iLast := row
			}
		}
		this.EnableButton(this.menu.edit, this.ID_EDIT_DELETE, !this.bRunning && this.bRunnable && iLast)
		this.EnableButton(this.menu.edit, this.ID_EDIT_MODIFY, !this.bRunning && this.bRunnable && this.lvReceiver.GetSelectedCount() = 1)
		this.EnableButton(this.menu.edit, this.ID_EDIT_UP, !this.bRunning && this.bRunnable && bSelected && iFirst > 1)
		this.EnableButton(this.menu.edit, this.ID_EDIT_DOWN, !this.bRunning && this.bRunnable && bSelected && iLast < this.lvReceiver.GetCount())
	}
	OnAdd()
	{
		this.dlgAx := new CReceiverInfoDialog()
		if (this.dlgAx.DoModal())
		{
			this.lvReceiver.Add("", this.dlgAx.name, this.dlgAx.phone, this.dlgAx.amount, 0.0 , Format("{1:.1f}", this.dlgAx.amount))
		}
		this.dlgAx := ""
		this.OnContentChanged()
	}
	OnCommand(wParam, lParam, nMsg, hWnd)
	{
		id := wParam & 0xFFFF
		if (id =  this.ID_EDIT_ADD)
		{
			this.OnAdd()
		}
		else if (id =  this.ID_EDIT_MODIFY)
		{
			this.OnModify()
		}
		else if (id =  this.ID_EDIT_UP)
		{
			this.OnUp()
		}
		else if (id =  this.ID_EDIT_DOWN)
		{
			this.OnDown()
		}
		else if (id =  this.ID_EDIT_DELETE)
		{
			this.OnDelete()
		}
		else if (id =  this.ID_EDIT_INIT)
		{
			this.OnInit()
		}
		else if (id =  this.ID_OPTION_SETTING)
		{
			this.OnOptionSetting()
		}
		else
		{
			base.OnCommand(wParam, lParam, nMsg, hWnd)
		}
	}
	OnContentChanged()
	{
		if (this.bRunnable && this.lvReceiver.GetCount() = 0)
		{
			this.bRunnable := false
			this.UpdateButtons()
		}
		else if (!this.bRunnable && this.lvReceiver.GetCount() > 0)
		{
			this.bRunnable := true
			this.UpdateButtons()
		}
		else
		{
		}
	}
	OnDelete()
	{
		count := 0
		row := 0
		while(row := this.lvReceiver.GetNext(row))
		{
			this.lvReceiver.Delete(row)
			count++
		}
		if (count > 0)
		{
			this.OnContentChanged()
		}
		else
		{
			this.AppendLog("삭제할 번호를 먼저 선택하세요")
		}
	}
	OnErase()
	{
		this.editLog.Clear()
	}
	OnInit()
	{
		count := this.lvReceiver.GetCount()
		if (count)
		{
			Loop, %count%
			{
				this.lvReceiver.Modify(A_Index, "Col4", 0.0)
				this.lvReceiver.Modify(A_Index, "Col5", Format("{1:.1f}", this.lvReceiver.GetItemText(A_Index, 3)))
			}
			this.AppendLog("보낸 용량, 남은 용량을 초기화했습니다")
		}
	}
	OnLoad()
	{
		base.OnLoad()
		this.PostMessage(this.WM_SETTING_CHANGED, 0, 0)
	}
	OnModify()
	{
		if (this.lvReceiver.GetCount("S") > 1)
		{
			this.AppendLog("하나만 선택하세요")
			return 
		}
		row := this.lvReceiver.GetNext(0)
		if (row > 0)
		{
			col := 1
			name := this.lvReceiver.GetItemText(row, col++)
			phone := this.lvReceiver.GetItemText(row, col++)
			amount := this.lvReceiver.GetItemText(row, col++)
			sent := this.lvReceiver.GetItemText(row, col++)
			this.dlgAx  := new CReceiverInfoDialog(name, phone, amount)
			if (this.dlgAx.DoModal())
			{
				this.lvReceiver.Modify(row, "", this.dlgAx.name, this.dlgAx.phone, this.dlgAx.amount, Format("{1:.1f}", sent), Format("{1:.1f}", this.dlgAx.amount - sent))
			}
			this.dlgAx := ""
		}
		else
		{
			this.AppendLog("수정할 번호를 먼저 선택하세요")
		}
	}
	OnUp()
	{
		iFirst := iLast := row := this.lvReceiver.GetNext(0)
		while(row := this.lvReceiver.GetNext(row))
		{
			iLast := row
		}
		if (iFirst > 1)
		{
			row_delete := iFirst - 1
			rows := Array()
			Loop, 5
			{
				rows.Push( this.lvReceiver.GetItemText(row_delete, A_Index))
			}
			this.lvReceiver.Insert(iLast + 1, "", rows*)
			this.lvReceiver.Delete(row_delete)
		}
	}
	OnDown()
	{
		iFirst := iLast := row := this.lvReceiver.GetNext(0)
		while(row := this.lvReceiver.GetNext(row))
		{
			iLast := row
		}
		if (iFirst > 0 && iLast < this.lvReceiver.GetCount())
		{
			row_delete := iLast + 1
			rows := Array()
			Loop, 5
			{
				rows.Push( this.lvReceiver.GetItemText(row_delete, A_Index))
			}
			this.lvReceiver.Delete(row_delete)
			this.lvReceiver.Insert(iFirst, "", rows*)
		}
	}
	OnNotify(wParam, lParam, nMsg, hWnd)
	{
		code := NumGet(lParam+0, 2 * A_PtrSize, "Int")
		if (code = CListViewCtrl.LVN_ITEMCHANGED)
		{
			this.UpdateButtons()
		}
	}
	
	OnOptionSetting()
	{
		this.dlgAx := new CAutoSenderSettingDialog()
		if (this.dlgAx.DoModal(this.setting))
		{
			this.setting := this.dlgAx.setting
		}
		this.dlgAx := ""
		this.PostMessage(this.WM_SETTING_CHANGED, 0, 0)
	}
	OnSettingChanged(wParam, lParam, nMsg, hWnd)
	{
		this.InitChrome()
		this.InitLog()
		this.UpdateButtons()
	}
}
class CApplication extends CWindow
{
	__New(name, version, titletext)
	{
		this.AddErrorHandler()
		SetWorkingDir %A_ScriptDir%
		SetWinDelay, -1
		FileEncoding, UTF-8
		; GUI
		Gui, +Resize     +HWNDhWnd
		base.__New(hWnd)
		this.name := name
		this.version := version
		this.titletext := titletext
		this.cmd_exit := ""
		this.m := A_ScreenDPI / 96
		this.toolbar := new CToolbarCtrl()
		this.toolbar_pos := 0
		this.menu := Object()
		this.AddMenu()
		this.AddToolbar()
		this.AddHotkeyHandler()
		this.AddStatusBar()
		; Init
		this.InitIEEmulation()
		this.dlgAx := ""
		this.bRunnable := false
		this.bRunning := false
		this.setting := { width : 800, height : 600}
		; AutoSizer
		this.sizer := new CAutoSizer(true, 2)
	
		this.hCursorNS := DllCall("LoadCursor", "ptr", 0, "ptr", CWU.IDC_SIZENS)
		this.hCursorWE := DllCall("LoadCursor", "ptr", 0, "ptr", CWU.IDC_SIZEWE)
		this.hCursorArrow := DllCall("LoadCursor", "ptr", 0, "ptr", CWU.IDC_ARROW)
		
		; 윈도우메세지핸들러
		this.WM_SETTING_CHANGED := 0x10000
		this.WM_WEBSOCKET_DISCONNECTED := 0x10000 + 1
		this.fn_wm_handler := Object()
		this.AddMessageHandler(CWU.WM_SIZE, "OnSize")
		this.AddMessageHandler(CWU.WM_COMMNOTIFY, "OnCommNotify")
		this.AddMessageHandler(CWU.WM_NOTIFY, "OnNotify")
		this.AddMessageHandler(CWU.WM_KEYDOWN, "OnKeyDown")
		this.AddMessageHandler(CWU.WM_COMMAND, "OnCommand")
		this.AddMessageHandler(CWU.WM_SYSCOMMAND, "OnSysCommand")
		this.AddMessageHandler(CWU.WM_MOUSEMOVE, "OnMouseMove")
		this.AddMessageHandler(CWU.WM_LBUTTONDOWN, "OnLButtonDown")
		this.AddMessageHandler(CWU.WM_LBUTTONUP, "OnLButtonUp")
		this.AddMessageHandler(this.WM_SETTING_CHANGED, "OnSettingChanged")
		this.AddMessageHandler(this.WM_WEBSOCKET_DISCONNECTED, "OnWebSocketDisconnected")
		; 타이머
		this.fn_tm_handler := Array()
		this.ID_TIMER_RUN := this.AddTimer("Run")
		this.ID_TIMER_MSGBOX := this.AddTimer("HandleMsgBox")
		this.OnUpdateCheck(false)
		this.LoadIcon()
		this.LoadSetting()
		this.tabLog := new CTabView()
		this.editLog := new CEditCtrl("로그창", true)
		this.tabLog.Add(this.editLog)
		this.idRun := 0
		this.bRunning := false
		this.InitApplication()
		; 마지막
		this.Show()
		this.OnLoad()
	}
	__Delete()
	{
	}
	AddErrorHandler()
	{
		this.fnOnError := this.OnError.Bind(this)
		; 기타
		if A_AhkVersion >= 1.1.29
		{
			OnError(this.fnOnError)
		}
		else
		{
			this.AppendLog("오토핫키 버전(" A_AhkVersion ")이 너무 낮습니다. 최신버전으로 업데이트하세요")
		}
	}
	AddHotkeyHandler()
	{
		this.hotkeys := Object()
		this.AddHotkey()
		fn := this.OnHotKey.Bind(this)
		Hotkey, IfWinActive, % this.title
		for key, val in % this.hotkeys
		{
			HotKey, %key%, %fn%
		}
		this.fnHotKey := fn
	}
	AddMessageHandler(wm, handler)
	{
		if (IsFunc(this[handler]))
		{
			this.fn_wm_handler[wm] := this[handler].Bind(this)
			OnMessage(wm, this.fn_wm_handler[wm])
		}
	}
	AddTimer(handler)
	{
		if (IsFunc(this[handler]))
		{
			return this.fn_tm_handler.Push(this[handler].Bind(this))
		}
		return 0
	}
	AddHotKey()
	{
	}
	AddMenu()
	{
	}
	AddStatusBar()
	{
		this.statusbar := new CStatusBarCtrl()
		this.statusbar.SetParts(-1, -1, -1, -1)
		this.statusbar.SetText(0, this.titletext)
		this.statusbar.SetText(1, A_YYYY "-" A_MM "-" A_DD)
		this.statusbar.SetText(2, "OK")		
	}
	AddToolbar()
	{
	}
	AppendLog(msg)
	{
		FormatTime, TimeString, , HH:mm:ss
		msg := "[" TimeString "] " msg "`r`n"
		this.editLog.AppendText(msg)
	}
	AppendLogBar(title)
	{
		FormatTime, TimeString, , HH:mm:ss
		this.UpdateSB(title)
		this.UpdateSB(TimeString, 2)
		this.AppendLog("__________________________________________________________________________<" title ">______")
	}
	EnableButton(ByRef menu, id, bEnable := true)
	{
		menu.Enable(id, bEnable)
		this.toolbar.Enable(id, bEnable)
	}
	ExitIfStop()
	{
		if (!this.bRunnable)
		{
			this.UpdateSB("사용자에 의해 중단되었습니다")
			this.AppendLog("사용자에 의해 중단되었습니다")
			this.ResetRunState()
			Exit, 1
		}
	}
	GetWin10Version()
	{
		if (!InStr(A_OSVersion, "10."))
		{
			return 0
		}
		RegRead, DisplayVersion , HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion, DisplayVersion
		return DisplayVersion
	}
	InitApplication()
	{
		this.bRunnable := true
		this.InitLog()
	}
	InitChrome()
	{
		if (this.chrome && (this.setting.browser = 0 || (this.chrome.id = this.setting.browser && this.chrome.port = this.setting.chrome_debugging_port)))
		{
			return
		}
		if (this.setting.browser = 2)
		{
			this.chrome := new CMicrosoftEdge(this.setting.chrome_debugging_port)
		}
		else if (this.setting.browser = 3)
		{
			this.chrome := new CNaverWhale(this.setting.chrome_debugging_port)
		}
		else
		{
			this.chrome := new CChrome(this.setting.chrome_debugging_port)
		}
		if (this.setting.browser)
		{
			this.AppendLog("현재 선택된 브라우저는 " this.chrome.korname " 입니다")
			this.UpdateSB(this.chrome.korname, 1)
		}
	}
	InitIEEmulation()
	{
		if (!InStr(A_OSVersion, "WIN_") || SubStr(A_OSVersion, 5, 1) >= 7)
		{
            be := {"Default" : 0, "IE7" : 7000, "IE8" : 8000, "IE8STD" : 8888, "IE9" : 9000, "IE9STD" : 9999, "IE10" :10000, "IE10STD" : 10001, "IE11" : 11000, "IE11Edge" : 11001}
			emulation := be.IE11Edge
			RegRead, emul_current, HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION, AutoHotKey.exe
			if (emul_current != emulation)
			{
				RegWrite, REG_DWORD, HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION, AutoHotKey.exe, %emulation%
			}
		}
	}
	InitLog(iSel := 0)
	{
		this.tabLog.SetCurSel(iSel)
		if (!this.tabLog.IsWindowVisible())
		{
			this.tabLog.ShowWindow()
			this.UpdateMenus()
			this.Size()
		}
	}
	InitSizerSplitter()
	{
		return true
	}
	LoadIcon()
	{
		ico := this.name ".ico"
		if (InStr(A_ScriptName, ".exe") || !FileExist(ico))
		{
			return
		}
		hIcon := LoadPicture(ico, "Icon1 w32 h32", type)
		this.SendMessage(CWU.WM_SETICON, 0, hIcon)
	}
	LoadSetting()
	{
		this.setting_file := this.name ".setting.json"
		if (FileExist(this.setting_file))
		{
			FileRead, str, % this.setting_file
			setting := JSON.Load(str)
			for key, val in % setting
			{
				if (!IsObject(val) && RegExMatch("^\d+$", val))
				{
					val := val + 0
				}
				this.setting[key] := val
			}
			if (!this.setting.width || !this.setting.height)
			{
				this.setting.width := 900
				this.setting.height := 1000
			}
		}
	}
	ReleaseNote()
	{
		RegRead, ProductName , HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion, ProductName
		win10ver := this.GetWin10Version()
		if (win10ver > 0)
		{
			os := ProductName " 버전 " win10ver " (" A_OSVersion ")"
		}
		else
		{
			os := ProductName
		}
		this.AppendLog("운영체제 : " os ", 오토핫키 : " A_AhkVersion " " (A_IsUnicode ? "Unicode" : "Ansi") " " (A_PtrSize = 8 ? "64" : "32") "-bit" ", 자동입력기 : " this.version)
		if (A_Args.Length() > 1)
		{
			if (InStr(A_Args[1], "ahk_pid"))
			{
				this.InitLog()
				http := new CHttp()
				response := JSON.Load(http.Get("https://auto.ddart.net/download/" this.name "/note"))
				old := A_Args[4]
				note := response.note
				if (note)
				{
					if (old)
					{
						pos := InStr(note, "v" old)
						if (pos)
						{
							note := SubStr(note, pos)
						}
					}
					this.AppendLog(note)
				}
				if (InStr(A_Args[5], ".exe"))
				{
					;; 업데이트 전에 exe 파일로 이용중이었음
					this.OnMakeExe()
				}
			}
		}
	}
	RemoveErrorHandler()
	{
		OnError(this.fnOnError, 0)
		this.fnOnError := ""
	}
	RemoveHotkeyHandler()
	{
		for key in % this.hotkeys
		{
			HotKey, %key%, _RemoveHotkey
		}
		this.fnHotKey := ""
	}
	RemoveMessageHandlers()
	{
		for wm, fn in this.fn_wm_handler
		{
			OnMessage(wm, fn, 0)
			this.fn_wm_handler[wm] := ""
		}
	}
	RemoveTimers()
	{
		Loop, % this.fn_tm_handler.MaxIndex()
		{
			this.SetTimer(A_Index, "Delete")
			this.fn_tm_handler[A_Index] := ""
		}
	}
	ResetRunState()
	{
		this.bRunning := false
		this.bRunnable := true
		this.UpdateButtons()
	}
	SetTimer(name, option)
	{
		fn := this.fn_tm_handler[name]
		if (fn)
		{
			SetTimer, %fn%, %option%
		}
	}
	Size()
	{
		if (!this.w || !this.h)
		{
			this.w := this.setting.width
			this.h := this.setting.height
		}
		else
		{
			this.setting.width := this.w
			this.setting.height := this.h
		}
		this.toolbar.Size()
		pos := this.toolbar.GetPos()
		this.h_toolbar := pos.h
		spw := Floor(80 * this.m)
		this.statusbar.SetParts(this.w - 3 * spw, this.w - 2 * spw, this.w - spw, -1)
		this.statusbar.Size()
		pos := this.statusbar.GetPos()
		this.h_statusbar := pos.h
		this.h_client := this.h - this.h_toolbar - this.h_statusbar
		if (this.toolbar_pos = 0)
		{
			this.sizer.SetRect(new CRect(0, this.h_toolbar, this.w, this.h - this.h_statusbar))
		}
		else if (this.toolbar_pos = 1)
		{
			this.sizer.SetRect(new CRect(0, 0, this.w, this.h_client))
			this.toolbar.Move(0, this.h_client, this.w, this.h_toolbar)
		}
		if (!this.sizer.bInitSplitter)
		{
			this.sizer.bInitSplitter := this.InitSizerSplitter()
		}
		this.sizer.Size()
	}
	Run()
	{
		this.SetTimer(this.ID_TIMER_RUN, "Off")
		this.ResetRunState()
	}
	SaveSetting()
	{
		if (FileExist(this.setting_file))
		{
			FileDelete, % this.setting_file
		}
		rc := this.GetWindowRect()
		this.setting.left := rc.left
		this.setting.top := rc.top
		rc := this.GetClientRect()
		this.setting.width := rc.right - rc.left
		this.setting.height := rc.bottom - rc.top
		FileAppend, % JSON.Dump(this.setting), % this.setting_file, UTF-8
	}
	Show()
	{
		if (!this.setting.width || !this.setting.height)
		{
			this.setting.width := 900
			this.setting.height := 1000
		}
		this.w := this.setting.width
		this.h := this.setting.height
		pos := "w" Floor(this.w / this.m) " h" Floor(this.h / this.m)
		if (this.setting.HasKey("left"))
		{
			pos .= " x" Floor(this.setting.left / this.m)
		}
		if (this.setting.HasKey("top"))
		{
			pos .= " y" Floor(this.setting.top / this.m)
		}
		Gui, 1:Show, %pos%, % this.titletext
	}
	UpdateApplication()
	{
		this.InitLog()
		backup := "backup_v" this.version
		if (!FileExist(backup))
		{
			FileCreateDir, %backup%
		}
		if (RegExMatch(A_ScriptName, "O)(.+)\.(\w{3})", matches))
		{
			name := this.name
			ahk := A_ScriptDir "\" name ".ahk"
			zip := A_ScriptDir "\" name ".zip"
			dst := A_ScriptDir
			if (matches[1] = name)
			{
				FileMove, %name%.ahk, %backup%, true
				FileMove, %name%.exe, %backup%, true
			}
			try
			{
				UrlDownloadToFile, https://auto.ddart.net/download/%name%/current, %zip%
			}
			catch e
			{
				this.AppendLog(e.Message)
			}
			if (FileExist(zip))
			{
				this.AppendLog(zip)
				MsgBox, 4, 업데이트 확인, 업데이트 완료되었습니다. 업데이트반영을 위해 지금 재실행하시겠습니까? , 10
				IfMsgBox, Yes
				{
					obj := ComObjCreate("Shell.Application")
					obj.Namespace(dst).CopyHere(obj.Namespace(zip).items, 4|16)
					ObjRelease(obj)
					FileDelete, %zip%
					this.cmd_exit := ahk " ahk_pid " this.GetPID() " version " this.version " " A_ScriptName
					this.OnFileExit()
				}			
			}
			else
			{
				this.AppendLog("업데이트 다운로드 실패")
			}
		}
	}
	UpdateButtons()
	{
		this.EnableButton(this.menu.tool, this.ID_TOOL_EXECUTE, !this.bRunning && this.bRunnable)
		this.EnableButton(this.menu.tool, this.ID_TOOL_STOP, this.bRunning && this.bRunnable)
	}
	UpdateMenus()
	{
	}
	UpdateSB(msg, iPart := 0)
	{
		this.statusbar.SetText(iPart, msg)
	}
	OnChromeLaunch()
	{
		this.chrome.Launch()
	}
	OnClose()
	{
		this.SaveSetting()
		return false
	}
	OnCommand(wParam, lParam, nMsg, hWnd)
	{
		id := wParam & 0xFFFF
		notification_code := wParam >> 16
		if (id = this.ID_FILE_EXIT)
		{
			this.OnFileExit()
		}
		else if (id = this.ID_TOOL_EXECUTE)
		{
			this.OnExecute()
		}
		else if (id = this.ID_TOOL_STOP)
		{
			this.OnStop()
		}
		else if (id = this.ID_TOOL_CHROMELAUNCH)
		{
			this.OnChromeLaunch()
		}
		else if (id = this.ID_HELP_HELP)
		{
			this.OnHelp()
		}
		else if (id = this.ID_HELP_UPDATE)
		{
			this.OnUpdateCheck()
		}
		else if (id = this.ID_FILE_MAKEEXE)
		{
			this.OnMakeExe()
		}
		else if (id = this.editLog.id)
		{
		}
		else
		{
		}
	}
	HandleMsgBox()
	{
		this.SetTimer(this.ID_TIMER_MSGBOX, "Off")
		pos := this.GetPos()
		wnd := new CWindow(this.WaitPopupWindow(500))
		if (wnd.Exist())
		{
			mbpos := wnd.GetPos()
			wnd.Move(pos.x + pos.w / 2 - mbpos.w/ 2, pos.y + pos.h / 2 - mbpos.h / 2)
		}
	}
	OnCommNotify(wParam, lParam, nMsg, hWnd)
	{
		if (wParam = 1027)
		{
			this.SetTimer(this.ID_TIMER_MSGBOX, -100)
		}
	}
	OnError(error)
	{
		msg := "오류발생 : " error.File " " error.Line "번째줄`r`n"
		msg .= error.Extra " : " error.Message
		this.AppendLog(msg)
		MsgBox, %msg%
		this.ResetRunState()
		return true
	}
	OnExecute(id := 0)
	{
		if (this.bRunnable && !this.bRunning)
		{
			this.idRun := id
			this.bRunning := true
			this.UpdateButtons()
			this.SetTimer(this.ID_TIMER_RUN, -10)
		}		
	}
	OnFileExit()
	{
		this.PostMessage(CWU.WM_SYSCOMMAND, 0xF060, 0)
	}
	OnHelp()
	{
		Run, https://auto.ddart.net/xe/help
	}
	OnHotKey()
	{
		cmd := this.hotkeys[A_ThisHotkey]
		if (cmd)
		{
			this.PostMessage(CWU.WM_COMMAND, cmd, 0)
		}
	}
	OnKeyDown(wParam, lParam, nMsg, hWnd)
	{
		if (this.dlgAx && hWnd = this.dlgAx.hWndIE && this.dlgAx.iaxie.pi)
		{
			; AxIE에 일부 키 전달안되는 문제. TAB=9, ENTER=13, DELETE=46
			if (wParam = 9 || wParam = 13 || wParam = 46)
			{
				VarSetCapacity(msg, 7*A_PtrSize)
				for i,val in [hWnd, nMsg, wParam, lParam, A_EventInfo, A_GuiX, A_GuiY]
					NumPut(val, msg, (i-1)*A_PtrSize)
				this.dlgAx.iaxie.TranslateAccelerator(&msg)
				; 메세지 루프탈출
				return 0 
			}
		}
	}
	OnLButtonDown(wParam, lParam, nMsg, hWnd)
	{
		if (hWnd != this.hWnd)
		{
			return
		}
		x := (lParam & 0xFFFF) << 48 >> 48
		y := lParam >> 16
		this.cur_sizer := this.sizer.HitTest(x, y)
		if (this.cur_sizer)
		{
			this.SetCapture()
			this.nSplitterPos := -1
		}
	}
	OnLButtonUp(wParam, lParam, nMsg, hWnd)
	{
		if (hWnd != this.hWnd)
		{
			return
		}
		if (this.cur_sizer && this.nSplitterPos >= 0)
		{
			this.ReleaseCapture()
			this.DrawFocusRect(-1)
			this.cur_sizer.SetCurSplitterPos(this.nSplitterPos)
			this.nSplitterPos := -1
			this.cur_sizer := 0
			this.Size()
		}
	}
	OnLoad()
	{
		this.ReleaseNote()
		this.UpdateSB("프로그램이 시작되었습니다")
	}
	DrawFocusRect(pos)
	{
		hdc := DllCall("GetDC", "ptr", this.hWnd, "ptr")
		VarSetCapacity(rc, 4 * 4, 0)
		if (this.nSplitterPos >= 0)
		{
			rc_f := this.cur_sizer.GetFocusRect(this.nSplitterPos)
			NumPut(rc_f.left, rc, 0, "Int")
			NumPut(rc_f.top, rc, 4, "Int")
			NumPut(rc_f.right, rc, 8, "Int")
			NumPut(rc_f.bottom, rc, 12, "Int")
			DllCall("DrawFocusRect", "ptr", hdc, "ptr", &rc)
		}
		if (pos >= 0)
		{
			rc_f := this.cur_sizer.GetFocusRect(pos)
			NumPut(rc_f.left, rc, 0, "Int")
			NumPut(rc_f.top, rc, 4, "Int")
			NumPut(rc_f.right, rc, 8, "Int")
			NumPut(rc_f.bottom, rc, 12, "Int")
			DllCall("DrawFocusRect", "ptr", hdc, "ptr", &rc)
		}
		DllCall("ReleaseDC", "ptr", this.hWnd, "ptr", hdc)
	}
	OnMouseMove(wParam, lParam, nMsg, hWnd)
	{
		static bSetCursor := false
		if (hWnd != this.hWnd)
		{
			return
		}
		x := (lParam & 0xFFFF) << 48 >> 48
		y := lParam >> 16
		if (this.cur_sizer)
		{
			pos := this.cur_sizer.GetCurSplitterPos(x, y)
			this.DrawFocusRect(pos)
			this.nSplitterPos := pos
		}
		else if (ret := this.sizer.HitTest(x, y))
		{
			DllCall("SetCursor", "ptr", ret.bVertical ? this.hCursorNS : this.hCursorWE)
			bSetCursor := true
		}
		else if (bSetCursor)
		{
			DllCall("SetCursor", "ptr", this.hCursorArrow)
			bSetCursor := false
		}
	}
	OnMakeExe()
	{
		file := A_ScriptDir "\" this.name ".exe"
		ico := A_ScriptDir "\" this.name ".ico"
		compiler := StrReplace(A_AhkPath, "AutoHotkey.exe") "Compiler\Ahk2Exe.exe"
		this.InitLog()
		if (InStr(A_ScriptName, ".exe"))
		{
			this.AppendLog("이미 실행파일로 실행되었습니다.")
			return
		}
		if (!FileExist(compiler))
		{
			this.AppendLog(compiler "를 찾을수 없습니다")
			return 
		}
		if (FileExist(file))
		{
			FileDelete, %file%
			this.AppendLog("기존 " file " 를 지웁니다")
		}
		icon_option := ""
		if (FileExist(ico))
		{
			icon_option = /icon "%ico%"
		}
		RunWait, "%compiler%" /in "%A_ScriptDir%\%A_ScriptName%" /out  "%file%" %icon_option%
		if (FileExist("bin\rcedit.exe"))
		{
			file_version := this.file_version
			RunWait, %A_ScriptDir%\bin\rcedit.exe %file% --set-file-version %file_version%
			cmd = %A_ScriptDir%\bin\rcedit.exe %file% --set-file-version %file_version%
			this.AppendLog(cmd)
		}
		this.AppendLog(file " 가 생성되었습니다")
	}
	OnNotify(wParam, lParam, nMsg, hWnd)
	{
		id := NumGet(lParam + 0, 1 * A_PtrSize, "UPtr")
		if (id = this.tabLog.id)
		{
			code := NumGet(lParam+0, 2 * A_PtrSize, "Int")
			if (code = CTabCtrl.TCN_SELCHANGE)
			{
			}
		}
	}
	OnSettingChanged(wParam, lParam, nMsg, hWnd)
	{
	}
	OnSize(wParam, lParam, nMsg, hWnd)
	{
		if (hWnd = this.hwnd)
		{
			w := lParam & 0xFFFF
			h := lParam >> 16
			this.w := w
			this.h := h
			this.Size()
		}
	}
	OnStop()
	{
		if (this.bRunning && this.bRunnable)
		{
			this.bRunnable := false
			this.UpdateButtons()
		}
	}	
	OnSysCommand(wParam, lParam, nMsg, hWnd)
	{
		if (wParam = CWU.SC_CLOSE)
		{
			if (hWnd = this.hwnd)
			{
				if (this.OnClose())
				{
					return true
				}
				this.RemoveMessageHandlers()
				this.RemoveTimers()
				this.RemoveHotkeyHandler()
				this.RemoveErrorHandler()
				if (this.cmd_exit)
				{
					cmd := this.cmd_exit
					Run, %cmd%
				}
				this := ""
				ExitApp
			}
		}
	}
	OnUpdateCheck(bUser := true)
	{
		timestamp := A_Now
		timestamp -= 19700101000000, seconds
		name := this.name
		if (bUser)
		{
			this.InitLog()
		}
		else
		{
			RegRead, DisableAutoUpdate , HKEY_CURRENT_USER\Software\DDART\%name%, DisableAutoUpdate
			if (DisableAutoUpdate)
			{
				return
			}
			RegRead, LastUpdate , HKEY_CURRENT_USER\Software\DDART\%name%, LastUpdate
			if (LastUpdate && timestamp - LastUpdate < 12 * 60 * 60)
			{
				return 
			}
		}
		http := new CHttp()
		response := JSON.Load(http.Get("https://auto.ddart.net/download/" name "/version"))
		version := response.version
		RegWrite, REG_DWORD, HKEY_CURRENT_USER\Software\DDART\%name%, LastUpdate, %timestamp%
		if (this.version = version)
		{
			this.AppendLog("현재 " this.version " 버전은 최신버전입니다")
		}
		else if (this.version < version)
		{
			MsgBox, 4, 업데이트확인, 새로운 버전(%version%) 이 있습니다. 다운받으시겠습니까?, 10
			IfMsgBox, Yes
			{
				RegWrite, REG_DWORD , HKEY_CURRENT_USER\Software\DDART\%name%, DisableAutoUpdate, 0
				this.UpdateApplication()
			}
			else if (!bUser)
			{
				RegWrite, REG_DWORD , HKEY_CURRENT_USER\Software\DDART\%name%, DisableAutoUpdate, 1
			}
		}
		else if (!version)
		{
			this.AppendLog("현재 서버문제로 최신버전 확인을 할수가 없습니다")
		}
		else
		{
			this.AppendLog("개발자?")
		}
	}
	OnWebSocketDisconnected()
	{
	}
}
_RemoveHotkey()
{
	; 아무것도 안함. Hotkey 에 등록된 binded function object 삭제를 위한 것
}
class CWU
{
	static WM_NULL := 0x0000
	static WM_CREATE := 0x0001
	static WM_DESTROY := 0x0002
	static WM_MOVE := 0x0003
	static WM_SIZE := 0x0005
	static WM_ACTIVATE := 0x0006
	static WM_SETFOCUS := 0x0007
	static WM_KILLFOCUS := 0x0008
	static WM_ENABLE := 0x000A
	static WM_SETREDRAW := 0x000B
	static WM_SETTEXT := 0x000C
	static WM_GETTEXT := 0x000D
	static WM_GETTEXTLENGTH := 0x000E
	static WM_PAINT := 0x000F
	static WM_CLOSE := 0x0010
	static WM_QUERYENDSESSION := 0x0011
	static WM_QUIT := 0x0012
	static WM_QUERYOPEN := 0x0013
	static WM_ERASEBKGND := 0x0014
	static WM_SYSCOLORCHANGE := 0x0015
	static WM_ENDSESSION := 0x0016
	static WM_SHOWWINDOW := 0x0018
	static WM_WININICHANGE := 0x001A
	static WM_SETTINGCHANGE := 0x001A
	static WM_DEVMODECHANGE := 0x001B
	static WM_ACTIVATEAPP := 0x001C
	static WM_FONTCHANGE := 0x001D
	static WM_TIMECHANGE := 0x001E
	static WM_CANCELMODE := 0x001F
	static WM_SETCURSOR := 0x0020
	static WM_MOUSEACTIVATE := 0x0021
	static WM_CHILDACTIVATE := 0x0022
	static WM_QUEUESYNC := 0x0023
	static WM_GETMINMAXINFO := 0x0024
	static WM_PAINTICON := 0x0026
	static WM_ICONERASEBKGND := 0x0027
	static WM_NEXTDLGCTL := 0x0028
	static WM_SPOOLERSTATUS := 0x002A
	static WM_DRAWITEM := 0x002B
	static WM_MEASUREITEM := 0x002C
	static WM_DELETEITEM := 0x002D
	static WM_VKEYTOITEM := 0x002E
	static WM_CHARTOITEM := 0x002F
	static WM_SETFONT := 0x0030
	static WM_GETFONT := 0x0031
	static WM_SETHOTKEY := 0x0032
	static WM_GETHOTKEY := 0x0033
	static WM_QUERYDRAGICON := 0x0037
	static WM_COMPAREITEM := 0x0039
	static WM_GETOBJECT := 0x003D
	static WM_COMPACTING := 0x0041
	static WM_COMMNOTIFY := 0x0044
	static WM_WINDOWPOSCHANGING := 0x0046
	static WM_WINDOWPOSCHANGED := 0x0047
	static WM_POWER := 0x0048
	static WM_COPYDATA := 0x004A
	static WM_CANCELJOURNAL := 0x004B
	static WM_NOTIFY := 0x004E
	static WM_INPUTLANGCHANGEREQUEST := 0x0050
	static WM_INPUTLANGCHANGE := 0x0051
	static WM_TCARD := 0x0052
	static WM_HELP := 0x0053
	static WM_USERCHANGED := 0x0054
	static WM_NOTIFYFORMAT := 0x0055
	static WM_CONTEXTMENU := 0x007B
	static WM_STYLECHANGING := 0x007C
	static WM_STYLECHANGED := 0x007D
	static WM_DISPLAYCHANGE := 0x007E
	static WM_GETICON := 0x007F
	static WM_SETICON := 0x0080
	static WM_NCCREATE := 0x0081
	static WM_NCDESTROY := 0x0082
	static WM_NCCALCSIZE := 0x0083
	static WM_NCHITTEST := 0x0084
	static WM_NCPAINT := 0x0085
	static WM_NCACTIVATE := 0x0086
	static WM_GETDLGCODE := 0x0087
	static WM_SYNCPAINT := 0x0088
	static WM_NCMOUSEMOVE := 0x00A0
	static WM_NCLBUTTONDOWN := 0x00A1
	static WM_NCLBUTTONUP := 0x00A2
	static WM_NCLBUTTONDBLCLK := 0x00A3
	static WM_NCRBUTTONDOWN := 0x00A4
	static WM_NCRBUTTONUP := 0x00A5
	static WM_NCRBUTTONDBLCLK := 0x00A6
	static WM_NCMBUTTONDOWN := 0x00A7
	static WM_NCMBUTTONUP := 0x00A8
	static WM_NCMBUTTONDBLCLK := 0x00A9
	static WM_NCXBUTTONDOWN := 0x00AB
	static WM_NCXBUTTONUP := 0x00AC
	static WM_NCXBUTTONDBLCLK := 0x00AD
	static WM_INPUT_DEVICE_CHANGE := 0x00FE
	static WM_INPUT := 0x00FF
	static WM_KEYFIRST := 0x0100
	static WM_KEYDOWN := 0x0100
	static WM_KEYUP := 0x0101
	static WM_CHAR := 0x0102
	static WM_DEADCHAR := 0x0103
	static WM_SYSKEYDOWN := 0x0104
	static WM_SYSKEYUP := 0x0105
	static WM_SYSCHAR := 0x0106
	static WM_SYSDEADCHAR := 0x0107
	static WM_UNICHAR := 0x0109
	static WM_KEYLAST := 0x0109
	static WM_IME_STARTCOMPOSITION := 0x010D
	static WM_IME_ENDCOMPOSITION := 0x010E
	static WM_IME_COMPOSITION := 0x010F
	static WM_IME_KEYLAST := 0x010F
	static WM_INITDIALOG := 0x0110
	static WM_COMMAND := 0x0111
	static WM_SYSCOMMAND := 0x0112
	static WM_TIMER := 0x0113
	static WM_HSCROLL := 0x0114
	static WM_VSCROLL := 0x0115
	static WM_INITMENU := 0x0116
	static WM_INITMENUPOPUP := 0x0117
	static WM_GESTURE := 0x0119
	static WM_GESTURENOTIFY := 0x011A
	static WM_MENUSELECT := 0x011F
	static WM_MENUCHAR := 0x0120
	static WM_ENTERIDLE := 0x0121
	static WM_MENURBUTTONUP := 0x0122
	static WM_MENUDRAG := 0x0123
	static WM_MENUGETOBJECT := 0x0124
	static WM_UNINITMENUPOPUP := 0x0125
	static WM_MENUCOMMAND := 0x0126
	static WM_CHANGEUISTATE := 0x0127
	static WM_UPDATEUISTATE := 0x0128
	static WM_QUERYUISTATE := 0x0129
	static WM_CTLCOLORMSGBOX := 0x0132
	static WM_CTLCOLOREDIT := 0x0133
	static WM_CTLCOLORLISTBOX := 0x0134
	static WM_CTLCOLORBTN := 0x0135
	static WM_CTLCOLORDLG := 0x0136
	static WM_CTLCOLORSCROLLBAR := 0x0137
	static WM_CTLCOLORSTATIC := 0x0138
	static MN_GETHMENU := 0x01E1
	static WM_MOUSEFIRST := 0x0200
	static WM_MOUSEMOVE := 0x0200
	static WM_LBUTTONDOWN := 0x0201
	static WM_LBUTTONUP := 0x0202
	static WM_LBUTTONDBLCLK := 0x0203
	static WM_RBUTTONDOWN := 0x0204
	static WM_RBUTTONUP := 0x0205
	static WM_RBUTTONDBLCLK := 0x0206
	static WM_MBUTTONDOWN := 0x0207
	static WM_MBUTTONUP := 0x0208
	static WM_MBUTTONDBLCLK := 0x0209
	static WM_MOUSEWHEEL := 0x020A
	static WM_XBUTTONDOWN := 0x020B
	static WM_XBUTTONUP := 0x020C
	static WM_XBUTTONDBLCLK := 0x020D
	static WM_MOUSEHWHEEL := 0x020E
	static WM_PARENTNOTIFY := 0x0210
	static WM_ENTERMENULOOP := 0x0211
	static WM_EXITMENULOOP := 0x0212
	static WM_NEXTMENU := 0x0213
	static WM_SIZING := 0x0214
	static WM_CAPTURECHANGED := 0x0215
	static WM_MOVING := 0x0216
	static WM_POWERBROADCAST := 0x0218
	static WM_DEVICECHANGE := 0x0219
	static WM_MDICREATE := 0x0220
	static WM_MDIDESTROY := 0x0221
	static WM_MDIACTIVATE := 0x0222
	static WM_MDIRESTORE := 0x0223
	static WM_MDINEXT := 0x0224
	static WM_MDIMAXIMIZE := 0x0225
	static WM_MDITILE := 0x0226
	static WM_MDICASCADE := 0x0227
	static WM_MDIICONARRANGE := 0x0228
	static WM_MDIGETACTIVE := 0x0229
	static WM_MDISETMENU := 0x0230
	static WM_ENTERSIZEMOVE := 0x0231
	static WM_EXITSIZEMOVE := 0x0232
	static WM_DROPFILES := 0x0233
	static WM_MDIREFRESHMENU := 0x0234
	static WM_POINTERDEVICECHANGE := 0x238
	static WM_POINTERDEVICEINRANGE := 0x239
	static WM_POINTERDEVICEOUTOFRANGE := 0x23A
	static WM_TOUCH := 0x0240
	static WM_NCPOINTERUPDATE := 0x0241
	static WM_NCPOINTERDOWN := 0x0242
	static WM_NCPOINTERUP := 0x0243
	static WM_POINTERUPDATE := 0x0245
	static WM_POINTERDOWN := 0x0246
	static WM_POINTERUP := 0x0247
	static WM_POINTERENTER := 0x0249
	static WM_POINTERLEAVE := 0x024A
	static WM_POINTERACTIVATE := 0x024B
	static WM_POINTERCAPTURECHANGED := 0x024C
	static WM_TOUCHHITTESTING := 0x024D
	static WM_POINTERWHEEL := 0x024E
	static WM_POINTERHWHEEL := 0x024F
	static DM_POINTERHITTEST := 0x0250
	static WM_POINTERROUTEDTO := 0x0251
	static WM_POINTERROUTEDAWAY := 0x0252
	static WM_POINTERROUTEDRELEASED := 0x0253
	static WM_IME_SETCONTEXT := 0x0281
	static WM_IME_NOTIFY := 0x0282
	static WM_IME_CONTROL := 0x0283
	static WM_IME_COMPOSITIONFULL := 0x0284
	static WM_IME_SELECT := 0x0285
	static WM_IME_CHAR := 0x0286
	static WM_IME_REQUEST := 0x0288
	static WM_IME_KEYDOWN := 0x0290
	static WM_IME_KEYUP := 0x0291
	static WM_MOUSEHOVER := 0x02A1
	static WM_MOUSELEAVE := 0x02A3
	static WM_NCMOUSEHOVER := 0x02A0
	static WM_NCMOUSELEAVE := 0x02A2
	static WM_WTSSESSION_CHANGE := 0x02B1
	static WM_TABLET_FIRST := 0x02c0
	static WM_TABLET_LAST := 0x02df
	static WM_DPICHANGED := 0x02E0
	static WM_DPICHANGED_BEFOREPARENT := 0x02E2
	static WM_DPICHANGED_AFTERPARENT := 0x02E3
	static WM_GETDPISCALEDSIZE := 0x02E4
	static WM_CUT := 0x0300
	static WM_COPY := 0x0301
	static WM_PASTE := 0x0302
	static WM_CLEAR := 0x0303
	static WM_UNDO := 0x0304
	static WM_RENDERFORMAT := 0x0305
	static WM_RENDERALLFORMATS := 0x0306
	static WM_DESTROYCLIPBOARD := 0x0307
	static WM_DRAWCLIPBOARD := 0x0308
	static WM_PAINTCLIPBOARD := 0x0309
	static WM_VSCROLLCLIPBOARD := 0x030A
	static WM_SIZECLIPBOARD := 0x030B
	static WM_ASKCBFORMATNAME := 0x030C
	static WM_CHANGECBCHAIN := 0x030D
	static WM_HSCROLLCLIPBOARD := 0x030E
	static WM_QUERYNEWPALETTE := 0x030F
	static WM_PALETTEISCHANGING := 0x0310
	static WM_PALETTECHANGED := 0x0311
	static WM_HOTKEY := 0x0312
	static WM_PRINT := 0x0317
	static WM_PRINTCLIENT := 0x0318
	static WM_APPCOMMAND := 0x0319
	static WM_THEMECHANGED := 0x031A
	static WM_CLIPBOARDUPDATE := 0x031D
	static WM_DWMCOMPOSITIONCHANGED := 0x031E
	static WM_DWMNCRENDERINGCHANGED := 0x031F
	static WM_DWMCOLORIZATIONCOLORCHANGED := 0x0320
	static WM_DWMWINDOWMAXIMIZEDCHANGE := 0x0321
	static WM_DWMSENDICONICTHUMBNAIL := 0x0323
	static WM_DWMSENDICONICLIVEPREVIEWBITMAP := 0x0326
	static WM_GETTITLEBARINFOEX := 0x033F
	static WM_HANDHELDFIRST := 0x0358
	static WM_HANDHELDLAST := 0x035F
	static WM_AFXFIRST := 0x0360
	static WM_AFXLAST := 0x037F
	static WM_PENWINFIRST := 0x0380
	static WM_PENWINLAST := 0x038F
	static WM_APP := 0x8000
	static WM_USER := 0x0400

	static WS_OVERLAPPED := 0x00000000
	static WS_POPUP := 0x80000000
	static WS_CHILD := 0x40000000
	static WS_MINIMIZE := 0x20000000
	static WS_VISIBLE := 0x10000000
	static WS_DISABLED := 0x08000000
	static WS_CLIPSIBLINGS := 0x04000000
	static WS_CLIPCHILDREN := 0x02000000
	static WS_MAXIMIZE := 0x01000000
	static WS_CAPTION := 0x00C00000
	static WS_BORDER := 0x00800000
	static WS_DLGFRAME := 0x00400000
	static WS_VSCROLL := 0x00200000
	static WS_HSCROLL := 0x00100000
	static WS_SYSMENU := 0x00080000
	static WS_THICKFRAME := 0x00040000
	static WS_GROUP := 0x00020000
	static WS_TABSTOP := 0x00010000
	static WS_MINIMIZEBOX := 0x00020000
	static WS_MAXIMIZEBOX := 0x00010000
	static WS_TILED := CWU.WS_OVERLAPPED
	static WS_ICONIC := CWU.WS_MINIMIZE
	static WS_SIZEBOX := CWU.WS_THICKFRAME
	static WS_OVERLAPPEDWINDOW := CWU.WS_OVERLAPPED |  CWU.WS_CAPTION | CWU.WS_SYSMENU |  CWU.WS_THICKFRAME | CWU.WS_MINIMIZEBOX | CWU.WS_MAXIMIZEBOX
	static WS_POPUPWINDOW := (CWU.WS_POPUP | CWU.WS_BORDER | CWU.WS_SYSMENU)
	static WS_CHILDWINDOW := CWU.WS_CHILD
	static WS_TILEDWINDOW := CWU.WS_OVERLAPPEDWINDOW
	static WS_EX_DLGMODALFRAME := 0x00000001
	static WS_EX_NOPARENTNOTIFY := 0x00000004
	static WS_EX_TOPMOST := 0x00000008
	static WS_EX_ACCEPTFILES := 0x00000010
	static WS_EX_TRANSPARENT := 0x00000020
	static WS_EX_MDICHILD := 0x00000040
	static WS_EX_TOOLWINDOW := 0x00000080
	static WS_EX_WINDOWEDGE := 0x00000100
	static WS_EX_CLIENTEDGE := 0x00000200
	static WS_EX_CONTEXTHELP := 0x00000400
	static WS_EX_RIGHT := 0x00001000
	static WS_EX_LEFT := 0x00000000
	static WS_EX_RTLREADING := 0x00002000
	static WS_EX_LTRREADING := 0x00000000
	static WS_EX_LEFTSCROLLBAR := 0x00004000
	static WS_EX_RIGHTSCROLLBAR := 0x00000000
	static WS_EX_CONTROLPARENT := 0x00010000
	static WS_EX_STATICEDGE := 0x00020000
	static WS_EX_APPWINDOW := 0x00040000
	static WS_EX_OVERLAPPEDWINDOW := (CWU.WS_EX_WINDOWEDGE | CWU.WS_EX_CLIENTEDGE)
	static WS_EX_PALETTEWINDOW := (CWU.WS_EX_WINDOWEDGE | CWU.WS_EX_TOOLWINDOW | CWU.WS_EX_TOPMOST)
	static WS_EX_LAYERED := 0x00080000
	static WS_EX_NOINHERITLAYOUT := 0x00100000
	static WS_EX_NOREDIRECTIONBITMAP := 0x00200000
	static WS_EX_LAYOUTRTL := 0x00400000
	static WS_EX_COMPOSITED := 0x02000000
	static WS_EX_NOACTIVATE := 0x08000000
	
	static CW_USEDEFAULT := 0x80000000
	
	static CTLCOLOR_MSGBOX := 0
	static CTLCOLOR_EDIT := 1
	static CTLCOLOR_LISTBOX := 2
	static CTLCOLOR_BTN := 3
	static CTLCOLOR_DLG := 4
	static CTLCOLOR_SCROLLBAR := 5
	static CTLCOLOR_STATIC := 6
	static CTLCOLOR_MAX := 7
	static COLOR_SCROLLBAR := 0
	static COLOR_BACKGROUND := 1
	static COLOR_ACTIVECAPTION := 2
	static COLOR_INACTIVECAPTION := 3
	static COLOR_MENU := 4
	static COLOR_WINDOW := 5
	static COLOR_WINDOWFRAME := 6
	static COLOR_MENUTEXT := 7
	static COLOR_WINDOWTEXT := 8
	static COLOR_CAPTIONTEXT := 9
	static COLOR_ACTIVEBORDER := 10
	static COLOR_INACTIVEBORDER := 11
	static COLOR_APPWORKSPACE := 12
	static COLOR_HIGHLIGHT := 13
	static COLOR_HIGHLIGHTTEXT := 14
	static COLOR_BTNFACE := 15
	static COLOR_BTNSHADOW := 16
	static COLOR_GRAYTEXT := 17
	static COLOR_BTNTEXT := 18
	static COLOR_INACTIVECAPTIONTEXT := 19
	static COLOR_BTNHIGHLIGHT := 20
	static COLOR_3DDKSHADOW := 21
	static COLOR_3DLIGHT := 22
	static COLOR_INFOTEXT := 23
	static COLOR_INFOBK := 24
	static COLOR_HOTLIGHT := 26
	static COLOR_GRADIENTACTIVECAPTION := 27
	static COLOR_GRADIENTINACTIVECAPTION := 28
	static COLOR_MENUHILIGHT := 29
	static COLOR_MENUBAR := 30
	static COLOR_DESKTOP := CWU.COLOR_BACKGROUND
	static COLOR_3DFACE := CWU.COLOR_BTNFACE
	static COLOR_3DSHADOW := CWU.COLOR_BTNSHADOW
	static COLOR_3DHIGHLIGHT := CWU.COLOR_BTNHIGHLIGHT
	static COLOR_3DHILIGHT := CWU.COLOR_BTNHIGHLIGHT
	static COLOR_BTNHILIGHT := CWU.COLOR_BTNHIGHLIGHT	
	
	static RT_CURSOR := 1
	static RT_BITMAP := 2
	static RT_ICON := 3
	static RT_MENU := 4
	static RT_DIALOG := 5
	static RT_STRING := 6
	static RT_FONTDIR := 7
	static RT_FONT := 8
	static RT_ACCELERATOR := 9
	static RT_RCDATA := 10
	static RT_MESSAGETABLE := 11
	static DIFFERENCE := 11
	static RT_GROUP_CURSOR := (CWU.RT_CURSOR + CWU.DIFFERENCE)
	static RT_GROUP_ICON := (CWU.RT_ICON + CWU.DIFFERENCE)
	static RT_VERSION := 16
	static RT_DLGINCLUDE := 17
	static RT_PLUGPLAY := 19
	static RT_VXD := 20
	static RT_ANICURSOR := 21
	static RT_ANIICON := 22
	static RT_HTML := 23
	static RT_MANIFEST := 24
	static CREATEPROCESS_MANIFEST_RESOURCE_ID := 1
	static ISOLATIONAWARE_MANIFEST_RESOURCE_ID := 2
	static ISOLATIONAWARE_NOSTATICIMPORT_MANIFEST_RESOURCE_ID := 3
	static ISOLATIONPOLICY_MANIFEST_RESOURCE_ID := 4
	static ISOLATIONPOLICY_BROWSER_MANIFEST_RESOURCE_ID := 5
	static MINIMUM_RESERVED_MANIFEST_RESOURCE_ID := 1
	static MAXIMUM_RESERVED_MANIFEST_RESOURCE_ID := 16
	static SWP_NOSIZE := 0x0001
	static SWP_NOMOVE := 0x0002
	static SWP_NOZORDER := 0x0004
	static SWP_NOREDRAW := 0x0008
	static SWP_NOACTIVATE := 0x0010
	static SWP_FRAMECHANGED := 0x0020
	static SWP_SHOWWINDOW := 0x0040
	static SWP_HIDEWINDOW := 0x0080
	static SWP_NOCOPYBITS := 0x0100
	static SWP_NOOWNERZORDER := 0x0200
	static SWP_NOSENDCHANGING := 0x0400
	static SWP_DRAWFRAME := CWU.SWP_FRAMECHANGED
	static SWP_NOREPOSITION := CWU.SWP_NOOWNERZORDER
	static SWP_DEFERERASE := 0x2000
	static SWP_ASYNCWINDOWPOS := 0x4000
	static HWND_TOP := 0
	static HWND_BOTTOM := 1
	static HWND_TOPMOST := -1
	static HWND_NOTOPMOST := -2
	
	static IMAGE_BITMAP := 0
	static IMAGE_ICON := 1
	static IMAGE_CURSOR := 2
	static IMAGE_ENHMETAFILE := 3
	static LR_DEFAULTCOLOR := 0x00000000
	static LR_MONOCHROME := 0x00000001
	static LR_COLOR := 0x00000002
	static LR_COPYRETURNORG := 0x00000004
	static LR_COPYDELETEORG := 0x00000008
	static LR_LOADFROMFILE := 0x00000010
	static LR_LOADTRANSPARENT := 0x00000020
	static LR_DEFAULTSIZE := 0x00000040
	static LR_VGACOLOR := 0x00000080
	static LR_LOADMAP3DCOLORS := 0x00001000
	static LR_CREATEDIBSECTION := 0x00002000
	static LR_COPYFROMRESOURCE := 0x00004000
	static LR_SHARED := 0x00008000
	
	static GW_HWNDFIRST := 0
	static GW_HWNDLAST := 1
	static GW_HWNDNEXT := 2
	static GW_HWNDPREV := 3
	static GW_OWNER := 4
	static GW_CHILD := 5
	static GW_ENABLEDPOPUP := 6
	static GW_MAX := 6	
	static GWL_WNDPROC := (-4)
	static GWL_HINSTANCE := (-6)
	static GWL_HWNDPARENT := (-8)
	static GWL_STYLE := (-16)
	static GWL_EXSTYLE := (-20)
	static GWL_USERDATA := (-21)
	static GWL_ID := (-12)
	
	static SC_SIZE := 0xF000
	static SC_MOVE := 0xF010
	static SC_MINIMIZE := 0xF020
	static SC_MAXIMIZE := 0xF030
	static SC_NEXTWINDOW := 0xF040
	static SC_PREVWINDOW := 0xF050
	static SC_CLOSE := 0xF060
	static SC_VSCROLL := 0xF070
	static SC_HSCROLL := 0xF080
	static SC_MOUSEMENU := 0xF090
	static SC_KEYMENU := 0xF100
	static SC_ARRANGE := 0xF110
	static SC_RESTORE := 0xF120
	static SC_TASKLIST := 0xF130
	static SC_SCREENSAVE := 0xF140
	static SC_HOTKEY := 0xF150
	static SC_DEFAULT := 0xF160
	static SC_MONITORPOWER := 0xF170
	static SC_CONTEXTHELP := 0xF180
	static SC_SEPARATOR := 0xF00F
	static SM_CXSCREEN := 0
	static SM_CYSCREEN := 1
	static SM_CXVSCROLL := 2
	static SM_CYHSCROLL := 3
	static SM_CYCAPTION := 4
	static SM_CXBORDER := 5
	static SM_CYBORDER := 6
	static SM_CXDLGFRAME := 7
	static SM_CYDLGFRAME := 8
	static SM_CYVTHUMB := 9
	static SM_CXHTHUMB := 10
	static SM_CXICON := 11
	static SM_CYICON := 12
	static SM_CXCURSOR := 13
	static SM_CYCURSOR := 14
	static SM_CYMENU := 15
	static SM_CXFULLSCREEN := 16
	static SM_CYFULLSCREEN := 17
	static SM_CYKANJIWINDOW := 18
	static SM_MOUSEPRESENT := 19
	static SM_CYVSCROLL := 20
	static SM_CXHSCROLL := 21
	static SM_DEBUG := 22
	static SM_SWAPBUTTON := 23
	static SM_RESERVED1 := 24
	static SM_RESERVED2 := 25
	static SM_RESERVED3 := 26
	static SM_RESERVED4 := 27
	static SM_CXMIN := 28
	static SM_CYMIN := 29
	static SM_CXSIZE := 30
	static SM_CYSIZE := 31
	static SM_CXFRAME := 32
	static SM_CYFRAME := 33
	static SM_CXMINTRACK := 34
	static SM_CYMINTRACK := 35
	static SM_CXDOUBLECLK := 36
	static SM_CYDOUBLECLK := 37
	static SM_CXICONSPACING := 38
	static SM_CYICONSPACING := 39
	static SM_MENUDROPALIGNMENT := 40
	static SM_PENWINDOWS := 41
	static SM_DBCSENABLED := 42
	static SM_CMOUSEBUTTONS := 43
	static SM_CXFIXEDFRAME := CWU.SM_CXDLGFRAME
	static SM_CYFIXEDFRAME := CWU.SM_CYDLGFRAME
	static SM_CXSIZEFRAME := CWU.SM_CXFRAME
	static SM_CYSIZEFRAME := CWU.SM_CYFRAME
	static SM_SECURE := 44
	static SM_CXEDGE := 45
	static SM_CYEDGE := 46
	static SM_CXMINSPACING := 47
	static SM_CYMINSPACING := 48
	static SM_CXSMICON := 49
	static SM_CYSMICON := 50
	static SM_CYSMCAPTION := 51
	static SM_CXSMSIZE := 52
	static SM_CYSMSIZE := 53
	static SM_CXMENUSIZE := 54
	static SM_CYMENUSIZE := 55
	static SM_ARRANGE := 56
	static SM_CXMINIMIZED := 57
	static SM_CYMINIMIZED := 58
	static SM_CXMAXTRACK := 59
	static SM_CYMAXTRACK := 60
	static SM_CXMAXIMIZED := 61
	static SM_CYMAXIMIZED := 62
	static SM_NETWORK := 63
	static SM_CLEANBOOT := 67
	static SM_CXDRAG := 68
	static SM_CYDRAG := 69
	static SM_SHOWSOUNDS := 70
	static SM_CXMENUCHECK := 71
	static SM_CYMENUCHECK := 72
	static SM_SLOWMACHINE := 73
	static SM_MIDEASTENABLED := 74
	static SM_MOUSEWHEELPRESENT := 75
	static SM_XVIRTUALSCREEN := 76
	static SM_YVIRTUALSCREEN := 77
	static SM_CXVIRTUALSCREEN := 78
	static SM_CYVIRTUALSCREEN := 79
	static SM_CMONITORS := 80
	static SM_SAMEDISPLAYFORMAT := 81
	static SM_IMMENABLED := 82
	static SM_CXFOCUSBORDER := 83
	static SM_CYFOCUSBORDER := 84
	static SM_TABLETPC := 86
	static SM_MEDIACENTER := 87
	static SM_STARTER := 88
	static SM_SERVERR2 := 89
	static SM_MOUSEHORIZONTALWHEELPRESENT := 91
	static SM_CXPADDEDBORDER := 92
	static SM_DIGITIZER := 94
	static SM_MAXIMUMTOUCHES := 95
	static SM_CMETRICS := 97
	static SM_REMOTESESSION := 0x1000
	static SM_SHUTTINGDOWN := 0x2000
	static SM_REMOTECONTROL := 0x2001
	static SM_CARETBLINKINGENABLED := 0x2002
	static SM_CONVERTIBLESLATEMODE := 0x2003
	static SM_SYSTEMDOCKED := 0x2004	
	static IDC_ARROW := 32512
	static IDC_IBEAM := 32513
	static IDC_WAIT := 32514
	static IDC_CROSS := 32515
	static IDC_UPARROW := 32516
	static IDC_SIZE := 32640
	static IDC_ICON := 32641
	static IDC_SIZENWSE := 32642
	static IDC_SIZENESW := 32643
	static IDC_SIZEWE := 32644
	static IDC_SIZENS := 32645
	static IDC_SIZEALL := 32646
	static IDC_NO := 32648
	static IDC_HAND := 32649
	static IDC_APPSTARTING := 32650
	static IDC_HELP := 32651
	static IDC_PIN := 32671
	static IDC_PERSON := 32672
	static MK_LBUTTON := 0x0001
	static MK_RBUTTON := 0x0002
	static MK_SHIFT := 0x0004
	static MK_CONTROL := 0x0008
	static MK_MBUTTON := 0x0010
	static MK_XBUTTON1 := 0x0020
	static MK_XBUTTON2 := 0x0040
	
	GetSystemMetrics(nIndex)
	{
		return DllCall("GetSystemMetrics", "int", nIndex)
	}
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Windows & Controls
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CRect
{
	__New(l :=0 , t := 0, r := 0, b := 0)
	{
		this.left := l + 0
		this.top := t + 0
		this.right := r + 0
		this.bottom := b + 0
	}
}
class CPoint
{
	__New(x, y)
	{
		this.x := x + 0
		this.y := y + 0
	}
}
class CSize
{
	__New(w, h)
	{
		this.w := w + 0
		this.h := h + 0
	}
}
class CPosition
{
	__New(x, y, w, h)
	{
		this.x := x + 0
		this.y := y + 0
		this.w := w + 0
		this.h := h + 0
	}
}
class CSplitter
{
	__New()
	{
		this.split := Array(0, 0)
		this.min := 25
	}
	Add(pos := 0)
	{
		return this.split.InsertAt(this.split.MaxIndex(), pos)
	}
	Adjust(i, v)
	{
		if (v < this.split[i] + this.min)
		{
			return this.split[i] + this.min
		}
		else if (v > this.split[i + 2] - this.min)
		{
			return this.split[i + 2] - this.min
		}
		return v
	}
	Exist()
	{
		return this.split.Length() > 2
	}
	GetIndex(pos)
	{
		if (!this.Exist())
		{
			return 0
		}
		Loop, % this.split.Length() - 2
		{
			v := this.Get(A_Index)
			if (Abs(v - pos) <= 2)
			{
				return A_Index
			}
			else if (v > pos)
			{
				return 0
			}
		}
		return 0
	}
	Get(i)
	{
		return this.split[i + 1]
	}
	GetStart(i)
	{
		return this.split[i]
	}
	GetDistance(i)
	{
		return this.Get(i) - this.GetStart(i)
	}
	Set(i, v)
	{
		this.split[i + 1] := v
	}
	SetRange(min, max)
	{
		this.split[1] := min
		this.split[this.split.MaxIndex()] := max
		if (this.Exist())
		{
			Loop, % this.split.MaxIndex() - 2
			{
				this.Set(A_Index, this.Adjust(A_Index, this.Get(A_Index)))
			}
		}
	}
}
class CAutoSizer
{
	__New(bVertical := true, spacing := 0, min := 25)
	{
		this.bVertical := bVertical
		this.children := Array()
		this.splitter := new CSplitter(min)
		this.spacing := spacing
		this.rc := new CRect()
		this.nCurSplitter := 0
		this.bInitSplitter := false
	}
	Add(child)
	{
		if (this.children.Push(child) > 1)
		{
			this.splitter.Add()
		}
	}
	Count()
	{
		return this.children.Length()
	}
	GetCurSplitterPos(x, y)
	{
		pos := this.bVertical ? (y - this.rc.top) : (x - this.rc.left)
		return this.splitter.Adjust(this.nCurSplitter, pos)
	}
	GetChildPos(i)
	{
		if (this.bVertical)
		{
			return new CPosition(this.rc.left + this.spacing
			, this.rc.top + this.splitter.GetStart(i)+ this.spacing
			, this.rc.right - this.rc.left - 2 * this.spacing
			, this.splitter.GetDistance(i) - 2 * this.spacing)
		}
		else
		{
			return new CPosition(this.rc.left + this.splitter.GetStart(i)  + this.spacing
			, this.rc.top + this.spacing
			, this.splitter.GetDistance(i) - 2 * this.spacing
			, this.rc.bottom - this.rc.top - 2 * this.spacing)
		}
	}
	GetFocusRect(pos)
	{
		if (this.bVertical)
		{
			return new CRect(this.rc.left, this.rc.top + pos - 2, this.rc.right, this.rc.top + pos + 2)
		}
		else
		{
			return new CRect(this.rc.left + pos - 2, this.rc.top, this.rc.left + pos + 2, this.rc.bottom)
		}
	}
	GetSplitterPos(i)
	{
		return this.splitter.Get(i)
	}
	HitTest(x, y)
	{
		pos := this.bVertical ? (y - this.rc.top) : (x - this.rc.left)
		this.nCurSplitter := this.splitter.GetIndex(pos)
		if (this.nCurSplitter)
		{
			return this
		}
		Loop, % this.children.Length()
		{
			if (pos > this.splitter.Get(A_Index))
			{
				return 0
			}
			if (this.children[A_Index].splitter && ret := this.children[A_Index].HitTest(x, y))
			{
				return ret
			}
		}
		return 0
	}
	InsertAt(i, child, pos := 25)
	{
		this.children.InsertAt(i, child)
		if (this.children.Length() > 1)
		{
			this.splitter.split.InsertAt(i + 1, pos)
		}
	}
	RemoveAt(i)
	{
		if (i > 0 && i <= this.children.MaxIndex())
		{
			this.children.RemoveAt(i)
			this.splitter.split.RemoveAt(i + 1)
		}
	}
	ResizeChildSizer()
	{
		Loop, % this.children.Length()
		{
			if (this.children[A_Index].splitter)
			{
				if (this.bVertical)
				{
					this.children[A_Index].SetRect(new CRect(this.rc.left, this.rc.top + this.splitter.GetStart(A_Index), this.rc.right, this.rc.top + this.splitter.GetDistance(A_Index)))
				}
				else
				{
					this.children[A_Index].SetRect(new CRect(this.rc.left + this.splitter.GetStart(A_Index), this.rc.top, this.rc.left + this.splitter.GetDistance(A_Index), this.rc.bottom))
				}
			}
		}
	}
	SetCurSplitterPos(pos)
	{
		this.SetSplitterPos(this.nCurSplitter, pos)
	}
	SetRect(rc)
	{
		this.rc := rc
		if (this.bVertical)
		{
			this.splitter.SetRange(0, rc.bottom - rc.top)
		}
		else
		{
			this.splitter.SetRange(0, rc.right - rc.left)
		}
		this.ResizeChildSizer()
	}
	SetSplitterPos(i, v)
	{
		if (this.Count() >= i + 1)
		{
			this.splitter.Set(i, this.splitter.Adjust(i, v))
			this.ResizeChildSizer()
		}
	}
	Size()
	{
		Loop, % this.children.Length()
		{
			if (this.children[A_Index].splitter)
			{
				this.children[A_Index].Size()
			}
			else
			{
				pos := this.GetChildPos(A_Index)
				this.children[A_Index].Move(pos.x, pos.y, pos.w, pos.h)
			}
		}
	}
}
class CWindow
{
	__New(hWnd)
	{
		if (RegExMatch(hWnd, "i)^0x[0-9a-f]+$") || RegExMatch(hWnd, "^\d+$"))
		{
			this.hWnd := hWnd
			this.title := "ahk_id " hWnd
		}
		else
		{
			this.title := hWnd
			this.hWnd := WinExist(this.title)
		}
	}
	Activate()
	{
		WinActivate, % this.title
	}
	Active()
	{
		return WinActive(this.title)
	}
	AlwaysOnTop(bOn := true)
	{
		onoff := bOn ? "On" : "Off" 
		WinSet, Alwaysontop, %onoff%, % this.title
	}
	Click(x, y)
	{
		lParam := this.MakeLong(x, y)
        this.PostMessage(CWU.WM_LBUTTONDOWN, CWU.MK_LBUTTON, lParam)
        this.PostMessage(CWU.WM_LBUTTONUP, CWU.MK_LBUTTON, lParam)
	}
	ClientToScreen(x, y)
	{
		VarSetCapacity(pt, 8, 0)
		NumPut(x, pt, 0, "int")
		NumPut(y, pt, 4, "int")
		if (DllCall("ClientToScreen", "ptr", this.hWnd, "ptr", &pt))
		{
			return this.GetPOINTObject(&pt)
		}
		return false
	}
	Close()
	{
		if (this.Exist())
		{
			WinClose, % this.title
			return true
		}
		return false
	}
	Control(name, subcmd, value :="")
	{
		Control, %subcmd%, %value%, %name%, % this.title
	}
	ControlClick(name := "", x := 0, y := 0)
	{
		pos := "x" x " y" y
		ControlClick, %name%, % this.title, , , , %pos%
	}
	ControlFocus(name := "")
	{
		ControlFocus, %name%, % this.title
	}
	ControlGet(name, subcmd := "hwnd", value := "")
	{
		ControlGet, outvar, %subcmd%, %value%, %name%, % this.title
		return outvar
	}
	ControlGetFocus()
	{
		ControlGetFocus, var, % this.title
		return var
	}
	ControlGetPos(name)
	{
		ControlGetPos, x, y, w, h, %name%, % this.title
		return new CPosition(x, y, w, h)
	}
	ControlGetText(name = "")
	{
		ControlGetText, text, %name%, % this.title
		return text
	}
	ControlMove(name, x, y, w := "", h := "")
	{
		ControlMove, %name%, x, y, w, h, % this.title
	}
	ControlPostMessage(uMsg, wParam := 0, lParam :=0, Control := "")
	{
		PostMessage, %uMsg%, %wParam%, %lParam%, %Control%, % this.title
	}
	ControlSend(name, keys)
	{
		ControlSend, %name%, %keys%, % this.title
	}
	ControlSendMessage(uMsg, wParam :=0, lParam := 0, Control := "", timeout := 5000)
	{
		SendMessage, %uMsg%, %wParam%, %lParam%, %Control% , % this.title, , , , %timeout%
		return ErrorLevel
	}
	ControlSendRaw(name, keys)
	{
		ControlSendRaw, %name%, %keys%, % this.title
	}
	
	ControlSetText(name, txt)
	{
		ControlSetText, %name%, %txt%, % this.title
	}
	DestroyWindow()
	{
		return DllCall("DestroyWindow", "ptr", this.hWnd)
	}
	Exist()
	{
		return WinExist(this.title)
	}
	Get(subcmd)
	{
		WinGet, var, %subcmd%, % this.title
		return var
	}
	GetClass()
	{
		WinGetClass, var, % this.title
		return var
	}
	GetClientRect()
	{
		VarSetCapacity(rect, 16, 0)
		if (DllCall("GetClientRect", "ptr", this.hWnd, "ptr", &rect))
		{
			return this.GetRECTObject(&rect)
		}
		return 0
	}
	GetControl(name)
	{
		return new CWindow(this.ControlGet(name))
	}
	GetControlList()
	{
		return this.Get("ControlList")
	}
	GetDialogWindow()
	{
		WinGet, windows, List, % this.title
		Loop, %windows%
		{
			win := new CWindow(windows%A_Index%)
			if (win.GetClass() = "#32770")
			{
				return win.hWnd
			}
		}
		return ""
	}
	GetParent()
	{
		SetFormat, Integer, h
		parent := DllCall("GetParent", "ptr", this.hWnd)
		SetFormat, Integer, d
		return parent
	}
	GetPID()
	{
		return this.Get("PID")
	}
	GetPixelColor(x, y, bCoordWindow := true)
	{
		if (bCoordWindow)
		{	
			this.WindowToScreen(x, y)
		}
		PixelGetColor, clr, x, y
		return clr
	}
	GetPOINTObject(ptr)
	{
		return new CPoint(NumGet(ptr + 0, 0, "Int"), NumGet(ptr + 0, 4, "Int"))
	}
	GetPos()
	{
		WinGetPos, x, y, w, h, % this.title
		return new CPosition(x, y, w, h)
	}	
	GetRECTObject(ptr)
	{
		return new CRect(NumGet(ptr + 0, 0, "Int"), NumGet(ptr + 0, 4, "Int"), NumGet(ptr + 0, 8, "Int"), NumGet(ptr + 0, 12, "Int"))
	}
	GetProcessName()
	{
		return this.Get("ProcessName")
	}
	GetText()
	{
		nBuffer := this.GetWindowTextLength() + 1
		VarSetCapacity(szText , nBuffer * (A_IsUnicode ? 2 : 1),0)
		length := this.SendMessage(CWU.WM_GETTEXT, nBuffer, &szText)
		return StrGet(&szText, length)
	}
	GetTitle()
	{
		WinGetTitle, var, % this.title
		return var
	}
	GetWindow(uCmd)
	{
		return DllCall("GetWindow", "ptr", this.hWnd, "uint", uCmd, "ptr")
	}
	GetWindowLong(nIndex)
	{
		if (A_PtrSize = 8)
		{
			return DllCall("GetWindowLongPtr", "ptr", this.hWnd, "int", nIndex, "ptr")
		}
		else
		{
			return DllCall("GetWindowLong", "ptr", this.hWnd, "int", nIndex)
		}
	}
	GetWindowRect()
	{
		VarSetCapacity(rect, 16, 0)
		if (DllCall("GetWindowRect", "ptr", this.hWnd, "ptr", &rect))
		{
			return this.GetRECTObject(&rect)
		}
		return 0
	}
	GetWindowTextLength()
	{
		return this.SendMessage(CWU.WM_GETTEXTLENGTH, 0, 0)
	}
	Hide()
	{
		WinHide, % this.title
	}
	IsWindow()
	{
		return DllCall("IsWindow", "ptr", this.hWnd)
	}
	IsWindowVisible()
	{
		return DllCall("IsWindowVisible", "ptr", this.hWnd)
	}
	Kill()
	{
		WinKill, % this.title
	}
	LogChildControl(x := 0, y = 0)
	{
		Loop, Parse, % this.GetControlList(), `n
		{
			child := this.GetControl(A_LoopField)
			pos := this.ControlGetPos(A_LoopField)
			l := pos.x
			r := pos.x + pos.w
			t := pos.y
			b := pos.y + pos.h
			if ((x = 0 && y = 0) || (x >= l && x <= r && y >= t && y <= b))
			{
				;this.ControlClick(A_LoopField, x - pos.x, y - pos.y)
				;Sleep, 1000
			}
		}
	}
	MakeLong(lo, hi)
	{
		return (hi << 16) | (lo & 0xffff)
	}
	Minimize()
	{
		;this.PostMessage(0x112, 0xF020)
		WinMinimize, % this.title
	}
	MouseMove(x, y)
	{
		lParam := this.MakeLong(x, y)
        this.PostMessage(CWU.WM_MOUSEMOVE, CWU.MK_LBUTTON, lParam)
	}
	Move(x, y, w := "", h := "")
	{
		if (!w || !h)
		{
			WinMove, % this.title, , x, y
		}
		else
		{
			WinMove, % this.title, , x, y, w, h
		}
	}
	MoveWindow(x, y, nWidth, nHeight, bRepaint := true)
	{
		return DllCall("MoveWindow", "ptr", this.hWnd, "int", x, "int", y, "int", nWidth, "int", nHeight, "int", bRepaint)
	}
	PopupWindowExist()
	{
		WinGet, windows, List
		Loop, %windows%
		{
			win := new CWindow(windows%A_Index%)
			if (win.GetClass() = "#32770" && win.GetProcessName() = this.GetProcessName())
			{
				return win.hWnd
			}
		}
		return 0
	}
	PostMessage(uMsg, wParam := 0, lParam :=0)
	{
		return DllCall("PostMessage", "ptr", this.hWnd, "uint", uMsg, "uptr", wParam, "ptr", lParam)
	}
	ReleaseCapture()
	{
		return DllCall("ReleaseCapture")
	}
	Reset()
	{
		this.hWnd := this.Exist()
		this.title := "ahk_id " this.hWnd
	}
	ScreenToClient(x, y)
	{
		VarSetCapacity(pt, 8, 0)
		NumPut(x, pt, 0, "int")
		NumPut(y, pt, 4, "int")
		if (DllCall("ScreenToClient", "ptr", this.hWnd, "ptr", &pt))
		{
			return this.GetPOINTObject(&pt)
		}
		return false
	}
	Send(keys)
	{
		this.Activate()
		Send, %keys%
	}
	SendMessage(uMsg, wParam :=0, lParam := 0)
	{
		return DllCall("SendMessage", "ptr", this.hWnd, "uint", uMsg, "uptr", wParam, "ptr", lParam)
	}
	SetActiveWindow()
	{
		return DllCall("SetActiveWindow", "ptr", this.hWnd, "ptr")
	}
	SetCapture()
	{
		return DllCall("SetCapture", "ptr", this.hWnd, "ptr")
	}
	SetFocus()
	{
		return DllCall("SetFocus", "ptr", this.hWnd, "ptr")
	}
	SetText(szText)
	{
		return this.SendMessage(CWU.WM_SETTEXT, 0, &szText)
	}
	SetTitle(title)
	{
		WinSetTitle, %title%
	}
	SetWindowLong(nIndex, value)
	{
		if (A_PtrSize = 8)
		{
			return DllCall("SetWindowLongPtr", "ptr", this.hWnd, "int", nIndex, "ptr", value)
		}
		else
		{
			return DllCall("SetWindowLong", "ptr", this.hWnd, "int", nIndex, "int", value)
		}
	}
	ShowWindow(bShow := true)
	{
		return DllCall("ShowWindow", "ptr", this.hWnd, "int", bShow)
	}
	SetWindowPos(flags := 3, hWndInsertAfter := 0, x := 0, y := 0, cx := 0, cy := 0)
	{
		return DllCall("SetWindowPos", "ptr", this.hWnd, "ptr", hWndInsertAfter, "int", x, "int", y, "int", cx, "int", cy,  "uint", flags)
	}
	InvalidateRect(rc := 0, bErase := true)
	{
		lpRect := 0
		if (rc)
		{
			VarSetCapacity(rect, 4 * 4, 0)
			NumPut(rc.left, rect, 0, "Int")
			NumPut(rc.top, rect, 4, "Int")
			NumPut(rc.right, rect, 8, "Int")
			NumPut(rc.bottom, rect, 12, "Int")
			lpRect := &rect
		}
		return DllCall("InvalidateRect", "ptr", this.hWnd, "ptr", lpRect, "int", bErase)
	}
	UpdateWindow()
	{
		return DllCall("UpdateWindow", "ptr", this.hWnd)
	}
	WaitControlFocus(name, timeout := 2000)
	{
		tc_start := A_TickCount
		while (1)
		{
			focus := this.ControlGetFocus() 
			if (focus = name)
			{
				return true
			}
			Sleep, 100
			if (A_TickCount - tc_start >= timeout)
			{
				return false
			}
		}
	}
	WaitPopupWindow(timeout := 2000)
	{
		tc_start := A_TickCount
		while (1)
		{
			hWnd := this.PopupWindowExist()
			if (hWnd)
			{
				return hWnd
			}
			Sleep, 100
			if (A_TickCount - tc_start >= timeout)
			{
				return 0
			}
		}
	}
	WindowToScreen(ByRef x, ByRef y)
	{
		pos := this.GetPos()
		x += pos.x
		y += pos.y
	}
	WinWait(title, timeout := 3, text := "")
	{
		WinWait, %title%, %text%, %timeout%
		return ErrorLevel = 0
	}
}

class CMenu
{
	static MF_INSERT := 0x00000000
	static MF_CHANGE := 0x00000080
	static MF_APPEND := 0x00000100
	static MF_DELETE := 0x00000200
	static MF_REMOVE := 0x00001000
	static MF_BYCOMMAND := 0x00000000
	static MF_BYPOSITION := 0x00000400
	static MF_SEPARATOR := 0x00000800
	static MF_ENABLED := 0x00000000
	static MF_GRAYED := 0x00000001
	static MF_DISABLED := 0x00000002
	static MF_UNCHECKED := 0x00000000
	static MF_CHECKED := 0x00000008
	static MF_USECHECKBITMAPS := 0x00000200
	static MF_STRING := 0x00000000
	static MF_BITMAP := 0x00000004
	static MF_OWNERDRAW := 0x00000100
	static MF_POPUP := 0x00000010
	static MF_MENUBARBREAK := 0x00000020
	static MF_MENUBREAK := 0x00000040
	static MF_UNHILITE := 0x00000000
	static MF_HILITE := 0x00000080
	static MF_DEFAULT := 0x00001000
	static MF_SYSMENU := 0x00002000
	static MF_HELP := 0x00004000
	static MF_RIGHTJUSTIFY := 0x00004000
	static MF_MOUSESELECT := 0x00008000
	__New(name)
	{
		this.name := name
	}
	Add(item, sub := "", bEnable := true)
	{
		if (item)
		{
			handler := sub ? ":" sub.name : CMenu.Handler
			Menu, % this.name, Add, %item%, %handler%
			return this.GetLastId()
		}
		else
		{
			Menu, % this.name, Add
		}
	}
	Check(id, bCheck := true)
	{
		hMenu := MenuGetHandle(this.name)
		uCheck := this.MF_BYCOMMAND | bCheck ? this.MF_CHECKED : this.MF_UNCHECKED
		return DllCall("CheckMenuItem", "ptr", hMenu, "uint", id, "uint", uCheck)
	}
	Enable(id, bEnable := true)
	{
		hMenu := MenuGetHandle(this.name)
		uEnable := this.MF_BYCOMMAND | bEnable ? this.MF_ENABLED : this.MF_DISABLED
		return DllCall("EnableMenuItem", "ptr", hMenu, "uint", id, "uint", uEnable)
	}
	EnableAll(bEnable := true)
	{
		count := this.GetMenuItemCount()
		hMenu := MenuGetHandle(this.name)
		Loop, %count%
		{
			pos := A_Index - 1
			uEnable := 0x0400
			uEnable |= bEnable ? 0x00 : 0x01
			DllCall("EnableMenuItem", "ptr", hMenu, "uint", pos, "uint", uEnable)
		}
	}
	GetMenuItemCount()
	{
		return DllCall("GetMenuItemCount", "ptr", MenuGetHandle(this.name))
	}
	GetMenuItemID(pos)
	{
		return DllCall("GetMenuItemID", "ptr", MenuGetHandle(this.name), "int", pos)
	}
	GetLastId()
	{
		return this.GetMenuItemID(this.GetMenuItemCount() - 1)
	}
	GetState(id, flags := 0)
	{
		hMenu := MenuGetHandle(this.name)
		return DllCall("GetMenuState", "ptr", hMenu, "uint", id, "uint", flags)		
	}
	Handler(ItemName, ItemPos, MenuName)
	{
	}
	IsChecked(id)
	{
		return this.GetState(id)  & this.MF_CHECKED
	}
	IsDisabled(id)
	{
		return this.GetState(id)  & this.MF_DISABLED
	}
	IsEnabled(id)
	{
		return ! this.IsDisabled(id)
	}
	IsUnchecked(id)
	{
		return ! this.IsChecked(id)
	}
	Rename(item, name)
	{
		Menu, % this.name, Rename, %item%, %name%
	}
}
class CControl extends CWindow
{
	static WND_CLASS := ""
	static CCS_TOP := 0x00000001
	static CCS_NOMOVEY := 0x00000002
	static CCS_BOTTOM := 0x00000003
	static CCS_NORESIZE := 0x00000004
	static CCS_NOPARENTALIGN := 0x00000008
	static CCS_ADJUSTABLE := 0x00000020
	static CCS_NODIVIDER := 0x00000040
	static CCS_VERT := 0x00000080
	static CCS_LEFT := (CControl.CCS_VERT | CControl.CCS_TOP)
	static CCS_RIGHT := (CControl.CCS_VERT | CControl.CCS_BOTTOM)
	static CCS_NOMOVEX := (CControl.CCS_VERT | CControl.CCS_NOMOVEY)
	
	static LVM_FIRST := 0x1000
	static DTM_FIRST := 0x1000
	static TV_FIRST := 0x1100
	static HDM_FIRST := 0x1200
	static TCM_FIRST := 0x1300
	static PGM_FIRST := 0x1400
	static ECM_FIRST := 0x1500
	static BCM_FIRST := 0x1600
	static CBM_FIRST := 0x1700
	static CCM_FIRST := 0x2000  
	static CCM_LAST := (CControl.CCM_FIRST + 0x200)
	static CCM_SETBKCOLOR := (CControl.CCM_FIRST + 1)
	static CCM_SETCOLORSCHEME := (CControl.CCM_FIRST + 2)
	static CCM_GETCOLORSCHEME := (CControl.CCM_FIRST + 3)
	static CCM_GETDROPTARGET := (CControl.CCM_FIRST + 4)
	static CCM_SETUNICODEFORMAT := (CControl.CCM_FIRST + 5)
	static CCM_GETUNICODEFORMAT := (CControl.CCM_FIRST + 6)
	static CCM_SETVERSION := (CControl.CCM_FIRST + 0x7)
	static CCM_GETVERSION := (CControl.CCM_FIRST + 0x8)
	static CCM_SETNOTIFYWINDOW := (CControl.CCM_FIRST + 0x9)
	static CCM_SETWINDOWTHEME := (CControl.CCM_FIRST + 0xb)
	static CCM_DPISCALE := (CControl.CCM_FIRST + 0xc)
	static INFOTIPSIZE := 1024
	static NM_FIRST := 0
	static NM_LAST := - 99
	static LVN_FIRST := -100
	static LVN_LAST := -199
	static HDN_FIRST := -300
	static HDN_LAST := -399
	static TVN_FIRST := -400
	static TVN_LAST := -499
	static TTN_FIRST := -520
	static TTN_LAST := -549
	static TCN_FIRST := -550
	static TCN_LAST := -580
	static CDN_FIRST := -601
	static CDN_LAST := -699
	static TBN_FIRST := -700
	static TBN_LAST := -720
	static UDN_FIRST := -721
	static UDN_LAST := -729
	static DTN_FIRST := -740
	static DTN_LAST := -745
	static MCN_FIRST := -746
	static MCN_LAST := -752
	static DTN_FIRST2 := -753
	static DTN_LAST2 := -799
	static CBEN_FIRST := -800
	static CBEN_LAST := -830
	static RBN_FIRST := -831
	static RBN_LAST := -859
	static IPN_FIRST := -860
	static IPN_LAST := -879
	static SBN_FIRST := -880
	static SBN_LAST := -899
	static PGN_FIRST := -900
	static PGN_LAST := -950
	static WMN_FIRST := -1000
	static WMN_LAST := -1200
	static BCN_FIRST := -1250
	static BCN_LAST := -1350
	static TRBN_FIRST := -1501
	static TRBN_LAST := -1519
	static EN_FIRST := -1520
	static EN_LAST := -1540
	static NM_OUTOFMEMORY := (CControl.NM_FIRST-1)
	static NM_CLICK := (CControl.NM_FIRST-2)
	static NM_DBLCLK := (CControl.NM_FIRST-3)
	static NM_RETURN := (CControl.NM_FIRST-4)
	static NM_RCLICK := (CControl.NM_FIRST-5)
	static NM_RDBLCLK := (CControl.NM_FIRST-6)
	static NM_SETFOCUS := (CControl.NM_FIRST-7)
	static NM_KILLFOCUS := (CControl.NM_FIRST-8)
	static NM_CUSTOMDRAW := (CControl.NM_FIRST-12)
	static NM_HOVER := (CControl.NM_FIRST-13)
	static NM_NCHITTEST := (CControl.NM_FIRST-14)
	static NM_KEYDOWN := (CControl.NM_FIRST-15)
	static NM_RELEASEDCAPTURE := (CControl.NM_FIRST-16)
	static NM_SETCURSOR := (CControl.NM_FIRST-17)
	static NM_CHAR := (CControl.NM_FIRST-18)
	static NM_TOOLTIPSCREATED := (CControl.NM_FIRST-19)
	static NM_LDOWN := (CControl.NM_FIRST-20)
	static NM_RDOWN := (CControl.NM_FIRST-21)
	static NM_THEMECHANGED := (CControl.NM_FIRST-22)
	static NM_FONTCHANGED := (CControl.NM_FIRST-23)
	static NM_CUSTOMTEXT := (CControl.NM_FIRST-24)
	static NM_TVSTATEIMAGECHANGING := (CControl.NM_FIRST-24)
	static MSGF_COMMCTRL_BEGINDRAG := 0x4200
	static MSGF_COMMCTRL_SIZEHEADER := 0x4201
	static MSGF_COMMCTRL_DRAGSELECT := 0x4202
	static MSGF_COMMCTRL_TOOLBARCUST := 0x4203
	static CDRF_DODEFAULT := 0x00000000
	static CDRF_NEWFONT := 0x00000002
	static CDRF_SKIPDEFAULT := 0x00000004
	static CDRF_DOERASE := 0x00000008
	static CDRF_SKIPPOSTPAINT := 0x00000100
	static CDRF_NOTIFYPOSTPAINT := 0x00000010
	static CDRF_NOTIFYITEMDRAW := 0x00000020
	static CDRF_NOTIFYSUBITEMDRAW := 0x00000020
	static CDRF_NOTIFYPOSTERASE := 0x00000040
	static CDDS_PREPAINT := 0x00000001
	static CDDS_POSTPAINT := 0x00000002
	static CDDS_PREERASE := 0x00000003
	static CDDS_POSTERASE := 0x00000004
	static CDDS_ITEM := 0x00010000
	static CDDS_ITEMPREPAINT := (CControl.CDDS_ITEM | CControl.CDDS_PREPAINT)
	static CDDS_ITEMPOSTPAINT := (CControl.CDDS_ITEM | CControl.CDDS_POSTPAINT)
	static CDDS_ITEMPREERASE := (CControl.CDDS_ITEM | CControl.CDDS_PREERASE)
	static CDDS_ITEMPOSTERASE := (CControl.CDDS_ITEM | CControl.CDDS_POSTERASE)
	static CDDS_SUBITEM := 0x00020000
	static CDIS_SELECTED := 0x0001
	static CDIS_GRAYED := 0x0002
	static CDIS_DISABLED := 0x0004
	static CDIS_CHECKED := 0x0008
	static CDIS_FOCUS := 0x0010
	static CDIS_DEFAULT := 0x0020
	static CDIS_HOT := 0x0040
	static CDIS_MARKED := 0x0080
	static CDIS_INDETERMINATE := 0x0100
	static CDIS_SHOWKEYBOARDCUES := 0x0200
	static CDIS_NEARHOT := 0x0400
	static CDIS_OTHERSIDEHOT := 0x0800
	static CDIS_DROPHILITED := 0x1000
	static ICC_LISTVIEW_CLASSES := 0x00000001
	static ICC_TREEVIEW_CLASSES := 0x00000002
	static ICC_BAR_CLASSES := 0x00000004
	static ICC_TAB_CLASSES := 0x00000008
	static ICC_UPDOWN_CLASS := 0x00000010
	static ICC_PROGRESS_CLASS := 0x00000020
	static ICC_HOTKEY_CLASS := 0x00000040
	static ICC_ANIMATE_CLASS := 0x00000080
	static ICC_WIN95_CLASSES := 0x000000FF
	static ICC_DATE_CLASSES := 0x00000100
	static ICC_USEREX_CLASSES := 0x00000200
	static ICC_COOL_CLASSES := 0x00000400
	static ICC_INTERNET_CLASSES := 0x00000800
	static ICC_PAGESCROLLER_CLASS := 0x00001000
	static ICC_NATIVEFNTCTL_CLASS := 0x00002000
	static ICC_STANDARD_CLASSES := 0x00004000
	static ICC_LINK_CLASS := 0x00008000
	__New(hWnd)
	{
		static id := 3
		base.__New(hWnd)
		this.id := this.GetCtrlID()
	}
	Destroy()
	{
		this.SendMessage(CWU.WM_SYSCOMMAND, CWU.SC_CLOSE, 0)
	}
	GetCtrlID()
	{
		return this.GetWindowLong(CWU.GWL_ID)
	}
	SetCtrlID(id)
	{
		this.id := id
		return this.SetWindowLong(CWU.GWL_ID, id)
	}
}
class CButtonCtrl extends CControl
{
	__New(name)
	{
		Gui, Add, Button,  HWNDhWnd, %name%
		base.__New(hWnd)
	}
}
class CEditCtrl extends CControl
{
	__New(name, bReadOnly := false)
	{
		this.name := name
		ES_MULTILINE := 0x0004, ES_AUTOVSCROLL := 0x0040, ES_READONLY := 0x0800
		style := ES_MULTILINE | ES_AUTOVSCROLL
		if (bReadOnly)
		{
			style |= ES_READONLY
		}
		Gui, Add, Edit,   HWNDhWnd %style% hidden
		base.__New(hWnd)
		EM_SETEXTENDEDSTYLE := CControl.ECM_FIRST + 10
		ES_EX_ALLOWEOL_CR  := 0x0001, ES_EX_ALLOWEOL_LF := 0x0002, ES_EX_ALLOWEOL_ALL := 0x0003
		ES_EX_CONVERT_EOL_ON_PASTE := 0x0004
		dwExStyle := ES_EX_ALLOWEOL_ALL | ES_EX_CONVERT_EOL_ON_PASTE
		this.SendMessage(EM_SETEXTENDEDSTYLE, 0x000F, dwExStyle)
	}
	Clear()
	{
		this.SetSel(0, -1)
		text := ""
		this.ReplaceSel(text)
	}
	SetSel(nStartChar, nEndChar)
	{
		EM_SETSEL := 0xB1
		this.SendMessage(EM_SETSEL, nStartChar, nEndChar)
	}
	ReplaceSel(ByRef text, bCanUndo := false)
	{
		EM_REPLACESEL := 0xC2
		return this.SendMessage(EM_REPLACESEL, bCanUndo, &text)
	}
	InsertText(nInsertAfterChar, ByRef text, bCanUndo := false)
	{
		this.SetSel(nInsertAfterChar, nInsertAfterChar)
		return this.ReplaceSel(text, bCanUndo)
	}	
	AppendText(ByRef text, bCanUndo :=false)
	{
		this.InsertText(this.GetWindowTextLength(), text, bCanUndo)
	}
	GetLimitText()
	{
		EM_GETLIMITTEXT := 0x00D5
		return this.SendMessage(EM_GETLIMITTEXT, 0, 0)
	}
	SetLimitText(nMax)
	{
		EM_SETLIMITTEXT := 0x00C5
		this.SendMessage(EM_SETLIMITTEXT, nMax, 0)
	}
	
}
class CStatusBarCtrl extends CControl
{
	__New()
	{
		Gui, Add, StatusBar, HWNDhWnd
		base.__New(hWnd)
	}
	SetParts(parts*)
	{
		static SB_SETPARTS := (CWU.WM_USER+4)
		VarSetCapacity(lParam, 4 * parts.Length(), 0)
		Loop, % parts.Length()
		{
			NumPut(parts[A_Index], lParam, 4 * (A_Index - 1))
		}
		return this.SendMessage(SB_SETPARTS, parts.Length(), &lParam)
	}
	SetText(iPart, szText)
	{
		static SB_SETTEXTA := (CWU.WM_USER+1)
		static SB_SETTEXTW := (CWU.WM_USER+11)
		static SB_SETTEXT := A_IsUnicode ? SB_SETTEXTW : SB_SETTEXTA
		iPart &= 0xFF
		return this.SendMessage(SB_SETTEXT, iPart, &szText)
	}
	Size()
	{
		return this.SendMessage(CWU.WM_SIZE, 0, 0)
	}
}

class CToolbarCtrl extends CControl
{
	__New()
	{
		TBSTYLE_WRAPABLE := 0x0200, TBSTYLE_FLAT := 0x0800, TBSTYLE_LIST := 0x1000, TBSTYLE_TRANSPARENT := 0x8000, TBSTYLE_EX_MIXEDBUTTONS := 0x00000008, BTNS_SHOWTEXT :=  0x0040
		TBSTYLE_AUTOSIZE := 0x0010	
		style := TBSTYLE_AUTOSIZE | TBSTYLE_WRAPABLE |  TBSTYLE_FLAT | TBSTYLE_LIST |  TBSTYLE_TRANSPARENT | BTNS_SHOWTEXT
		Gui, Add, Custom, ClassToolbarWindow32 HWNDhWnd %style%
		base.__new(hWnd)
	}
     SetMaxTextRows(MaxRows := 0)
    {
		TB_SETMAXTEXTROWS :=  (CWU.WM_USER + 60)
        return this.SendMessage(TB_SETMAXTEXTROWS, MaxRows, 0)
    }
	
    SetImageList(IL_Default)
    {
		TB_SETIMAGELIST :=  (CWU.WM_USER + 48)
		return this.SendMessage(TB_SETIMAGELIST, 0, IL_Default)
    }
	GetButtonText(id)
	{
		TB_GETBUTTONTEXTW := (CWU.WM_USER + 75)
		TB_GETBUTTONTEXTA :=  (CWU.WM_USER + 45)
		TB_GETBUTTONTEXT := A_IsUnicode ? TB_GETBUTTONTEXTW : TB_GETBUTTONTEXTA
		VarSetCapacity(pstr , 128 * (A_IsUnicode ? 2 : 1),0)
		length := this.SendMessage(TB_GETBUTTONTEXT, id, &pstr)
		return StrGet(&pstr, length)
	}
	SetButtonText(id, str)
	{
		TB_SETBUTTONINFOW := (CWU.WM_USER + 64)
		TB_SETBUTTONINFOA :=  (CWU.WM_USER + 66)
		TBIF_TEXT := 0x00000002
		
		TB_SETBUTTONINFO := A_IsUnicode ? TB_SETBUTTONINFOW : TB_SETBUTTONINFOA
		cbSize := A_PtrSize = 8 ? 48 : 32
		VarSetCapacity(ptbinfo, cbSize, 0)
		VarSetCapacity(pstr , StrPut(str) * (A_IsUnicode ? 2 : 1),0)
		StrPut(str, &pstr, StrPut(str) * (A_IsUnicode ? 2 : 1))
		NumPut(cbSize, ptbinfo, 0, "Uint")
		NumPut(TBIF_TEXT, ptbinfo, 4, "UInt")
		NumPut(&pstr, ptbinfo, A_PtrSize=8 ? 32 : 24, "Ptr")
		NumPut(StrPut(str), ptbinfo,A_PtrSize=8 ? 40 : 28,"Int")
		return this.SendMessage(TB_SETBUTTONINFO, id, &ptbinfo)
	}
	SetButtonSize(width, height)
	{
	}
	SetButtonWidth(min, max)
	{
		TB_SETBUTTONWIDTH := (CWU.WM_USER + 59)
		return this.SendMessage(TB_SETBUTTONWIDTH, 0, this.MakeLong(min, max))
	}
	Enable(id, bEnable := true)
	{
		TB_ENABLEBUTTON := 0x0401
		return this.SendMessage(TB_ENABLEBUTTON, id, bEnable)
	}
	AddString(str)
	{
		TB_ADDSTRINGA := (CWU.WM_USER + 28)
		TB_ADDSTRINGW := (CWU.WM_USER + 77)
		TB_ADDSTRING := A_IsUnicode ? TB_ADDSTRINGW : TB_ADDSTRINGA
		VarSetCapacity(pstr, (StrPut(str) * (A_IsUnicode ? 2 : 1), 0))
		StrPut(str, &pstr, StrPut(str) * (A_IsUnicode ? 2 : 1))
		return this.SendMessage(TB_ADDSTRING, 0, &pstr)
	}
	AddButton(i, id, str := "", state := 0x04, style := 0)
	{
		TBSTATE_ENABLED := 0x04
		TB_ADDBUTTONS := (CWU.WM_USER + 20)
		istr := str ? this.AddString(str) : -1
		VarSetCapacity(ptbbutton, 8 + (A_PtrSize * 3), 0)
		NumPut(i, ptbbutton, 0, "Int")
		NumPut(id, ptbbutton, 4, "Int")
		NumPut(state, ptbbutton, 8, "Char")
		NumPut(style, ptbbutton, 9, "Char")
		NumPut(istr, ptbbutton, 8 + (A_PtrSize * 2), "Ptr")		
		return this.SendMessage(TB_ADDBUTTONS, 1, &ptbbutton)
	}
    AutoSize()
    {
		TB_AUTOSIZE := (CWU.WM_USER + 33)
        return this.SendMessage(TB_AUTOSIZE, 0, 0)
    }
    Size()
    {
		return this.SendMessage(CWU.WM_SIZE, 0, 0)
    }
}
class CToolbarButton
{
	__New(id, text, icono, icofile := "wmploc.dll")
	{
		this.id := id
		this.text := text
		this.icono := icono
		this.icofile := icofile
	}
}
class CTabCtrl extends CControl
{
	static WND_CLASS := "SysTabControl32"
	static TCS_SCROLLOPPOSITE := 0x0001
	static TCS_BOTTOM := 0x0002
	static TCS_RIGHT := 0x0002
	static TCS_MULTISELECT := 0x0004
	static TCS_FLATBUTTONS := 0x0008
	static TCS_FORCEICONLEFT := 0x0010
	static TCS_FORCELABELLEFT := 0x0020
	static TCS_HOTTRACK := 0x0040
	static TCS_VERTICAL := 0x0080
	static TCS_TABS := 0x0000
	static TCS_BUTTONS := 0x0100
	static TCS_SINGLELINE := 0x0000
	static TCS_MULTILINE := 0x0200
	static TCS_RIGHTJUSTIFY := 0x0000
	static TCS_FIXEDWIDTH := 0x0400
	static TCS_RAGGEDRIGHT := 0x0800
	static TCS_FOCUSONBUTTONDOWN := 0x1000
	static TCS_OWNERDRAWFIXED := 0x2000
	static TCS_TOOLTIPS := 0x4000
	static TCS_FOCUSNEVER := 0x8000
	static TCS_EX_FLATSEPARATORS := 0x00000001
	static TCS_EX_REGISTERDROP := 0x00000002
	static TCM_GETIMAGELIST := (CControl.TCM_FIRST + 2)
	static TCM_SETIMAGELIST := (CControl.TCM_FIRST + 3)
	static TCM_GETITEMCOUNT := (CControl.TCM_FIRST + 4)
	static TCIF_TEXT := 0x0001
	static TCIF_IMAGE := 0x0002
	static TCIF_RTLREADING := 0x0004
	static TCIF_PARAM := 0x0008
	static TCIF_STATE := 0x0010
	static TCIS_BUTTONPRESSED := 0x0001
	static TCIS_HIGHLIGHTED := 0x0002
	static TCM_GETITEMA := (CControl.TCM_FIRST + 5)
	static TCM_GETITEMW := (CControl.TCM_FIRST + 60)
	static TCM_SETITEMA := (CControl.TCM_FIRST + 6)
	static TCM_SETITEMW := (CControl.TCM_FIRST + 61)
	static TCM_INSERTITEMA := (CControl.TCM_FIRST + 7)
	static TCM_INSERTITEMW := (CControl.TCM_FIRST + 62)
	static TCM_GETITEM := A_IsUnicode ? CTabCtrl.TCM_GETITEMW : CTabCtrl.TCM_GETITEMA
	static TCM_SETITEM := A_IsUnicode ? CTabCtrl.TCM_SETITEMW : CTabCtrl.TCM_SETITEMA
	static TCM_INSERTITEM := A_IsUnicode ? CTabCtrl.TCM_INSERTITEMW : CTabCtrl.TCM_INSERTITEMA
	static TCM_DELETEITEM := (CControl.TCM_FIRST + 8)
	static TCM_DELETEALLITEMS := (CControl.TCM_FIRST + 9)
	static TCM_GETITEMRECT := (CControl.TCM_FIRST + 10)
	static TCM_GETCURSEL := (CControl.TCM_FIRST + 11)
	static TCM_SETCURSEL := (CControl.TCM_FIRST + 12)
	static TCHT_NOWHERE := 0x0001
	static TCHT_ONITEMICON := 0x0002
	static TCHT_ONITEMLABEL := 0x0004
	static TCHT_ONITEM := (CTabCtrl.TCHT_ONITEMICON | CTabCtrl.TCHT_ONITEMLABEL)
	static TCM_HITTEST := (CControl.TCM_FIRST + 13)
	static TCM_SETITEMEXTRA := (CControl.TCM_FIRST + 14)
	static TCM_ADJUSTRECT := (CControl.TCM_FIRST + 40)
	static TCM_SETITEMSIZE := (CControl.TCM_FIRST + 41)
	static TCM_REMOVEIMAGE := (CControl.TCM_FIRST + 42)
	static TCM_SETPADDING := (CControl.TCM_FIRST + 43)
	static TCM_GETROWCOUNT := (CControl.TCM_FIRST + 44)
	static TCM_GETTOOLTIPS := (CControl.TCM_FIRST + 45)
	static TCM_SETTOOLTIPS := (CControl.TCM_FIRST + 46)
	static TCM_GETCURFOCUS := (CControl.TCM_FIRST + 47)
	static TCM_SETCURFOCUS := (CControl.TCM_FIRST + 48)
	static TCM_SETMINTABWIDTH := (CControl.TCM_FIRST + 49)
	static TCM_DESELECTALL := (CControl.TCM_FIRST + 50)
	static TCM_HIGHLIGHTITEM := (CControl.TCM_FIRST + 51)
	static TCM_SETEXTENDEDSTYLE := (CControl.TCM_FIRST + 52)
	static TCM_GETEXTENDEDSTYLE := (CControl.TCM_FIRST + 53)
	static TCM_SETUNICODEFORMAT := CControl.CCM_SETUNICODEFORMAT
	static TCM_GETUNICODEFORMAT := CControl.CCM_GETUNICODEFORMAT
	static TCN_KEYDOWN := (CControl.TCN_FIRST - 0)
	static TCN_SELCHANGE := (CControl.TCN_FIRST - 1)
	static TCN_SELCHANGING := (CControl.TCN_FIRST - 2)
	static TCN_GETOBJECT := (CControl.TCN_FIRST - 3)
	static TCN_FOCUSCHANGE := (CControl.TCN_FIRST - 4)
	__New(dwStyle := 0, dwExStyle := 0)
	{
		Gui, Add, Custom, ClassSysTabControl32 HWNDhWnd %dwStyle% E%dwExStyle% hidden
		base.__New(hWnd)
	}
	AdjustRect(ByRef rc, bLarger := false)
	{
		VarSetCapacity(prc, 4 * 4, 0)
		NumPut(rc.left, prc, 0, "Int")
		NumPut(rc.top, prc, 4, "Int")
		NumPut(rc.right, prc, 8, "Int")
		NumPut(rc.bottom, prc, 12, "Int")
		this.SendMessage(this.TCM_ADJUSTRECT, bLarger, &prc)
		rc := this.GetRECTObject(&prc)
	}
	DeleteItem(iItem)
	{
		return this.SendMessage(this.TCM_DELETEITEM, iItem, 0)
	}
	GetCurSel()
	{
		return this.SendMessage(this.TCM_GETCURSEL, 0, 0)
	}
	HitTest(x, y, flags)
	{
		VarSetCapacity(TCHITTESTINFO, 12, 0)
		NumPut(x, TCHITTESTINFO, 0, "Int")
		NumPut(y, TCHITTESTINFO, 4, "Int")
		NumPut(flags, TCHITTESTINFO, 8, "UInt")
		return this.SendMessage(this.TCM_HITTEST, 0, &TCHITTESTINFO)
	}
	HighlightItem(iItem, fHighlight := 1)
	{
		return this.SendMessage(this.TCM_HIGHLIGHTITEM, iItem, fHighlight)
	}
	InsertItem(iItem, str)
	{
		VarSetCapacity(pitem, A_PtrSize = 8 ? 40 : 28, 0)
		VarSetCapacity(pstr , StrPut(str)*(A_IsUnicode ? 2:1),0)
		StrPut(str, &pstr, StrPut(str) * (A_IsUnicode ? 2 : 1))
		NumPut(this.TCIF_TEXT,pitem,0,"UInt")                   
		NumPut(&pstr,  pitem,A_PtrSize=8 ? 16:12,"Ptr") 
		NumPut(StrPut(str), pitem,A_PtrSize=8 ? 24:16,"Int")
		return this.SendMessage(this.TCM_INSERTITEM, iItem, &pitem)
	}
	SetCurFocus(iItem)
	{
		this.SendMessage(this.TCM_SETCURFOCUS, iItem, 0)
	}
	SetCurSel(iItem)
	{
		this.SendMessage(this.TCM_SETCURSEL, iItem, 0)		
	}
}
class CTabView extends CTabCtrl
{
	__New(dwStyle := 0, dwExStyle := 0)
	{
		base.__New(dwStyle, dwExStyle)
		this.children := Array()
	}
	Add(child)
	{
		i := this.children.Length()
		this.InsertItem(i, child.name)
		this.children.Push(child)
	}
	Exist(name)
	{
		Loop, % this.children.Length()
		{
			if (this.children[A_Index].name = name)
			{
				return true
			}
		}
		return false
	}
	GetCurSelName()
	{
		i := this.GetCurSel() + 1
		return this.children[i].name
	}
	GetCurChild()
	{
		return this.children[this.GetCurSel() + 1]
	}
	GetCurChildId()
	{
		return this.children[this.GetCurSel() + 1].id
	}
	Move(x, y, w, h)
	{
		base.Move(x, y, w, h)
		rc := new CRect(x, y, x+ w, y +h)
		this.AdjustRect(rc)
		Loop, % this.children.MaxIndex()
		{
			if (this.children[A_Index].hWnd)
			{
				this.children[A_Index].Move(rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top)
			}
		}
	}
	RemoveAt(iItem)
	{
		child := this.children.RemoveAt(iItem + 1)
		if (child)
		{
			this.DeleteItem(iItem)
			return child
		}
		return ""
	}
	Select(name)
	{
		Loop, % this.children.MaxIndex()
		{
			if (name = this.children[A_Index].name)
			{
				this.SetCurSel(A_Index - 1)
				return this.children[A_Index]
			}
		}
	}
	SetCurSel(iItem)
	{
		base.SetCurSel(iItem)
		if (this.IsWindowVisible())
		{
			this.ShowChild()
		}
	}
	ShowWindow(bShow := true)
	{
		base.ShowWindow(bShow)
		this.ShowChild(bShow)
	}
	ShowChild(bShow := true)
	{
		iSel := this.GetCurSel()
		Loop, % this.children.MaxIndex()
		{
			if (A_Index != iSel + 1)
			{
				this.children[A_Index].ShowWindow(false)
			}
		}
		this.children[iSel + 1].ShowWindow(bShow)
		if (bShow)
		{
			this.children[iSel + 1].SetFocus()
		}
	}
}
class CImageList
{
	static CLR_NONE := 0xFFFFFFFF
	static CLR_DEFAULT := 0xFF000000
	static ILC_MASK := 0x00000001
	static ILC_COLOR := 0x00000000
	static ILC_COLORDDB := 0x000000FE
	static ILC_COLOR4 := 0x00000004
	static ILC_COLOR8 := 0x00000008
	static ILC_COLOR16 := 0x00000010
	static ILC_COLOR24 := 0x00000018
	static ILC_COLOR32 := 0x00000020
	static ILC_PALETTE := 0x00000800
	static ILC_MIRROR := 0x00002000
	static ILC_PERITEMMIRROR := 0x00008000
	static ILC_ORIGINALSIZE := 0x00010000
	static ILC_HIGHQUALITYSCALE := 0x00020000
	static ILD_NORMAL := 0x00000000
	static ILD_TRANSPARENT := 0x00000001
	static ILD_MASK := 0x00000010
	static ILD_IMAGE := 0x00000020
	static ILD_ROP := 0x00000040
	static ILD_BLEND25 := 0x00000002
	static ILD_BLEND50 := 0x00000004
	static ILD_OVERLAYMASK := 0x00000F00
	static ILD_PRESERVEALPHA := 0x00001000
	static ILD_SCALE := 0x00002000
	static ILD_DPISCALE := 0x00004000
	static ILD_ASYNC := 0x00008000
	static ILD_SELECTED := CImageList.ILD_BLEND50
	static ILD_FOCUS := CImageList.ILD_BLEND25
	static ILD_BLEND := CImageList.ILD_BLEND50
	static CLR_HILIGHT := CImageList.CLR_DEFAULT
	static ILS_NORMAL := 0x00000000
	static ILS_GLOW := 0x00000001
	static ILS_SHADOW := 0x00000002
	static ILS_SATURATE := 0x00000004
	static ILS_ALPHA := 0x00000008
	static ILGT_NORMAL := 0x00000000
	static ILGT_ASYNC := 0x00000001
	static ILCF_MOVE := (0x00000000)
	static ILCF_SWAP := (0x00000001)
	static ILP_NORMAL := 0
	static ILP_DOWNLEVEL := 1	
	__New(himl := "")
	{
		this.himl := himl
	}
	Add(hbmImage, hbmMask)
	{
		return DllCall("ImageList_Add", "ptr", this.himl, "ptr", hbmImage, "ptr", hbmMask)
	}
	AddIconFromModule(lpszModuleName, index)
	{
		hModule := DllCall("GetModuleHandle", "str", lpszModuleName, "ptr")
		flags := CWU.LR_SHARED | CWU.LR_DEFAULTCOLOR
		hicon := DllCall("LoadImage", "ptr", hModule, "Uint", index, "Uint", CWU.IMAGE_ICON, "int", this.cx, "int", this.cy, "Uint", flags, "ptr")
		if (hicon)
		{
			return this.ReplaceIcon(-1, hicon)
		}
		return false
	}
	AddIcon(hicon)
	{
		return this.ReplaceIcon(-1, hicon)
	}
	AddMask(hbmImage, crMask)
	{
		return DllCall("ImageList_AddMasked", "ptr", this.himl, "ptr", hbmImage, "uint", crMask)
	}
	BeginDrag(iTrack, dxHotspot, dyHotspot)
	{
		return DllCall("ImageList_BeginDrag", "ptr", this.himl, "int", iTrack, "int", dxHotspot, "int", dyHotspot)
	}
	Copy(himlDst, iDst, iSrc, uFlags)
	{
		return DllCall("ImageList_Copy", "ptr", himlDst, "int", iDst, "ptr", this.himl, "int", iSrc, "uint", uFlags)
	}
	Create(cx, cy, flags, cInitial, cGrow)
	{
		this.cx := cx
		this.cy := cy
		this.himl := DllCall("ImageList_Create", "int", cx, "int", cy, "uint", flags, "int", cInitial, "int", cGrow, "ptr")
		return (this.himl) ? true : false
	}
	DragEnter(hwndLock, x, y)
	{
		return DllCall("ImageList_DragEnter", "ptr", hwndLock, "int", x, "int", y)
	}
	DragLeave(hwndLock)
	{
		return DllCall("ImageList_DragLeave", "ptr", hwndLock)
	}
	DragMove(x, y)
	{
		return DllCall("ImageList_DragMove", "int", x, "int", y)
	}
	DragShowNolock(bShow)
	{
		return DllCall("ImageList_DragShowNolock", "int", bShow)
	}
	Destroy()
	{
		return DllCall("ImageList_Destroy", "ptr", this.himl)
	}
	GetImageCount()
	{
		return DllCall("ImageList_GetImageCount", "ptr", this.himl)
	}
	EndDrag()
	{
		DllCall("ImageList_EndDrag")
	}
	ReplaceIcon(i, hicon)
	{
		return DllCall("ImageList_ReplaceIcon", "ptr", this.himl, "int", i, "ptr", hicon)
	}
}
class CTreeViewCtrl extends CControl
{
	static WND_CLASS := "SysTreeView32"
	static TVS_HASBUTTONS := 0x0001
	static TVS_HASLINES := 0x0002
	static TVS_LINESATROOT := 0x0004
	static TVS_EDITLABELS := 0x0008
	static TVS_DISABLEDRAGDROP := 0x0010
	static TVS_SHOWSELALWAYS := 0x0020
	static TVS_RTLREADING := 0x0040
	static TVS_NOTOOLTIPS := 0x0080
	static TVS_CHECKBOXES := 0x0100
	static TVS_TRACKSELECT := 0x0200
	static TVS_SINGLEEXPAND := 0x0400
	static TVS_INFOTIP := 0x0800
	static TVS_FULLROWSELECT := 0x1000
	static TVS_NOSCROLL := 0x2000
	static TVS_NONEVENHEIGHT := 0x4000
	static TVS_NOHSCROLL := 0x8000
	static TVS_EX_NOSINGLECOLLAPSE := 0x0001
	static TVS_EX_MULTISELECT := 0x0002
	static TVS_EX_DOUBLEBUFFER := 0x0004
	static TVS_EX_NOINDENTSTATE := 0x0008
	static TVS_EX_RICHTOOLTIP := 0x0010
	static TVS_EX_AUTOHSCROLL := 0x0020
	static TVS_EX_FADEINOUTEXPANDOS := 0x0040
	static TVS_EX_PARTIALCHECKBOXES := 0x0080
	static TVS_EX_EXCLUSIONCHECKBOXES := 0x0100
	static TVS_EX_DIMMEDCHECKBOXES := 0x0200
	static TVS_EX_DRAWIMAGEASYNC := 0x0400
	static TVIF_TEXT := 0x0001
	static TVIF_IMAGE := 0x0002
	static TVIF_PARAM := 0x0004
	static TVIF_STATE := 0x0008
	static TVIF_HANDLE := 0x0010
	static TVIF_SELECTEDIMAGE := 0x0020
	static TVIF_CHILDREN := 0x0040
	static TVIF_INTEGRAL := 0x0080
	static TVIF_STATEEX := 0x0100
	static TVIF_EXPANDEDIMAGE := 0x0200
	static TVIS_SELECTED := 0x0002
	static TVIS_CUT := 0x0004
	static TVIS_DROPHILITED := 0x0008
	static TVIS_BOLD := 0x0010
	static TVIS_EXPANDED := 0x0020
	static TVIS_EXPANDEDONCE := 0x0040
	static TVIS_EXPANDPARTIAL := 0x0080
	static TVIS_OVERLAYMASK := 0x0F00
	static TVIS_STATEIMAGEMASK := 0xF000
	static TVIS_USERMASK := 0xF000
	static TVIS_EX_FLAT := 0x0001
	static TVIS_EX_DISABLED := 0x0002
	static TVIS_EX_ALL := 0x0002
	static I_CHILDRENCALLBACK := (-1)
	static I_CHILDRENAUTO := (-2)
	static TVI_ROOT := (-0x10000)
	static TVI_FIRST := (-0x0FFFF)
	static TVI_LAST := (-0x0FFFE)
	static TVI_SORT := (-0x0FFFD)
	static TVM_INSERTITEMA := (CControl.TV_FIRST + 0)
	static TVM_INSERTITEMW := (CControl.TV_FIRST + 50)
	static TVM_DELETEITEM := (CControl.TV_FIRST + 1)
	static TVM_EXPAND := (CControl.TV_FIRST + 2)
	static TVE_COLLAPSE := 0x0001
	static TVE_EXPAND := 0x0002
	static TVE_TOGGLE := 0x0003
	static TVE_EXPANDPARTIAL := 0x4000
	static TVE_COLLAPSERESET := 0x8000
	static TVM_GETITEMRECT := (CControl.TV_FIRST + 4)
	static TVM_GETCOUNT := (CControl.TV_FIRST + 5)
	static TVM_GETINDENT := (CControl.TV_FIRST + 6)
	static TVM_SETINDENT := (CControl.TV_FIRST + 7)
	static TVM_GETIMAGELIST := (CControl.TV_FIRST + 8)
	static TVSIL_NORMAL := 0
	static TVSIL_STATE := 2
	static TVM_SETIMAGELIST := (CControl.TV_FIRST + 9)
	static TVM_GETNEXTITEM := (CControl.TV_FIRST + 10)
	static TVGN_ROOT := 0x0000
	static TVGN_NEXT := 0x0001
	static TVGN_PREVIOUS := 0x0002
	static TVGN_PARENT := 0x0003
	static TVGN_CHILD := 0x0004
	static TVGN_FIRSTVISIBLE := 0x0005
	static TVGN_NEXTVISIBLE := 0x0006
	static TVGN_PREVIOUSVISIBLE := 0x0007
	static TVGN_DROPHILITE := 0x0008
	static TVGN_CARET := 0x0009
	static TVGN_LASTVISIBLE := 0x000A
	static TVGN_NEXTSELECTED := 0x000B
	static TVSI_NOSINGLEEXPAND := 0x8000
	static TVM_SELECTITEM := (CControl.TV_FIRST + 11)
	static TVM_GETITEMA := (CControl.TV_FIRST + 12)
	static TVM_GETITEMW := (CControl.TV_FIRST + 62)
	static TVM_SETITEMA := (CControl.TV_FIRST + 13)
	static TVM_SETITEMW := (CControl.TV_FIRST + 63)
	static TVM_EDITLABELA := (CControl.TV_FIRST + 14)
	static TVM_EDITLABELW := (CControl.TV_FIRST + 65)
	static TVM_GETEDITCONTROL := (CControl.TV_FIRST + 15)
	static TVM_GETVISIBLECOUNT := (CControl.TV_FIRST + 16)
	static TVM_HITTEST := (CControl.TV_FIRST + 17)
	static TVHT_NOWHERE := 0x0001
	static TVHT_ONITEMICON := 0x0002
	static TVHT_ONITEMLABEL := 0x0004
	static TVHT_ONITEM := (CTreeViewCtrl.TVHT_ONITEMICON | CTreeViewCtrl.TVHT_ONITEMLABEL | CTreeViewCtrl.TVHT_ONITEMSTATEICON)
	static TVHT_ONITEMINDENT := 0x0008
	static TVHT_ONITEMBUTTON := 0x0010
	static TVHT_ONITEMRIGHT := 0x0020
	static TVHT_ONITEMSTATEICON := 0x0040
	static TVHT_ABOVE := 0x0100
	static TVHT_BELOW := 0x0200
	static TVHT_TORIGHT := 0x0400
	static TVHT_TOLEFT := 0x0800
	static TVM_CREATEDRAGIMAGE := (CControl.TV_FIRST + 18)
	static TVM_SORTCHILDREN := (CControl.TV_FIRST + 19)
	static TVM_ENSUREVISIBLE := (CControl.TV_FIRST + 20)
	static TVM_SORTCHILDRENCB := (CControl.TV_FIRST + 21)
	static TVM_ENDEDITLABELNOW := (CControl.TV_FIRST + 22)
	static TVM_GETISEARCHSTRINGA := (CControl.TV_FIRST + 23)
	static TVM_GETISEARCHSTRINGW := (CControl.TV_FIRST + 64)
	static TVM_SETTOOLTIPS := (CControl.TV_FIRST + 24)
	static TVM_GETTOOLTIPS := (CControl.TV_FIRST + 25)
	static TVM_SETINSERTMARK := (CControl.TV_FIRST + 26)
	static TVM_SETUNICODEFORMAT := CControl.CCM_SETUNICODEFORMAT
	static TVM_GETUNICODEFORMAT := CControl.CCM_GETUNICODEFORMAT
	static TVM_SETITEMHEIGHT := (CControl.TV_FIRST + 27)
	static TVM_GETITEMHEIGHT := (CControl.TV_FIRST + 28)
	static TVM_SETBKCOLOR := (CControl.TV_FIRST + 29)
	static TVM_SETTEXTCOLOR := (CControl.TV_FIRST + 30)
	static TVM_GETBKCOLOR := (CControl.TV_FIRST + 31)
	static TVM_GETTEXTCOLOR := (CControl.TV_FIRST + 32)
	static TVM_SETSCROLLTIME := (CControl.TV_FIRST + 33)
	static TVM_GETSCROLLTIME := (CControl.TV_FIRST + 34)
	static TVM_SETINSERTMARKCOLOR := (CControl.TV_FIRST + 37)
	static TVM_GETINSERTMARKCOLOR := (CControl.TV_FIRST + 38)
	static TVM_SETBORDER := (CControl.TV_FIRST + 35)
	static TVSBF_XBORDER := 0x00000001
	static TVSBF_YBORDER := 0x00000002
	static TVM_GETITEMSTATE := (CControl.TV_FIRST + 39)
	static TVM_SETLINECOLOR := (CControl.TV_FIRST + 40)
	static TVM_GETLINECOLOR := (CControl.TV_FIRST + 41)
	static TVM_MAPACCIDTOHTREEITEM := (CControl.TV_FIRST + 42)
	static TVM_MAPHTREEITEMTOACCID := (CControl.TV_FIRST + 43)
	static TVM_SETEXTENDEDSTYLE := (CControl.TV_FIRST + 44)
	static TVM_GETEXTENDEDSTYLE := (CControl.TV_FIRST + 45)
	static TVM_SETAUTOSCROLLINFO := (CControl.TV_FIRST + 59)
	static TVM_SETHOT := (CControl.TV_FIRST + 58)
	static TVM_GETSELECTEDCOUNT := (CControl.TV_FIRST + 70)
	static TVM_SHOWINFOTIP := (CControl.TV_FIRST + 71)
	static TVM_GETITEMPARTRECT := (CControl.TV_FIRST + 72)
	static TVN_SELCHANGINGA := (CControl.TVN_FIRST-1)
	static TVN_SELCHANGINGW := (CControl.TVN_FIRST-50)
	static TVN_SELCHANGEDA := (CControl.TVN_FIRST-2)
	static TVN_SELCHANGEDW := (CControl.TVN_FIRST-51)
	static TVC_UNKNOWN := 0x0000
	static TVC_BYMOUSE := 0x0001
	static TVC_BYKEYBOARD := 0x0002
	static TVN_GETDISPINFOA := (CControl.TVN_FIRST-3)
	static TVN_GETDISPINFOW := (CControl.TVN_FIRST-52)
	static TVN_SETDISPINFOA := (CControl.TVN_FIRST-4)
	static TVN_SETDISPINFOW := (CControl.TVN_FIRST-53)
	static TVIF_DI_SETITEM := 0x1000
	static TVN_ITEMEXPANDINGA := (CControl.TVN_FIRST-5)
	static TVN_ITEMEXPANDINGW := (CControl.TVN_FIRST-54)
	static TVN_ITEMEXPANDEDA := (CControl.TVN_FIRST-6)
	static TVN_ITEMEXPANDEDW := (CControl.TVN_FIRST-55)
	static TVN_BEGINDRAGA := (CControl.TVN_FIRST-7)
	static TVN_BEGINDRAGW := (CControl.TVN_FIRST-56)
	static TVN_BEGINRDRAGA := (CControl.TVN_FIRST-8)
	static TVN_BEGINRDRAGW := (CControl.TVN_FIRST-57)
	static TVN_DELETEITEMA := (CControl.TVN_FIRST-9)
	static TVN_DELETEITEMW := (CControl.TVN_FIRST-58)
	static TVN_BEGINLABELEDITA := (CControl.TVN_FIRST-10)
	static TVN_BEGINLABELEDITW := (CControl.TVN_FIRST-59)
	static TVN_ENDLABELEDITA := (CControl.TVN_FIRST-11)
	static TVN_ENDLABELEDITW := (CControl.TVN_FIRST-60)
	static TVN_KEYDOWN := (CControl.TVN_FIRST-12)
	static TVN_GETINFOTIPA := (CControl.TVN_FIRST-13)
	static TVN_GETINFOTIPW := (CControl.TVN_FIRST-14)
	static TVN_SINGLEEXPAND := (CControl.TVN_FIRST-15)
	static TVNRET_DEFAULT := 0
	static TVNRET_SKIPOLD := 1
	static TVNRET_SKIPNEW := 2
	static TVN_ITEMCHANGINGA := (CControl.TVN_FIRST-16)
	static TVN_ITEMCHANGINGW := (CControl.TVN_FIRST-17)
	static TVN_ITEMCHANGEDA := (CControl.TVN_FIRST-18)
	static TVN_ITEMCHANGEDW := (CControl.TVN_FIRST-19)
	static TVN_ASYNCDRAW := (CControl.TVN_FIRST-20)
	static TVCDRF_NOIMAGES := 0x00010000
	static TVM_INSERTITEM := A_IsUnicode ? CTreeViewCtrl.TVM_INSERTITEMW : CTreeViewCtrl.TVM_INSERTITEMA
	static TVM_GETITEM := A_IsUnicode ? CTreeViewCtrl.TVM_GETITEMW : CTreeViewCtrl.TVM_GETITEMA
	static TVM_SETITEM := A_IsUnicode ? CTreeViewCtrl.TVM_SETITEMW : CTreeViewCtrl.TVM_SETITEMA
	static TVM_EDITLABEL := A_IsUnicode ? CTreeViewCtrl.TVM_EDITLABELW : CTreeViewCtrl.TVM_EDITLABELA
	static TVM_GETISEARCHSTRING := A_IsUnicode ? CTreeViewCtrl.TVM_GETISEARCHSTRINGW : CTreeViewCtrl.TVM_GETISEARCHSTRINGA
	static TVN_SELCHANGING := A_IsUnicode ? CTreeViewCtrl.TVN_SELCHANGINGW : CTreeViewCtrl.TVN_SELCHANGINGA
	static TVN_SELCHANGED := A_IsUnicode ? CTreeViewCtrl.TVN_SELCHANGEDW : CTreeViewCtrl.TVN_SELCHANGEDA
	static TVN_GETDISPINFO := A_IsUnicode ? CTreeViewCtrl.TVN_GETDISPINFOW : CTreeViewCtrl.TVN_GETDISPINFOA
	static TVN_SETDISPINFO := A_IsUnicode ? CTreeViewCtrl.TVN_SETDISPINFOW : CTreeViewCtrl.TVN_SETDISPINFOA
	static TVN_ITEMEXPANDING := A_IsUnicode ? CTreeViewCtrl.TVN_ITEMEXPANDINGW : CTreeViewCtrl.TVN_ITEMEXPANDINGA
	static TVN_ITEMEXPANDED := A_IsUnicode ? CTreeViewCtrl.TVN_ITEMEXPANDEDW : CTreeViewCtrl.TVN_ITEMEXPANDEDA
	static TVN_BEGINDRAG := A_IsUnicode ? CTreeViewCtrl.TVN_BEGINDRAGW : CTreeViewCtrl.TVN_BEGINDRAGA
	static TVN_BEGINRDRAG := A_IsUnicode ? CTreeViewCtrl.TVN_BEGINRDRAGW : CTreeViewCtrl.TVN_BEGINRDRAGA
	static TVN_DELETEITEM := A_IsUnicode ? CTreeViewCtrl.TVN_DELETEITEMW : CTreeViewCtrl.TVN_DELETEITEMA
	static TVN_BEGINLABELEDIT := A_IsUnicode ? CTreeViewCtrl.TVN_BEGINLABELEDITW : CTreeViewCtrl.TVN_BEGINLABELEDITA
	static TVN_ENDLABELEDIT := A_IsUnicode ? CTreeViewCtrl.TVN_ENDLABELEDITW : CTreeViewCtrl.TVN_ENDLABELEDITA
	static TVN_GETINFOTIP := A_IsUnicode ? CTreeViewCtrl.TVN_GETINFOTIPW : CTreeViewCtrl.TVN_GETINFOTIPA
	static TVN_ITEMCHANGING := A_IsUnicode ? CTreeViewCtrl.TVN_ITEMCHANGINGW : CTreeViewCtrl.TVN_ITEMCHANGINGA
	static TVN_ITEMCHANGED := A_IsUnicode ? CTreeViewCtrl.TVN_ITEMCHANGEDW : CTreeViewCtrl.TVN_ITEMCHANGEDA
	
	__New(dwStyle, dwExStyle := 0)
	{
		Gui, Add, TreeView, HWNDhWnd %dwStyle% E%dwExStyle% hidden
		base.__New(hWnd)
	}
	CreateDragImage(hItem)
	{
		return this.SendMessage(this.TVM_CREATEDRAGIMAGE, 0, hItem)
	}
	EnsureVisible(hItem)
	{
		return this.SendMessage(this.TVM_ENSUREVISIBLE, 0, hItem)
	}
	GetItemRect(hItem, bOnlyText)
	{
		VarSetCapacity(rc, 16, 0)
		NumPut(hItem, rc, 0, "ptr")
		if (this.SendMessage(this.TVM_GETITEMRECT, bOnlyText, &rc))
		{
			return this.GetRECTObject(&rc)
		}
		return 0
	}
	GetDropHiLight()
	{
		return this.GetNextItem(0, this.TVGN_DROPHILITE)
	}
	GetNextItem(hItem, flags)
	{
		return this.SendMessage(this.TVM_GETNEXTITEM , flags, hItem)
	}
	GetNMTREEVIEWObject(ptr)
	{
		o := Object()
		o.hdr := this.GetNMHDRObject(ptr)
		o.action := NumGet(ptr + 0, A_PtrSize == 8 ? 24 : 12, "UInt")
		o.itemOld := this.GetTVITEMObject(ptr + (A_PtrSize == 8 ? 32 : 16))
		o.itemNew := this.GetTVITEMObject(ptr + (A_PtrSize == 8 ? 88 : 56)) 
		o.ptDrag := this.GetPOINTObject(ptr + (A_PtrSize == 8 ? 144 : 96)) 
		return o
	}
	GetItemText(hItem, cchTextMax := 256)
	{
		VarSetCapacity(pszText , (cchTextMax + 1) * (A_IsUnicode ? 2 : 1),0)
		mask := this.TVIF_HANDLE | this.TVIF_TEXT
		VarSetCapacity(TVITEM, A_PtrSize == 8 ? 56 : 40, 0)
		NumPut(mask, TVITEM, 0, "UInt")
		NumPut(hItem, TVITEM, A_PtrSize == 8 ? 8 : 4, "Ptr")
		;NumPut(state, TVITEM, A_PtrSize == 8 ? 16 : 8, "UInt")
		;NumPut(stateMask, TVITEM, A_PtrSize == 8 ? 20 : 12, "UInt")
		NumPut(&pszText, TVITEM, A_PtrSize == 8 ? 24 : 16, "Ptr")
		NumPut(cchTextMax, TVITEM, A_PtrSize == 8 ? 32 : 20, "Int")
		;NumPut(iImage, TVITEM, A_PtrSize == 8 ? 36 : 24, "Int")
		;NumPut(iSelectedImage, TVITEM, A_PtrSize == 8 ? 40 : 28, "Int")
		;NumPut(cChildren, TVITEM, A_PtrSize == 8 ? 44 : 32, "Int")
		;NumPut(lParam, TVITEM, A_PtrSize == 8 ? 48 : 36, "Ptr")
		if (this.SendMessage(this.TVM_GETITEM, 0, &TVITEM))
		{
			return StrGet(&pszText)		
		}
		return ""
	}
	GetTVITEMObject(ptr)
	{
		o := Object()
		o.mask := NumGet(ptr + 0, 0, "UInt")
		o.hItem := NumGet(ptr + 0, A_PtrSize == 8 ? 8 : 4, "Ptr")
		o.state := NumGet(ptr + 0, A_PtrSize == 8 ? 16 : 8, "UInt")
		o.stateMask := NumGet(ptr + 0, A_PtrSize == 8 ? 20 : 12, "UInt")
		o.pszText := NumGet(ptr + 0, A_PtrSize == 8 ? 24 : 16, "Ptr")
		o.cchTextMax := NumGet(ptr + 0, A_PtrSize == 8 ? 32 : 20, "Int")
		o.iImage := NumGet(ptr + 0, A_PtrSize == 8 ? 36 : 24, "Int")
		o.iSelectedImage := NumGet(ptr + 0, A_PtrSize == 8 ? 40 : 28, "Int")
		o.cChildren := NumGet(ptr + 0, A_PtrSize == 8 ? 44 : 32, "Int")
		o.lParam := NumGet(ptr + 0, A_PtrSize == 8 ? 48 : 36, "Ptr")
		return o
	}
	HitTest(x, y)
	{
		VarSetCapacity(TVHITTESTINFO, A_PtrSize == 8 ? 24 : 16, 0)
		NumPut(x, TVHITTESTINFO, 0, "Int")
		NumPut(y, TVHITTESTINFO, 4, "Int")
		if (this.SendMessage(this.TVM_HITTEST, 0, &TVHITTESTINFO))
		{
			o := Object()
			o.x := x
			o.y := y
			o.flags := NumGet(TVHITTESTINFO, 8, "UInt")
			o.hItem := NumGet(TVHITTESTINFO, A_PtrSize == 8 ? 16 : 12, "Ptr")
			return o
		}
		return false
	}
	InsertItem(szText, hParent, hInsertAfter, iImage, iSelectedImage)
	{
		mask := this.TVIF_TEXT | this.TVIF_IMAGE | this.TVIF_SELECTEDIMAGE
		cchTextMax := StrLen(szText)
		VarSetCapacity(TVINSERTSTRUCT, A_PtrSize == 8 ? 96 : 68, 0)
		NumPut(hParent, TVINSERTSTRUCT, 0, "Ptr")
		NumPut(hInsertAfter, TVINSERTSTRUCT, A_PtrSize == 8 ? 8 : 4, "Ptr")
		item_offset := A_PtrSize == 8 ? 16 : 8
		; TVITEM
		NumPut(mask, TVINSERTSTRUCT, item_offset + 0, "UInt")
		;NumPut(hItem, TVINSERTSTRUCT, item_offset + (A_PtrSize == 8 ? 8 : 4), "Ptr")
		;NumPut(state, TVINSERTSTRUCT, item_offset + (A_PtrSize == 8 ? 16 : 8), "UInt")
		;NumPut(stateMask, TVINSERTSTRUCT, item_offset + (A_PtrSize == 8 ? 20 : 12), "UInt")
		NumPut(&szText, TVINSERTSTRUCT, item_offset + (A_PtrSize == 8 ? 24 : 16), "Ptr")
		NumPut(cchTextMax, TVINSERTSTRUCT, item_offset + (A_PtrSize == 8 ? 32 : 20), "Int")
		NumPut(iImage, TVINSERTSTRUCT, item_offset + (A_PtrSize == 8 ? 36 : 24), "Int")
		NumPut(iSelectedImage, TVINSERTSTRUCT, item_offset + (A_PtrSize == 8 ? 40 : 28), "Int")
		;NumPut(cChildren, TVINSERTSTRUCT, item_offset + (A_PtrSize == 8 ? 44 : 32), "Int")
		;NumPut(lParam, TVINSERTSTRUCT, item_offset + (A_PtrSize == 8 ? 48 : 36), "Ptr")
		; TVITEMEX
		;NumPut(iIntegral, TVINSERTSTRUCT, item_offset + (A_PtrSize == 8 ? 56 : 40), "Int")
		;NumPut(uStateEx, TVINSERTSTRUCT, item_offset + (A_PtrSize == 8 ? 60 : 44), "UInt")
		;NumPut(hwnd, TVINSERTSTRUCT, item_offset + (A_PtrSize == 8 ? 64 : 48), "Ptr")
		;NumPut(iExpandedImage, TVINSERTSTRUCT, item_offset + (A_PtrSize == 8 ? 72 : 52), "Int")
		;NumPut(iReserved, TVINSERTSTRUCT, item_offset + (A_PtrSize == 8 ? 76 : 56), "Int")
		
		return this.SendMessage(this.TVM_INSERTITEM, 0, &TVINSERTSTRUCT)
	}
	SelectDropTarget(hItem)
	{
		return this.SelectItem(hItem, this.TVGN_DROPHILITE)
	}
	SelectItem(hItem, flags)
	{
		return this.SendMessage(this.TVM_SELECTITEM, flags, hItem)
	}
	SetImageList(himl, type)
	{
		return this.SendMessage(this.TVM_SETIMAGELIST, type, himl)
	}
}
class CListViewCtrl extends CControl
{
	static WND_CLASS := "SysListView32"
	static LVS_ICON := 0x0000
	static LVS_REPORT := 0x0001
	static LVS_SMALLICON := 0x0002
	static LVS_LIST := 0x0003
	static LVS_TYPEMASK := 0x0003
	static LVS_SINGLESEL := 0x0004
	static LVS_SHOWSELALWAYS := 0x0008
	static LVS_SORTASCENDING := 0x0010
	static LVS_SORTDESCENDING := 0x0020
	static LVS_SHAREIMAGELISTS := 0x0040
	static LVS_NOLABELWRAP := 0x0080
	static LVS_AUTOARRANGE := 0x0100
	static LVS_EDITLABELS := 0x0200
	static LVS_OWNERDATA := 0x1000
	static LVS_NOSCROLL := 0x2000
	static LVS_TYPESTYLEMASK := 0xfc00
	static LVS_ALIGNTOP := 0x0000
	static LVS_ALIGNLEFT := 0x0800
	static LVS_ALIGNMASK := 0x0c00
	static LVS_OWNERDRAWFIXED := 0x0400
	static LVS_NOCOLUMNHEADER := 0x4000
	static LVS_NOSORTHEADER := 0x8000
	static LVM_SETUNICODEFORMAT := CControl.CCM_SETUNICODEFORMAT
	static LVM_GETUNICODEFORMAT := CControl.CCM_GETUNICODEFORMAT
	static LVM_GETBKCOLOR := (CControl.LVM_FIRST + 0)
	static LVM_SETBKCOLOR := (CControl.LVM_FIRST + 1)
	static LVM_GETIMAGELIST := (CControl.LVM_FIRST + 2)
	static LVSIL_NORMAL := 0
	static LVSIL_SMALL := 1
	static LVSIL_STATE := 2
	static LVSIL_GROUPHEADER := 3
	static LVM_SETIMAGELIST := (CControl.LVM_FIRST + 3)
	static LVM_GETITEMCOUNT := (CControl.LVM_FIRST + 4)
	static LVIF_TEXT := 0x00000001
	static LVIF_IMAGE := 0x00000002
	static LVIF_PARAM := 0x00000004
	static LVIF_STATE := 0x00000008
	static LVIF_INDENT := 0x00000010
	static LVIF_NORECOMPUTE := 0x00000800
	static LVIF_GROUPID := 0x00000100
	static LVIF_COLUMNS := 0x00000200
	static LVIF_COLFMT := 0x00010000
	static LVIS_FOCUSED := 0x0001
	static LVIS_SELECTED := 0x0002
	static LVIS_CUT := 0x0004
	static LVIS_DROPHILITED := 0x0008
	static LVIS_GLOW := 0x0010
	static LVIS_ACTIVATING := 0x0020
	static LVIS_OVERLAYMASK := 0x0F00
	static LVIS_STATEIMAGEMASK := 0xF000
	static I_INDENTCALLBACK := (-1)
	static I_GROUPIDCALLBACK := (-1)
	static I_GROUPIDNONE := (-2)
	static I_IMAGECALLBACK := (-1)
	static I_IMAGENONE := (-2)
	static I_COLUMNSCALLBACK := 0xFFFFFFFF
	static LVM_GETITEMA := (CControl.LVM_FIRST + 5)
	static LVM_GETITEMW := (CControl.LVM_FIRST + 75)
	static LVM_SETITEMA := (CControl.LVM_FIRST + 6)
	static LVM_SETITEMW := (CControl.LVM_FIRST + 76)
	static LVM_INSERTITEMA := (CControl.LVM_FIRST + 7)
	static LVM_INSERTITEMW := (CControl.LVM_FIRST + 77)
	static LVM_DELETEITEM := (CControl.LVM_FIRST + 8)
	static LVM_DELETEALLITEMS := (CControl.LVM_FIRST + 9)
	static LVM_GETCALLBACKMASK := (CControl.LVM_FIRST + 10)
	static LVM_SETCALLBACKMASK := (CControl.LVM_FIRST + 11)
	static LVM_GETITEM := A_IsUnicode ? CListViewCtrl.LVM_GETITEMW : CListViewCtrl.LVM_GETITEMA
	static LVM_SETITEM := A_IsUnicode ? CListViewCtrl.LVM_SETITEMW : CListViewCtrl.LVM_SETITEMA
	static LVM_INSERTITEM := A_IsUnicode ? CListViewCtrl.LVM_INSERTITEMW : CListViewCtrl.LVM_INSERTITEMA
	static LVNI_ALL := 0x0000
	static LVNI_FOCUSED := 0x0001
	static LVNI_SELECTED := 0x0002
	static LVNI_CUT := 0x0004
	static LVNI_DROPHILITED := 0x0008
	static LVNI_STATEMASK := (CListViewCtrl.LVNI_FOCUSED | CListViewCtrl.LVNI_SELECTED | CListViewCtrl.LVNI_CUT | CListViewCtrl.LVNI_DROPHILITED)
	static LVNI_VISIBLEORDER := 0x0010
	static LVNI_PREVIOUS := 0x0020
	static LVNI_VISIBLEONLY := 0x0040
	static LVNI_SAMEGROUPONLY := 0x0080
	static LVNI_ABOVE := 0x0100
	static LVNI_BELOW := 0x0200
	static LVNI_TOLEFT := 0x0400
	static LVNI_TORIGHT := 0x0800
	static LVNI_DIRECTIONMASK := (CListViewCtrl.LVNI_ABOVE | CListViewCtrl.LVNI_BELOW | CListViewCtrl.LVNI_TOLEFT | CListViewCtrl.LVNI_TORIGHT)
	static LVM_GETNEXTITEM := (CControl.LVM_FIRST + 12)
	static LVFI_PARAM := 0x0001
	static LVFI_STRING := 0x0002
	static LVFI_SUBSTRING := 0x0004
	static LVFI_PARTIAL := 0x0008
	static LVFI_WRAP := 0x0020
	static LVFI_NEARESTXY := 0x0040
	static LVM_FINDITEMA := (CControl.LVM_FIRST + 13)
	static LVM_FINDITEMW := (CControl.LVM_FIRST + 83)
	static LVM_FINDITEM := A_IsUnicode ? CListViewCtrl.LVM_FINDITEMW : CListViewCtrl.LVM_FINDITEMA
	static LVIR_BOUNDS := 0
	static LVIR_ICON := 1
	static LVIR_LABEL := 2
	static LVIR_SELECTBOUNDS := 3
	static LVM_GETITEMRECT := (CControl.LVM_FIRST + 14)
	static LVM_SETITEMPOSITION := (CControl.LVM_FIRST + 15)
	static LVM_GETITEMPOSITION := (CControl.LVM_FIRST + 16)
	static LVM_GETSTRINGWIDTHA := (CControl.LVM_FIRST + 17)
	static LVM_GETSTRINGWIDTHW := (CControl.LVM_FIRST + 87)
	static LVM_GETSTRINGWIDTH := A_IsUnicode ? CListViewCtrl.LVM_GETSTRINGWIDTHW : CListViewCtrl.LVM_GETSTRINGWIDTHA
	static LVHT_NOWHERE := 0x00000001
	static LVHT_ONITEMICON := 0x00000002
	static LVHT_ONITEMLABEL := 0x00000004
	static LVHT_ONITEMSTATEICON := 0x00000008
	static LVHT_ONITEM := (CListViewCtrl.LVHT_ONITEMICON | CListViewCtrl.LVHT_ONITEMLABEL | CListViewCtrl.LVHT_ONITEMSTATEICON)
	static LVHT_ABOVE := 0x00000008
	static LVHT_BELOW := 0x00000010
	static LVHT_TORIGHT := 0x00000020
	static LVHT_TOLEFT := 0x00000040
	static LVHT_EX_GROUP_HEADER := 0x10000000
	static LVHT_EX_GROUP_FOOTER := 0x20000000
	static LVHT_EX_GROUP_COLLAPSE := 0x40000000
	static LVHT_EX_GROUP_BACKGROUND := 0x80000000
	static LVHT_EX_GROUP_STATEICON := 0x01000000
	static LVHT_EX_GROUP_SUBSETLINK := 0x02000000
	static LVHT_EX_GROUP := (CListViewCtrl.LVHT_EX_GROUP_BACKGROUND | CListViewCtrl.LVHT_EX_GROUP_COLLAPSE | CListViewCtrl.LVHT_EX_GROUP_FOOTER | CListViewCtrl.LVHT_EX_GROUP_HEADER | CListViewCtrl.LVHT_EX_GROUP_STATEICON | CListViewCtrl.LVHT_EX_GROUP_SUBSETLINK)
	static LVHT_EX_ONCONTENTS := 0x04000000
	static LVHT_EX_FOOTER := 0x08000000
	static LVM_HITTEST := (CControl.LVM_FIRST + 18)
	static LVM_ENSUREVISIBLE := (CControl.LVM_FIRST + 19)
	static LVM_SCROLL := (CControl.LVM_FIRST + 20)
	static LVM_REDRAWITEMS := (CControl.LVM_FIRST + 21)
	static LVA_DEFAULT := 0x0000
	static LVA_ALIGNLEFT := 0x0001
	static LVA_ALIGNTOP := 0x0002
	static LVA_SNAPTOGRID := 0x0005
	static LVM_ARRANGE := (CControl.LVM_FIRST + 22)
	static LVM_EDITLABELA := (CControl.LVM_FIRST + 23)
	static LVM_EDITLABELW := (CControl.LVM_FIRST + 118)
	static LVM_EDITLABEL := A_IsUnicode ? CListViewCtrl.LVM_EDITLABELW : CListViewCtrl.LVM_EDITLABELA
	static LVM_GETEDITCONTROL := (CControl.LVM_FIRST + 24)
	static LVCF_FMT := 0x0001
	static LVCF_WIDTH := 0x0002
	static LVCF_TEXT := 0x0004
	static LVCF_SUBITEM := 0x0008
	static LVCF_IMAGE := 0x0010
	static LVCF_ORDER := 0x0020
	static LVCF_MINWIDTH := 0x0040
	static LVCF_DEFAULTWIDTH := 0x0080
	static LVCF_IDEALWIDTH := 0x0100
	static LVCFMT_LEFT := 0x0000
	static LVCFMT_RIGHT := 0x0001
	static LVCFMT_CENTER := 0x0002
	static LVCFMT_JUSTIFYMASK := 0x0003
	static LVCFMT_IMAGE := 0x0800
	static LVCFMT_BITMAP_ON_RIGHT := 0x1000
	static LVCFMT_COL_HAS_IMAGES := 0x8000
	static LVCFMT_FIXED_WIDTH := 0x00100
	static LVCFMT_NO_DPI_SCALE := 0x40000
	static LVCFMT_FIXED_RATIO := 0x80000
	static LVCFMT_LINE_BREAK := 0x100000
	static LVCFMT_FILL := 0x200000
	static LVCFMT_WRAP := 0x400000
	static LVCFMT_NO_TITLE := 0x800000
	static LVCFMT_TILE_PLACEMENTMASK := (CListViewCtrl.LVCFMT_LINE_BREAK | CListViewCtrl.LVCFMT_FILL)
	static LVCFMT_SPLITBUTTON := 0x1000000
	static LVM_GETCOLUMNA := (CControl.LVM_FIRST + 25)
	static LVM_GETCOLUMNW := (CControl.LVM_FIRST + 95)
	static LVM_SETCOLUMNA := (CControl.LVM_FIRST + 26)
	static LVM_SETCOLUMNW := (CControl.LVM_FIRST + 96)
	static LVM_INSERTCOLUMNA := (CControl.LVM_FIRST + 27)
	static LVM_INSERTCOLUMNW := (CControl.LVM_FIRST + 97)
	static LVM_DELETECOLUMN := (CControl.LVM_FIRST + 28)
	static LVM_GETCOLUMNWIDTH := (CControl.LVM_FIRST + 29)
	static LVM_SETCOLUMNWIDTH := (CControl.LVM_FIRST + 30)
	static LVM_GETHEADER := (CControl.LVM_FIRST + 31)
	static LVM_CREATEDRAGIMAGE := (CControl.LVM_FIRST + 33)
	static LVM_GETVIEWRECT := (CControl.LVM_FIRST + 34)
	static LVM_GETTEXTCOLOR := (CControl.LVM_FIRST + 35)
	static LVM_SETTEXTCOLOR := (CControl.LVM_FIRST + 36)
	static LVM_GETTEXTBKCOLOR := (CControl.LVM_FIRST + 37)
	static LVM_SETTEXTBKCOLOR := (CControl.LVM_FIRST + 38)
	static LVM_GETTOPINDEX := (CControl.LVM_FIRST + 39)
	static LVM_GETCOUNTPERPAGE := (CControl.LVM_FIRST + 40)
	static LVM_GETORIGIN := (CControl.LVM_FIRST + 41)
	static LVM_UPDATE := (CControl.LVM_FIRST + 42)
	static LVM_SETITEMSTATE := (CControl.LVM_FIRST + 43)
	static LVM_GETITEMSTATE := (CControl.LVM_FIRST + 44)
	static LVM_GETITEMTEXTA := (CControl.LVM_FIRST + 45)
	static LVM_GETITEMTEXTW := (CControl.LVM_FIRST + 115)
	static LVM_SETITEMTEXTA := (CControl.LVM_FIRST + 46)
	static LVM_SETITEMTEXTW := (CControl.LVM_FIRST + 116)
	static LVSICF_NOINVALIDATEALL := 0x00000001
	static LVSICF_NOSCROLL := 0x00000002
	static LVM_SETITEMCOUNT := (CControl.LVM_FIRST + 47)
	static LVM_SORTITEMS := (CControl.LVM_FIRST + 48)
	static LVM_SETITEMPOSITION32 := (CControl.LVM_FIRST + 49)
	static LVM_GETSELECTEDCOUNT := (CControl.LVM_FIRST + 50)
	static LVM_GETITEMSPACING := (CControl.LVM_FIRST + 51)
	static LVM_GETISEARCHSTRINGA := (CControl.LVM_FIRST + 52)
	static LVM_GETISEARCHSTRINGW := (CControl.LVM_FIRST + 117)
	static LVM_SETICONSPACING := (CControl.LVM_FIRST + 53)
	static LVM_SETEXTENDEDLISTVIEWSTYLE := (CControl.LVM_FIRST + 54)
	static LVM_GETEXTENDEDLISTVIEWSTYLE := (CControl.LVM_FIRST + 55)
	static LVM_GETCOLUMN := A_IsUnicode ? CListViewCtrl.LVM_GETCOLUMNW : CListViewCtrl.LVM_GETCOLUMNA
	static LVM_SETCOLUMN := A_IsUnicode ? CListViewCtrl.LVM_SETCOLUMNW : CListViewCtrl.LVM_SETCOLUMNA
	static LVM_INSERTCOLUMN := A_IsUnicode ? CListViewCtrl.LVM_INSERTCOLUMNW : CListViewCtrl.LVM_INSERTCOLUMNA
	static LVM_GETITEMTEXT := A_IsUnicode ? CListViewCtrl.LVM_GETITEMTEXTW : CListViewCtrl.LVM_GETITEMTEXTA
	static LVM_SETITEMTEXT := A_IsUnicode ? CListViewCtrl.LVM_SETITEMTEXTW : CListViewCtrl.LVM_SETITEMTEXTA
	static LVM_GETISEARCHSTRING := A_IsUnicode ? CListViewCtrl.LVM_GETISEARCHSTRINGW : CListViewCtrl.LVM_GETISEARCHSTRINGA
	static LVS_EX_GRIDLINES := 0x00000001
	static LVS_EX_SUBITEMIMAGES := 0x00000002
	static LVS_EX_CHECKBOXES := 0x00000004
	static LVS_EX_TRACKSELECT := 0x00000008
	static LVS_EX_HEADERDRAGDROP := 0x00000010
	static LVS_EX_FULLROWSELECT := 0x00000020
	static LVS_EX_ONECLICKACTIVATE := 0x00000040
	static LVS_EX_TWOCLICKACTIVATE := 0x00000080
	static LVS_EX_FLATSB := 0x00000100
	static LVS_EX_REGIONAL := 0x00000200
	static LVS_EX_INFOTIP := 0x00000400
	static LVS_EX_UNDERLINEHOT := 0x00000800
	static LVS_EX_UNDERLINECOLD := 0x00001000
	static LVS_EX_MULTIWORKAREAS := 0x00002000
	static LVS_EX_LABELTIP := 0x00004000
	static LVS_EX_BORDERSELECT := 0x00008000
	static LVS_EX_DOUBLEBUFFER := 0x00010000
	static LVS_EX_HIDELABELS := 0x00020000
	static LVS_EX_SINGLEROW := 0x00040000
	static LVS_EX_SNAPTOGRID := 0x00080000
	static LVS_EX_SIMPLESELECT := 0x00100000
	static LVS_EX_JUSTIFYCOLUMNS := 0x00200000
	static LVS_EX_TRANSPARENTBKGND := 0x00400000
	static LVS_EX_TRANSPARENTSHADOWTEXT := 0x00800000
	static LVS_EX_AUTOAUTOARRANGE := 0x01000000
	static LVS_EX_HEADERINALLVIEWS := 0x02000000
	static LVS_EX_AUTOCHECKSELECT := 0x08000000
	static LVS_EX_AUTOSIZECOLUMNS := 0x10000000
	static LVS_EX_COLUMNSNAPPOINTS := 0x40000000
	static LVS_EX_COLUMNOVERFLOW := 0x80000000
	static LVM_GETSUBITEMRECT := (CControl.LVM_FIRST + 56)
	static LVM_SUBITEMHITTEST := (CControl.LVM_FIRST + 57)
	static LVM_SETCOLUMNORDERARRAY := (CControl.LVM_FIRST + 58)
	static LVM_GETCOLUMNORDERARRAY := (CControl.LVM_FIRST + 59)
	static LVM_SETHOTITEM := (CControl.LVM_FIRST + 60)
	static LVM_GETHOTITEM := (CControl.LVM_FIRST + 61)
	static LVM_SETHOTCURSOR := (CControl.LVM_FIRST + 62)
	static LVM_GETHOTCURSOR := (CControl.LVM_FIRST + 63)
	static LVM_APPROXIMATEVIEWRECT := (CControl.LVM_FIRST + 64)
	static LV_MAX_WORKAREAS := 16
	static LVM_SETWORKAREAS := (CControl.LVM_FIRST + 65)
	static LVM_GETWORKAREAS := (CControl.LVM_FIRST + 70)
	static LVM_GETNUMBEROFWORKAREAS := (CControl.LVM_FIRST + 73)
	static LVM_GETSELECTIONMARK := (CControl.LVM_FIRST + 66)
	static LVM_SETSELECTIONMARK := (CControl.LVM_FIRST + 67)
	static LVM_SETHOVERTIME := (CControl.LVM_FIRST + 71)
	static LVM_GETHOVERTIME := (CControl.LVM_FIRST + 72)
	static LVM_SETTOOLTIPS := (CControl.LVM_FIRST + 74)
	static LVM_GETTOOLTIPS := (CControl.LVM_FIRST + 78)
	static LVM_SORTITEMSEX := (CControl.LVM_FIRST + 81)
	static LVBKIF_SOURCE_NONE := 0x00000000
	static LVBKIF_SOURCE_HBITMAP := 0x00000001
	static LVBKIF_SOURCE_URL := 0x00000002
	static LVBKIF_SOURCE_MASK := 0x00000003
	static LVBKIF_STYLE_NORMAL := 0x00000000
	static LVBKIF_STYLE_TILE := 0x00000010
	static LVBKIF_STYLE_MASK := 0x00000010
	static LVBKIF_FLAG_TILEOFFSET := 0x00000100
	static LVBKIF_TYPE_WATERMARK := 0x10000000
	static LVBKIF_FLAG_ALPHABLEND := 0x20000000
	static LVM_SETBKIMAGEA := (CControl.LVM_FIRST + 68)
	static LVM_SETBKIMAGEW := (CControl.LVM_FIRST + 138)
	static LVM_GETBKIMAGEA := (CControl.LVM_FIRST + 69)
	static LVM_GETBKIMAGEW := (CControl.LVM_FIRST + 139)
	static LVM_SETSELECTEDCOLUMN := (CControl.LVM_FIRST + 140)
	static LV_VIEW_ICON := 0x0000
	static LV_VIEW_DETAILS := 0x0001
	static LV_VIEW_SMALLICON := 0x0002
	static LV_VIEW_LIST := 0x0003
	static LV_VIEW_TILE := 0x0004
	static LV_VIEW_MAX := 0x0004
	static LVM_SETVIEW := (CControl.LVM_FIRST + 142)
	static LVM_GETVIEW := (CControl.LVM_FIRST + 143)
	static LVGF_NONE := 0x00000000
	static LVGF_HEADER := 0x00000001
	static LVGF_FOOTER := 0x00000002
	static LVGF_STATE := 0x00000004
	static LVGF_ALIGN := 0x00000008
	static LVGF_GROUPID := 0x00000010
	static LVGF_SUBTITLE := 0x00000100
	static LVGF_TASK := 0x00000200
	static LVGF_DESCRIPTIONTOP := 0x00000400
	static LVGF_DESCRIPTIONBOTTOM := 0x00000800
	static LVGF_TITLEIMAGE := 0x00001000
	static LVGF_EXTENDEDIMAGE := 0x00002000
	static LVGF_ITEMS := 0x00004000
	static LVGF_SUBSET := 0x00008000
	static LVGF_SUBSETITEMS := 0x00010000
	static LVGS_NORMAL := 0x00000000
	static LVGS_COLLAPSED := 0x00000001
	static LVGS_HIDDEN := 0x00000002
	static LVGS_NOHEADER := 0x00000004
	static LVGS_COLLAPSIBLE := 0x00000008
	static LVGS_FOCUSED := 0x00000010
	static LVGS_SELECTED := 0x00000020
	static LVGS_SUBSETED := 0x00000040
	static LVGS_SUBSETLINKFOCUSED := 0x00000080
	static LVGA_HEADER_LEFT := 0x00000001
	static LVGA_HEADER_CENTER := 0x00000002
	static LVGA_HEADER_RIGHT := 0x00000004
	static LVGA_FOOTER_LEFT := 0x00000008
	static LVGA_FOOTER_CENTER := 0x00000010
	static LVGA_FOOTER_RIGHT := 0x00000020
	static LVM_INSERTGROUP := (CControl.LVM_FIRST + 145)
	static LVM_SETGROUPINFO := (CControl.LVM_FIRST + 147)
	static LVM_GETGROUPINFO := (CControl.LVM_FIRST + 149)
	static LVM_REMOVEGROUP := (CControl.LVM_FIRST + 150)
	static LVM_MOVEGROUP := (CControl.LVM_FIRST + 151)
	static LVM_GETGROUPCOUNT := (CControl.LVM_FIRST + 152)
	static LVM_GETGROUPINFOBYINDEX := (CControl.LVM_FIRST + 153)
	static LVM_MOVEITEMTOGROUP := (CControl.LVM_FIRST + 154)
	static LVGGR_GROUP := 0
	static LVGGR_HEADER := 1
	static LVGGR_LABEL := 2
	static LVGGR_SUBSETLINK := 3
	static LVM_GETGROUPRECT := (CControl.LVM_FIRST + 98)
	static LVGMF_NONE := 0x00000000
	static LVGMF_BORDERSIZE := 0x00000001
	static LVGMF_BORDERCOLOR := 0x00000002
	static LVGMF_TEXTCOLOR := 0x00000004
	static LVM_SETGROUPMETRICS := (CControl.LVM_FIRST + 155)
	static LVM_GETGROUPMETRICS := (CControl.LVM_FIRST + 156)
	static LVM_ENABLEGROUPVIEW := (CControl.LVM_FIRST + 157)
	static LVM_SORTGROUPS := (CControl.LVM_FIRST + 158)
	static LVM_INSERTGROUPSORTED := (CControl.LVM_FIRST + 159)
	static LVM_REMOVEALLGROUPS := (CControl.LVM_FIRST + 160)
	static LVM_HASGROUP := (CControl.LVM_FIRST + 161)
	static LVM_GETGROUPSTATE := (CControl.LVM_FIRST + 92)
	static LVM_GETFOCUSEDGROUP := (CControl.LVM_FIRST + 93)
	static LVTVIF_AUTOSIZE := 0x00000000
	static LVTVIF_FIXEDWIDTH := 0x00000001
	static LVTVIF_FIXEDHEIGHT := 0x00000002
	static LVTVIF_FIXEDSIZE := 0x00000003
	static LVTVIF_EXTENDED := 0x00000004
	static LVTVIM_TILESIZE := 0x00000001
	static LVTVIM_COLUMNS := 0x00000002
	static LVTVIM_LABELMARGIN := 0x00000004
	static LVM_SETTILEVIEWINFO := (CControl.LVM_FIRST + 162)
	static LVM_GETTILEVIEWINFO := (CControl.LVM_FIRST + 163)
	static LVM_SETTILEINFO := (CControl.LVM_FIRST + 164)
	static LVM_GETTILEINFO := (CControl.LVM_FIRST + 165)
	static LVIM_AFTER := 0x00000001
	static LVM_SETINSERTMARK := (CControl.LVM_FIRST + 166)
	static LVM_GETINSERTMARK := (CControl.LVM_FIRST + 167)
	static LVM_INSERTMARKHITTEST := (CControl.LVM_FIRST + 168)
	static LVM_GETINSERTMARKRECT := (CControl.LVM_FIRST + 169)
	static LVM_SETINSERTMARKCOLOR := (CControl.LVM_FIRST + 170)
	static LVM_GETINSERTMARKCOLOR := (CControl.LVM_FIRST + 171)
	static LVM_SETINFOTIP := (CControl.LVM_FIRST + 173)
	static LVM_GETSELECTEDCOLUMN := (CControl.LVM_FIRST + 174)
	static LVM_ISGROUPVIEWENABLED := (CControl.LVM_FIRST + 175)
	static LVM_GETOUTLINECOLOR := (CControl.LVM_FIRST + 176)
	static LVM_SETOUTLINECOLOR := (CControl.LVM_FIRST + 177)
	static LVM_CANCELEDITLABEL := (CControl.LVM_FIRST + 179)
	static LVM_MAPINDEXTOID := (CControl.LVM_FIRST + 180)
	static LVM_MAPIDTOINDEX := (CControl.LVM_FIRST + 181)
	static LVM_ISITEMVISIBLE := (CControl.LVM_FIRST + 182)
	static LVM_GETEMPTYTEXT := (CControl.LVM_FIRST + 204)
	static LVM_GETFOOTERRECT := (CControl.LVM_FIRST + 205)
	static LVFF_ITEMCOUNT := 0x00000001
	static LVM_GETFOOTERINFO := (CControl.LVM_FIRST + 206)
	static LVM_GETFOOTERITEMRECT := (CControl.LVM_FIRST + 207)
	static LVFIF_TEXT := 0x00000001
	static LVFIF_STATE := 0x00000002
	static LVFIS_FOCUSED := 0x0001
	static LVM_GETFOOTERITEM := (CControl.LVM_FIRST + 208)
	static LVM_GETITEMINDEXRECT := (CControl.LVM_FIRST + 209)
	static LVM_SETITEMINDEXSTATE := (CControl.LVM_FIRST + 210)
	static LVM_GETNEXTITEMINDEX := (CControl.LVM_FIRST + 211)
	static LVM_SETBKIMAGE := A_IsUnicode ? CListViewCtrl.LVM_SETBKIMAGEW : CListViewCtrl.LVM_SETBKIMAGEA
	static LVM_GETBKIMAGE := A_IsUnicode ? CListViewCtrl.LVM_GETBKIMAGEW : CListViewCtrl.LVM_GETBKIMAGEA
	static LVKF_ALT := 0x0001
	static LVKF_CONTROL := 0x0002
	static LVKF_SHIFT := 0x0004
	static LVCDI_ITEM := 0x00000000
	static LVCDI_GROUP := 0x00000001
	static LVCDI_ITEMSLIST := 0x00000002
	static LVCDRF_NOSELECT := 0x00010000
	static LVCDRF_NOGROUPFRAME := 0x00020000
	static LVN_ITEMCHANGING := (CControl.LVN_FIRST-0)
	static LVN_ITEMCHANGED := (CControl.LVN_FIRST-1)
	static LVN_INSERTITEM := (CControl.LVN_FIRST-2)
	static LVN_DELETEITEM := (CControl.LVN_FIRST-3)
	static LVN_DELETEALLITEMS := (CControl.LVN_FIRST-4)
	static LVN_BEGINLABELEDITA := (CControl.LVN_FIRST-5)
	static LVN_BEGINLABELEDITW := (CControl.LVN_FIRST-75)
	static LVN_ENDLABELEDITA := (CControl.LVN_FIRST-6)
	static LVN_ENDLABELEDITW := (CControl.LVN_FIRST-76)
	static LVN_COLUMNCLICK := (CControl.LVN_FIRST-8)
	static LVN_BEGINDRAG := (CControl.LVN_FIRST-9)
	static LVN_BEGINRDRAG := (CControl.LVN_FIRST-11)
	static LVN_ODCACHEHINT := (CControl.LVN_FIRST-13)
	static LVN_ODFINDITEMA := (CControl.LVN_FIRST-52)
	static LVN_ODFINDITEMW := (CControl.LVN_FIRST-79)
	static LVN_ITEMACTIVATE := (CControl.LVN_FIRST-14)
	static LVN_ODSTATECHANGED := (CControl.LVN_FIRST-15)
	static LVN_HOTTRACK := (CControl.LVN_FIRST-21)
	static LVN_GETDISPINFOA := (CControl.LVN_FIRST-50)
	static LVN_GETDISPINFOW := (CControl.LVN_FIRST-77)
	static LVN_SETDISPINFOA := (CControl.LVN_FIRST-51)
	static LVN_SETDISPINFOW := (CControl.LVN_FIRST-78)
	static LVIF_DI_SETITEM := 0x1000
	static LVN_KEYDOWN := (CControl.LVN_FIRST-55)
	static LVN_MARQUEEBEGIN := (CControl.LVN_FIRST-56)
	static LVGIT_UNFOLDED := 0x0001
	static LVN_GETINFOTIPA := (CControl.LVN_FIRST-57)
	static LVN_GETINFOTIPW := (CControl.LVN_FIRST-58)
	static LVN_INCREMENTALSEARCHA := (CControl.LVN_FIRST-62)
	static LVN_INCREMENTALSEARCHW := (CControl.LVN_FIRST-63)
	static LVN_COLUMNDROPDOWN := (CControl.LVN_FIRST-64)
	static LVN_COLUMNOVERFLOWCLICK := (CControl.LVN_FIRST-66)
	static LVN_BEGINSCROLL := (CControl.LVN_FIRST-80)
	static LVN_ENDSCROLL := (CControl.LVN_FIRST-81)
	static LVN_LINKCLICK := (CControl.LVN_FIRST-84)
	static EMF_CENTERED := 0x00000001
	static LVN_GETEMPTYMARKUP := (CControl.LVN_FIRST-87)
	static LVN_ODFINDITEM := A_IsUnicode ? CListViewCtrl.LVN_ODFINDITEMW : CListViewCtrl.LVN_ODFINDITEMA
	static LVN_BEGINLABELEDIT := A_IsUnicode ? CListViewCtrl.LVN_BEGINLABELEDITW : CListViewCtrl.LVN_BEGINLABELEDITA
	static LVN_ENDLABELEDIT := A_IsUnicode ? CListViewCtrl.LVN_ENDLABELEDITW : CListViewCtrl.LVN_ENDLABELEDITA
	static LVN_GETDISPINFO := A_IsUnicode ? CListViewCtrl.LVN_GETDISPINFOW : CListViewCtrl.LVN_GETDISPINFOA
	static LVN_SETDISPINFO := A_IsUnicode ? CListViewCtrl.LVN_SETDISPINFOW : CListViewCtrl.LVN_SETDISPINFOA
	static LVN_GETINFOTIP := A_IsUnicode ? CListViewCtrl.LVN_GETINFOTIPW : CListViewCtrl.LVN_GETINFOTIPA
	static LVN_INCREMENTALSEARCH := A_IsUnicode ? CListViewCtrl.LVN_INCREMENTALSEARCHW : CListViewCtrl.LVN_INCREMENTALSEARCHA
	__New(dwStyle, dwExStyle := 0)
	{
		Gui, Add, ListView, HWNDhWnd %dwStyle% E%dwExStyle% hidden
		base.__New(hWnd)
	}
	DeleteAllItems()
	{
		return this.SendMessage(this.LVM_DELETEALLITEMS, 0, 0)
	}
	DeleteColumn(iSubItem)
	{
		return this.SendMessage(this.LVM_DELETECOLUMN, iSubItem, 0)
	}
	DeleteItem(iItem)
	{
		return this.SendMessage(this.LVM_DELETEITEM , iItem, 0)
	}
	EnsureVisible(iItem, fPartialOK := false)
	{
		return this.SendMessage(this.LVM_ENSUREVISIBLE, iItem, fPartialOK)
	}
	GetColumnCount()
	{
		static HDM_GETITEMCOUNT := (CControl.HDM_FIRST + 0)
		header := new CWindow(this.SendMessage(this.LVM_GETHEADER, 0, 0))
		return header.SendMessage(HDM_GETITEMCOUNT, 0, 0)
	}
	GetItemCount()
	{
		return this.SendMessage(this.LVM_GETITEMCOUNT, 0, 0)
	}
	GetItemText(iItem, iSubItem)
	{
		cchTextMax := 256
		mask := this.LVIF_TEXT
		VarSetCapacity(szText , cchTextMax * (A_IsUnicode ? 2 : 1),0)
		VarSetCapacity(LVITEM, A_PtrSize == 8 ? 88 : 60, 0)
		NumPut(mask, LVITEM, 0, "UInt")
		NumPut(iItem, LVITEM, 4, "Int")
		NumPut(iSubItem, LVITEM, 8, "Int")
		NumPut(&szText, LVITEM, A_PtrSize == 8 ? 24 : 20, "Ptr")
		NumPut(cchTextMax, LVITEM, A_PtrSize == 8 ? 32 : 24, "Int")
		length := this.SendMessage(this.LVM_GETITEMTEXT, iItem, &LVITEM)
		return StrGet(&szText, length)
	}
	GetLVITEMObject(ptr)
	{
		o := Object()
		o.mask := NumGet(ptr + 0, 0, "UInt")
		o.iItem := NumGet(ptr + 0, 4, "Int")
		o.iSubItem := NumGet(ptr + 0, 8, "Int")
		o.state := NumGet(ptr + 0, 12, "UInt")
		o.stateMask := NumGet(ptr + 0, 16, "UInt")
		o.pszText := NumGet(ptr + 0, A_PtrSize == 8 ? 24 : 20, "Ptr")
		o.cchTextMax := NumGet(ptr + 0, A_PtrSize == 8 ? 32 : 24, "Int")
		o.iImage := NumGet(ptr + 0, A_PtrSize == 8 ? 36 : 28, "Int")
		o.lParam := NumGet(ptr + 0, A_PtrSize == 8 ? 40 : 32, "Ptr")
		o.iIndent := NumGet(ptr + 0, A_PtrSize == 8 ? 48 : 36, "Int")
		o.iGroupId := NumGet(ptr + 0, A_PtrSize == 8 ? 52 : 40, "Int")
		o.cColumns := NumGet(ptr + 0, A_PtrSize == 8 ? 56 : 44, "UInt")
		o.puColumns := NumGet(ptr + 0, A_PtrSize == 8 ? 64 : 48, "Ptr")
		o.iGroup := NumGet(ptr + 0, A_PtrSize == 8 ? 80 : 56, "Int")
		return o
	}
	GetLVDISPINFOObject(ptr)
	{
		o := Object()
		o.hdr := this.GetNMHDRObject(ptr)
		o.item := this.GetLVITEMObject(ptr + (A_PtrSize == 8 ? 24 : 12))
		return o
	}
	GetNextItem(hItem, flags)
	{
		return this.SendMessage(this.LVM_GETNEXTITEM, hItem, flags)
	}
	GetSelectedCount()
	{
		return this.SendMessage(this.LVM_GETSELECTEDCOUNT, 0, 0)
	}
	InsertColumn(iSubItem, szText, cx, fmt, addMask := 0, iImage := 0, iOrder := 0, cxMin := 0, cxDefault :=0, cxIdeal := 0)
	{
		mask := this.LVCF_SUBITEM | this.LVCF_TEXT | this.LVCF_WIDTH | this.LVCF_FMT | addMask
		cchTextMax := StrLen(szText)
		VarSetCapacity(LVCOLUMN, A_PtrSize == 8 ? 56 : 44, 0)
		NumPut(mask, LVCOLUMN, 0, "UInt")
		NumPut(fmt, LVCOLUMN, 4, "Int")
		NumPut(cx, LVCOLUMN, 8, "Int")
		NumPut(&szText, LVCOLUMN, A_PtrSize == 8 ? 16 : 12, "Ptr")
		NumPut(cchTextMax, LVCOLUMN, A_PtrSize == 8 ? 24 : 16, "Int")
		NumPut(iSubItem, LVCOLUMN, A_PtrSize == 8 ? 28 : 20, "Int")
		NumPut(iImage, LVCOLUMN, A_PtrSize == 8 ? 32 : 24, "Int")
		NumPut(iOrder, LVCOLUMN, A_PtrSize == 8 ? 36 : 28, "Int")
		NumPut(cxMin, LVCOLUMN, A_PtrSize == 8 ? 40 : 32, "Int")
		NumPut(cxDefault, LVCOLUMN, A_PtrSize == 8 ? 44 : 36, "Int")
		NumPut(cxIdeal, LVCOLUMN, A_PtrSize == 8 ? 48 : 40, "Int")
		return this.SendMessage(this.LVM_INSERTCOLUMN, iSubItem, &LVCOLUMN)
	}
	InsertItem(iItem, iSubItem, szText, iImage := 0, state := 0, stateMask :=0)
	{
		mask := this.LVIF_TEXT | this.LVIF_STATE
		uMsg := this.LVM_INSERTITEM
		if (iSubItem)
		{
			uMsg := this.LVM_SETITEMTEXT
		}
		else
		{
			mask |= this.LVIF_IMAGE
		}
		cchTextMax := StrLen(szText)
		VarSetCapacity(LVITEM, A_PtrSize == 8 ? 88 : 60, 0)
		NumPut(mask, LVITEM, 0, "UInt")
		NumPut(iItem, LVITEM, 4, "Int")
		NumPut(iSubItem, LVITEM, 8, "Int")
		NumPut(state, LVITEM, 12, "UInt")
		NumPut(stateMask, LVITEM, 16, "UInt")
		NumPut(&szText, LVITEM, A_PtrSize == 8 ? 24 : 20, "Ptr")
		NumPut(cchTextMax, LVITEM, A_PtrSize == 8 ? 32 : 24, "Int")
		NumPut(iImage, LVITEM, A_PtrSize == 8 ? 36 : 28, "Int")
		;NumPut(lParam, LVITEM, A_PtrSize == 8 ? 40 : 32, "Ptr")
		;NumPut(iIndent, LVITEM, A_PtrSize == 8 ? 48 : 36, "Int")
		;NumPut(iGroupId, LVITEM, A_PtrSize == 8 ? 52 : 40, "Int")
		;NumPut(cColumns, LVITEM, A_PtrSize == 8 ? 56 : 44, "UInt")
		;NumPut(puColumns, LVITEM, A_PtrSize == 8 ? 64 : 48, "Ptr")
		;NumPut(iGroup, LVITEM, A_PtrSize == 8 ? 80 : 56, "Int")
		return this.SendMessage(uMsg, iItem, &LVITEM)
	}
	SetImageList(himl, type)
	{
		return this.SendMessage(this.LVM_SETIMAGELIST, type, himl)
	}
	SetItemCount(cItems)
	{
		return this.SendMessage(this.LVM_SETITEMCOUNT, cItems, 0)
	}
	SetExtendedListViewStyle(dwStyles, dwMask := 0)
	{
		return this.SendMessage(this.LVM_SETEXTENDEDLISTVIEWSTYLE, dwMask, dwStyles)
	}
}
class CListView extends CListViewCtrl
{
	__New(name, options := "", row_height := 20)
	{
		this.name := name
		this.row_height := row_height
		options .= " -" CWU.WS_BORDER
		base.__New(options)
		DllCall("UxTheme.dll\SetWindowTheme", "Ptr", this.hWnd, "WStr", "Explorer", "Ptr", 0)		
		LV_SetImageList(DllCall( "ImageList_Create", Int, 1, Int, row_height , Int, 8, Int, 1, Int, 1), 1)
		;iml := new CImageList()
		;iml.Create(1, this.row_height, 8, 1, 1)
		;this.SetImageList(iml.himl, this.LVSIL_NORMAL)
	}
	Activate()
	{
		Gui, ListView, % this.hWnd
	}
	Add(options, cols*)
	{
		return this.Insert(this.GetItemCount() + 1, options, cols*)
	}
	DeleteAll()
	{
		return this.DeleteAllItems()
	}
	Delete(row)
	{
		return this.DeleteItem(row - 1)
	}
	Insert(row, options, cols*)
	{
		if (!options || Format("{:L}", options) = "select")
		{
			Loop, % cols.Length()
			{
				state := (A_Index = 1 && options) ? this.LVIS_SELECTED : 0
				this.InsertItem(row - 1, A_Index - 1, cols[A_Index], 0, state, state)
			}
		}
		else
		{
			this.Activate()
			LV_Insert(row, options, cols*)
		}
	}
	Modify(row, options, cols*)
	{
		this.Activate()
		LV_Modify(row, options, cols*)
	}
	ModifyCol(col, options, title := "")
	{
		this.Activate()
		if (title)
		{
			LV_ModifyCol(col, options, title)
		}
		else
		{
			LV_ModifyCol(col, options)
		}
	}
	InsertCol(col, options, title)
	{
		this.Activate()
		LV_InsertCol(col, options, title)
	}
	DeleteCol(col)
	{
		return this.DeleteColumn(col - 1)
	}
	GetCount(mode :="")
	{
		if (!mode)
		{
			return this.GetItemCount()
		}
		else if (RegExMatch(mode, "i)^s"))
		{
			return this.GetSelectedCount()
		}
		else if (RegExMatch(mode, "i)^col"))
		{
			return this.GetColumnCount()
		}
		return 0
	}
	GetItemText(row, col)
	{
		return base.GetItemText(row - 1, col - 1)
	}
	GetNext(StartingRowNumber := 0, RowType := "")
	{
		if (!RowType)
		{
			return this.GetNextItem(StartingRowNumber - 1, this.LVNI_SELECTED) + 1
		}
		else
		{
			this.Activate()
			return LV_GetNext(StartingRowNumber, RowType)
		}
	}
	GetSelectedRowText(col := 1)
	{
		if (this.GetSelectedCount() = 1)
		{
			return this.GetItemText(this.GetNext(0), col)
		}
		return ""
	}
	Sort(col)
	{
		this.ModifyCol(col, "Sort")
	}
	SortDesc(col)
	{
		this.ModifyCol(col, "SortDesc")
	}
	ScrollToEnd()
	{
		iItem := this.GetItemCount() - 1
		if (iItem >=0)
		{
			this.EnsureVisible(iItem)
		}
	}
}
class CExplorerView extends CControl
{
	__New(name)
	{
		static wb
		this.name := name
		Gui, Add, ActiveX, HWNDhWnd vwb, Shell.Explorer
		base.__New(hWnd)
		this.wb := wb
/*
		Gui, Add, ActiveX, hWndhWnd VScroll HScroll, about:<!DOCTYPE html><meta http-equiv='X-UA-Compatible' content='IE=Edge'>
		base.__New(hWnd)
		this.SetWebBrowser()
*/		
		this.SetWindowPos()
	}
	SetWebBrowser()
	{
		static IID_IWebBrowserApp := "{0002DF05-0000-0000-C000-000000000046}" 
		static IID_IHTMLWindow2 := "{332C4425-26CB-11D0-B483-00C04FD90119}"
		static msg := DllCall("RegisterWindowMessage", "str", "WM_HTML_GETOBJECT")
		; AtlAxWin>Shell Embedding>Shell DocObject View>Internet Explorer_Server
		wnd := new CWindow(this.GetWindow(CWU.GW_CHILD))
		wnd := new CWindow(wnd.GetWindow(CWU.GW_CHILD))
		Loop, 5
		{
			wnd_ie := new CWindow(wnd.GetWindow(CWU.GW_CHILD))
			if (wnd_ie.IsWindow())
			{
				VarSetCapacity(GUID, 16, 0)
				DllCall("ole32\CLSIDFromString", "wstr", &IID_IHTMLWindow2, "ptr",&GUID)
				lresult := wnd_ie.SendMessage(msg, 0, 0)
				pdoc := 0
				DllCall("oleacc\ObjectFromLresult", "ptr", lresult, "ptr", &GUID, "ptr", 0, "ptr*", pdoc)
				this.wb := ComObject(VT_DISPATCH := 9, ComObjQuery(pdoc, IID_IWebBrowserApp, IID_IWebBrowserApp), 1)
				ObjRelease(pdoc)
				return true
			}
			Sleep, 100
		}
		this.wb := ""
		return false
	}
	Navigate(url)
	{
		this.wb.Navigate(url)
		Loop, 100
		{
			if (this.wb.document.readyState = "complete")
			{
				return true
			}
			Sleep, 50
		}
		return false
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ModalDialog
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CAxIEEventHandler 
{
	OnKeyPress(doc) 
	{
		static keys := {1:"selectall", 3:"copy", 22:"paste", 24:"cut"}
		keyCode := doc.parentWindow.event.keyCode
		if keys.HasKey(keyCode)
			Doc.ExecCommand(keys[keyCode])
	}
}
class CModalDialog extends CWindow
{
	__New(html, w, h, title := "", center := true)
	{
		Gui, popup:+Owner1 +hWndhWnd -Resize -MaximizeBox -MinimizeBox
		Gui, popup:Add, ActiveX, hWndhWndAX x0 y0 w%w% h%h%, about:<!DOCTYPE html><meta http-equiv='X-UA-Compatible' content='IE=Edge'>
		base.__New(hWnd)
		
		Sleep, 100
		if (StrLen(html) < 256 && SubStr(html, -4) = ".html")
		{
			filepath := A_ScriptDir "/html/" html
			if (FileExist(filepath))
			{
				FileRead, html, %filepath%
			}
			else
			{
				MsgBox, %filepath% 파일이 존재하지 않습니다
				
			}
		}
		wb := WBGet("ahk_id " hWndAX)
		wb.document.open()
		wb.document.write(html)
		wb.document.close()		
		Loop, 100
		{
			if (wb.document.readyState = "complete")
			{
				break
			}
			Sleep, 50
		}
		; ComObjConnect 의 첫번째 파라미터는 static, global 변수만.
		static doc
		ComObjConnect(doc:= wb.document, new CAxIEEventHandler)		
		
		winAX := new CWindow(hWndAX)
		this.hWndIE := winAX.ControlGet("Internet Explorer_Server1")
		this.iaxie := new CIOleInPlaceActiveObject(wb)
		this.ie := wb.document.parentWindow
		this.ie._EventHandler := this._EventHandler.Bind(this)
		Gui, 1:+Disabled
		if (center)
		{
			parent := new CWindow(this.GetParent())
			pos := parent.GetPos()
			x := "x" (pos.x + pos.w / 2 - w / 2)
			y := "y" (pos.y + pos.h / 2 - h / 2)
			Gui, popup:Show, %x% %y% w%w% h%h%, %title%
		}
		else
		{
			Gui, popup:Show, w%w% h%h%, %title%
		}
		this.clicked_button := 0
		this.ID_CANCEL := 0
		this.ID_OK := 1
	}
	_EventHandler(e)
	{
		if (this["On" e.type])
		{
			this["On" e.type](e)
		}
	}
	OnClick(e)
	{
		if (e.srcElement.type = "button")
		{
			if (e.srcElement.value = "확 인")
			{
				if (!this.ApplyChange())
				{
					return
				}
				this.clicked_button := this.ID_OK
			}
			else
			{
				this.clicked_button := this.ID_CANCEL
			}
			this.PostMessage(CWU.WM_CLOSE, 0, 0)
		}
	}
	ApplyChnage()
	{
		return false
	}
	DoModal()
	{
		WinWaitClose, % this.title
		Gui, popup:Hide
		Gui, popup:Destroy
		Gui, 1:-Disabled
		Gui, 1:Show
		return this.clicked_button
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Setting & Dialogs
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CAutosenderSetting
{
	__New()
	{
		this.width := 640
		this.height := 480
		this.browser := 1
		this.fetcher := 0
		this.chrome_debugging_port := 9222
		this.cert_cooldown := 70
		this.cert_retry := 3
		this.receivers := Array()
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CAutoSenderSettingDialog extends CModalDialog
{
	__New()
	{
		w := 320
		h := 200
		html =
(
<html lang="ko">
<head>
<meta charset="utf-8">
<style>
html, body {margin:0;padding:0;overflow: hidden;font-size:12px; background-color:#F0F0F0;width:100`%;height:100`%;}
table{width:100`%;height:100`%; border-spacing:0}
.setting td:nth-child(1) {font-size:12px; width: 120px; text-align: right}
.setting td:nth-child(2) {font-size:12px; padding-left:20px}
.setting input{ border-radius: 3px; border : 1px solid #ADADAD}
.setting input[type=checkbox] {}
.setting input[type=text] {width:60px; text-align:right;}
.setting input[type=button] {font-size:12px; ; background-color:#E1E1E1;width:80px;height:25px; }
td.bottom{align:right; padding:10px;}
.separator > td {border-top: 1px solid #ADADAD;}
</style>
<script>
var setting = null;
var proptype_checkbox = {"browser" : true, "fetcher" : true, "fetcher_check_time" : true, "fetcher_filter" : true, "skip_send_logging" : true, "ex_charging_auto" : true, "ex_charging_target" : true};
function EventHandler(e)
{
	if (_EventHandler)
	{
		_EventHandler(e)
	}
}
function Init(data)
{
	if (data)
	{
		setting = JSON.parse(data);
	}
	setting.browser = 1;
	for (prop in setting)
	{
		if (proptype_checkbox[prop])
		{
			var elms = document.getElementsByClassName(prop);
			for (var i=0; i < elms.length; i++)
			{
				elms[i].checked = (i == setting[prop]);
				elms[i].addEventListener("click", OnClickCheckbox)
			}
		}
		else
		{
			var elm = document.getElementById(prop);
			if (elm)
			{
				elm.value = setting[prop];
			}		
		}	
	}
	var elms = document.getElementsByClassName("button");
	for (var i=0; i < elms.length; i++)
	{
		elms[i].addEventListener("click", EventHandler);
	}
	document.getElementById("chrome_display").style.display = (setting.browser == 0) ? "none" : "";
}
function Submit()
{
	for (prop in setting)
	{
		if (proptype_checkbox[prop])
		{
			var elms = document.getElementsByClassName(prop);
			for (var i=0; i < elms.length; i++)
			{
				if  (elms[i].checked)
				{
					setting[prop] = i;
					break;
				}
			}
			
		}
		else
		{
			var elm = document.getElementById(prop)
			if (elm)
			{
				setting[prop] = parseInt(elm.value);
			}
		}
	}
	return JSON.stringify(setting);
}
function OnClickCheckbox(e)
{
	var elms = document.getElementsByClassName(e.srcElement.className);
	for (var i=0; i < elms.length; i++)
	{
		if (elms[i] == e.srcElement)
		{
			if (elms[i].className == "browser")
			{
				document.getElementById("chrome_display").style.display = (i == 0) ? "none" : "";
			}
		}
		else
		{
			elms[i].checked = false;
		}
	}
}
</script>
</head>
<body>
<table class=setting>
  <tr>
    <td>브라우저</td>
	<td> <input type=checkbox disabled class=browser> 익스플로러 <input type=checkbox class=browser>크롬</td>
  </tr>
  <tr id=chrome_display>
    <td>크롬디버거포트</td>
	<td> <input type=text maxlength=5 id=chrome_debugging_port> (default: 9222)</td>
  </tr>
  <tr class=separator>
    <td>문자수신 어플</td>
	<td>
	   <input type=checkbox class=fetcher> 사용자 휴대폰 도우미 <br>
	   <input type=checkbox class=fetcher> 구글메시지웹<input type=checkbox class=fetcher>Pushbullet웹
	</td>
  </tr>
  <tr class=separator>
    <td>인증요청 대기시간</td>
	<td> <input type=text maxlength=3 id=cert_cooldown> 초 (최소 60)</td>
  </tr>
  <tr>
    <td>수신실패시 재요청</td>
	<td> <input type=text maxlength=1 id=cert_retry> 회</td>
  </tr>
  <tr class=separator>
	<td colspan=2 class=bottom> 
	   <input type=button class=button value="취 소">&nbsp; 
	   <input type=button class=button value="확 인">
	</td>
  </tr>
</table>
</body>
</html>
)
		base.__New(html, w, h, "설정")
	}
	DoModal(setting)
	{
		this.setting := setting
		this.ie.Init(JSON.Dump(this.setting))
		return base.DoModal()
	}
	ApplyChange()
	{
		data := this.ie.Submit()
		setting := JSON.Load(data)
		err := ""
		if (setting.cert_cooldown < 60)
		{
			err .= "인증요청 대기시간은 SK텔레콤의 제한으로 최소 60초 이상 설정해야합니다"
		}
		else if (setting.chrome_debugging_port < 1024 || setting.chrome_debuggin_port > 65535)
		{
			err .= "디버거포트는 1024 ~ 65535 범위내에서만 설정가능합니다."
		}
		if (err)
		{
			MsgBox, 0x10, 입력오류, %err%
			return false
		}
		this.setting := setting
		return true
	}	
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CReceiverInfoDialog extends CModalDialog
{
	__New(n := "", p := "", a := 0)
	{
		this.name := n
		this.phone := p
		this.amount :=a
		
		html = 
(
<html lang="ko">
<head>
<meta charset="utf-8">
<style>
body { font-size:12px; margin:0px; overflow:hidden;background-color:#F0F0F0}
table{width:300px;height:200px;}
.setting td:nth-child(1) {font-size:12px; width: 100px; text-align: center}
.setting td:nth-child(2) {font-size:12px; padding-left:20px}
.setting input[type=text] { border : 1px solid black; width:120px;}
.setting input[type=button] {font-size:12px; border : 1px solid #ADADAD; background-color:#E1E1E1;width:80px;height:25px; }
td.bottom{text-align:center;}
td.title{text-align:left; color:red;}
</style>
<script>
function EventHandler(e)
{
	if (_EventHandler)
	{
		_EventHandler(e)
	}
}
function Init(name, phone, amount)
{
	document.getElementById("name").value = name;
	document.getElementById("phone").value = phone;
	document.getElementById("amount").value = amount;
	var elms = document.getElementsByClassName("button");
	for (var i=0; i < elms.length; i++)
	{
		elms[i].addEventListener("click", EventHandler);
	}
}
function Submit()
{
	return {
	"name" : document.getElementById("name").value, 
	"phone" : document.getElementById("phone").value,
	"amount" : document.getElementById("amount").value,
	};
}
</script>
</head>
<body>
<table class=setting>
  <tr>
    <td>수신자 실명</td>
	<td><input type=text maxlength=20 id=name></td>
  </tr>
  <tr>
    <td>수신자 번호</td>
	<td> <input type=text maxlength=14 id=phone></td>
  </tr>
  <tr>
    <td>선물 용량</td>
	<td> <input type=text maxlength=4 id=amount> GB</td>
  </tr>
  <tr>
	<td colspan=2 class=bottom> 
	   	   <input type=button class=button value="취 소">&nbsp;
			<input type=button class=button value="확 인">
	</td>
  </tr>
</table>
</body>
</html>
)
		base.__New(html, 300, 200, "수신자 추가")
	}
	__Delete()
	{
	}
	DoModal()
	{
		this.ie.Init(this.name, this.phone, this.amount)
		return base.DoModal()
	}
	ApplyChange()
	{
		ret := this.ie.Submit()
		phone := RegExReplace(ret.phone, "[^\d]")
		if (StrLen(phone) != 11 && StrLen(phone) != 10)
		{
			MsgBox, 0x10, 입력오류, 전화번호 길이가 맞지않습니다.
			return false
		}
		name := ret.name
/* 외국인 사용자 위해 실명길이 체크 안함		
		name := RegExReplace(ret.name, "\s")
		if (StrLen(name) >= 5)
		{
			MsgBox, 0x10, 입력오류, 실명은 4자이하로 입력하세요.
			return false
		}
*/		
		amount := RegExReplace(ret.amount, "[^\d\.]")
		if (StrLen(amount) >= 5 || RegExMatch(amount, "\.\d{2,}"))
		{
			MsgBox, 0x10, 입력오류, 선물 용량 소수점이하 한자리까지 99기가 이하입니다.
			return false
		}
		this.phone := SubStr(phone, 1, 3) "-" SubStr(phone, 4, 4) "-" SubStr(phone, 8, 4)
		this.name := name
		this.amount := amount
		return true
	}
}	






;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; COM support & helper classes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
vt(p,n)
{
	return NumGet(NumGet(p+0,"ptr")+n*A_PtrSize,"ptr")
}
_Error(a,b)
{
	static err:={0x8000FFFF:"Catastrophic failure error.",0x80004001:"Not implemented error.",0x8007000E:"Out of memory error.",0x80070057:"One or more arguments are not valid error.",0x80004002:"Interface not supported error.",0x80004003:"Pointer not valid error.",0x80070006:"Handle not valid error.",0x80004004:"Operation aborted error.",0x80004005:"Unspecified error.",0x80070005:"General access denied error.",0x800401E5:"The object identified by this moniker could not be found."
		,0x80040201:"UIA_E_ELEMENTNOTAVAILABLE",0x80040200:"UIA_E_ELEMENTNOTENABLED",0x80131509:"UIA_E_INVALIDOPERATION",0x80040202:"UIA_E_NOCLICKABLEPOINT",0x80040204:"UIA_E_NOTSUPPORTED",0x80040203:"UIA_E_PROXYASSEMBLYNOTLOADED"} ; //not completed
	if a && (a&=0xFFFFFFFF)
	return a
}
Variant(ByRef var, type=0, val=0) 
{
	VarSetCapacity(var, 8+2*A_PtrSize)
	NumPut(type,var,0,"short")
	if (type == 8)
	{
		NumPut(DllCall("oleaut32\SysAllocString", "ptr",&val), var, 8, "ptr")
	}
	else if (type == 3)
	{
		NumPut(val, var, 8, "int")
	}
}	
class CCOMInterface
{
	__New(pi)
	{
		this.pi := pi
	}
	__Delete()
	{
		if (this.pi)
		{
			ObjRelease(this.pi)
			this.pi := ""
		}
	}
	QueryInterface(iid)
	{
		_Error(DllCall(vt(this.pi,0),"ptr",this.pi, "ptr", &iid, "ptr*", ppvObject), A_ThisFunc)
		return ppvObject
	}
	AddRef()
	{
		return _Error(DllCall(vt(this.pi,1),"ptr",this.pi), A_ThisFunc)
	}
	Release()
	{
		return _Error(DllCall(vt(this.pi,2),"ptr",this.pi), A_ThisFunc)
	}
	
}
class IUnknown 
{
    __New(methods*)
	{
		methods.InsertAt(1, "QueryInterface", "AddRef", "Release")
		this.methods := Array()
		Loop, % methods.MaxIndex()
		{
			this.AddInterfaceMethod(methods[A_Index])
		}
		this.vtbl := new CHeap(this.methods.MaxIndex() * A_PtrSize)
		Loop, % this.methods.MaxIndex()
		{
			NumPut(this.methods[A_Index].cb, this.vtbl.p, (A_Index - 1) * A_PtrSize)
		}
		this.pi := new CHeap(A_PtrSize)
        NumPut(this.vtbl.p, this.pi.p)
		this.ref_counter := 0
    }
    __Delete() 
	{
    }
	AddInterfaceMethod(name)
	{
		if (!IsFunc(this[name]))
		{
			return false
		}
		cbo := Object()
		cbo.name := name
		cbo.fn := this[name].bind(this)
		cbo.params := this[name].MinParams - 1
		cbo.cb := RegisterCallback(IUnknown.CallBack, "" , cbo.params, &cbo)
		this.methods.Push(cbo)
		return true
	}
	FreeInterfaceMethod()
	{
		Loop, % this.methods.MaxIndex()
		{
			DllCall("GlobalFree", "Ptr", this.methods[A_Index].cb, "Ptr")
		}
		this.methods := Array()
	}
	CallBack(p*)
	{
		static p_type := A_PtrSize == 4 ? "uint" : "int64"
		cbo := object(A_EventInfo)
		if (cbo.params >= 1)
		{
			args := [this]
			Loop, % (cbo.params - 1)
			{
				args.push(NumGet(p + 0 , A_PtrSize * (A_Index - 1), p_type))
			}
			return cbo.fn.call(args*)
		}
		return cbo.fn.call()
	}
    QueryInterface(riid, ppvObject) 
	{
    }
    AddRef(interface) 
	{
		this.ref_counter++
		;LogMessage(A_ThisFunc ":" this.ref_counter)
		return this.ref_counter
    }
    Release(interface) 
	{
		this.ref_counter--
		;LogMessage(A_ThisFunc ":" this.ref_counter)
		return this.ref_counter
    }
}
class CIOleInPlaceActiveObject extends CCOMInterface
{
	__New(obj)
	{
		this.iid := "{00000117-0000-0000-C000-000000000046}"
		base.__New(ComObjQuery(obj, this.iid))
	}
	TranslateAccelerator(pMsg)
	{
		_Error(DllCall(vt(this.pi, 5),"ptr",this.pi,"ptr",pMsg), A_ThisFunc)
	}
}
class CHtmlUtil
{
	__New()
	{
		Gui 1:+LastFoundExist
		if !WinExist()
		{
			Gui, New
			Gui, 1:Show
		}
		Gui, Add, ActiveX, hWndhWnd hidden, about:<!DOCTYPE html><meta http-equiv='X-UA-Compatible' content='IE=Edge'>
		this.wb := WBGet("ahk_id " hWnd)
		this.wb.document.open()
		this.wb.document.write("")
		this.wb.document.close()
	}
	Escape(str)
	{
		return this.wb.document.parentWindow.escape(str)
	}
	Unescape(str)
	{
		return this.wb.document.parentWindow.unescape(str)
	}
	ReplaceHtmlSpeicalChars(str)
	{
		this.SetBody(str)
		return this.wb.document.body.innerText
	}
	SetBody(html)
	{
		this.wb.document.body.innerHTML := html
	}
	GetTable(html, index)
	{
		this.SetBody(html)
		elms := this.wb.document.body.getElementsByTagName("table")
		if (elms && elms.length > index)
		{
			return elms[index]
		}
		return ""
	}
	GetTableData(html)
	{
		this.SetBody(html)
		elms := this.wb.document.body.getElementsByTagName("table")
		data := Array()
		if (elms)
		{
			Loop, % elms.length
			{
				table := elms[A_Index - 1]
				rows := Array()
				Loop, % table.rows.length
				{
					cells := Array()
					row := A_Index - 1
					Loop, % table.rows[row].cells.length
					{
						cells.Push(table.rows[row].cells[A_Index - 1].innerText)
					}
					rows.Push(cells)
				}
				data.Push(rows)
			}
		}
		return data
	}
}

StrPutVar(str, ByRef var, enc = "")
{
	len := StrPut(str, enc) * (enc = "UTF-16" || enc = "CP1200" ? 2 : 1)
	VarSetCapacity(var, len, 0)
	return StrPut(str, &var, enc)
}
UriEncode(uri, enc = "UTF-8")
{
	StrPutVar(uri, var, enc)
	f := A_FormatInteger
	SetFormat, IntegerFast, H
	res := ""
	Loop
	{
		code := NumGet(var, A_Index - 1, "UChar")
		if (!code)
			break
		if (code >= 0x30 && code <= 0x39 ; 0-9
			|| code >= 0x41 && code <= 0x5A ; A-Z
			|| code >= 0x61 && code <= 0x7A) ; a-z
			res .= Chr(code)
		else
			res .= "%" . SubStr(code + 0x100, -1)
	}
	SetFormat, IntegerFast, %f%
	return res
}
UriDecode(uri, enc = "UTF-8")
{
	pos := 1
	Loop
	{
		pos := RegExMatch(uri, "i)(?:%[\da-f]{2})+", code, pos++)
		if (pos = 0)
			break
		VarSetCapacity(var, StrLen(code) // 3, 0)
		StringTrimLeft, code, code, 1
		Loop, Parse, code, `%
			NumPut("0x" . A_LoopField, var, A_Index - 1, "UChar")
		StringReplace, uri, uri, `%%code%, % StrGet(&var, enc), All
	}
	return uri
}

class CFormData
{
	__New()
	{
		this.data := Object()
	}
	Set(key, val)
	{
		this.data[key] := val
	}
	GetData()
	{
		data := ""
		for key, val in this.data
		{
			data .= key "=" UriEncode(val) "&"
		}
		return Trim(data, "&")
	}
}

class CHTTP
{
	__New()
	{
		;this.http := ComObjCreate(A_OSVersion = "WIN_7" ? "Msxml2.ServerXMLHTTP.6.0" : "WinHttp.WinHttpRequest.5.1")
		this.http := ComObjCreate("WinHttp.WinHttpRequest.5.1")
		this.Win7WinHttpTLS12Support()
	}
	__Delete()
	{
		if (this.http)
		{
			ObjRelease(this.http)
		}
	}
	Win7WinHttpTLS12Support()
	{
		; WIN_7 에서 WinHttp.WinHttpRequest.5.1로 httprequest 할 경우 TLS 1.2 보안채널 사용하게 하기위한 코드 백업. 
		; TLS 1.2 미만은 최신 서버, 브라우저들에서 더이상 사용되지 않는데 win 7 winhttp에선 tls 1.2가 default 로 사용되지 않는다.
		if (A_OSVersion != "WIN_7")
			return
		RegRead, DefaultSecureProtocols, HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\WinHttp, DefaultSecureProtocols
		if !(DefaultSecureProtocols & 0x800)
		{
			if (A_IsAdmin)
			{
				commandLine := DllCall("GetCommandLine", "str")
				isRestarted := !!RegExMatch(commandLine, " /restart(?!\S)")
				if (A_Is64bitOS)
				{
					RegWrite, REG_DWORD, HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Internet Settings\WinHttp, DefaultSecureProtocols, 0xA00
				}
				RegWrite, REG_DWORD, HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\WinHttp, DefaultSecureProtocols, 0xA00
				if (isRestarted)
				{
					MsgBox, 레지스트리값을 설정완료후 프로그램을 종료합니다. 일반권한으로 자동입력기를 다시 실행해주세요.
					ExitApp
				}
			}
			else 
			{
				msg := "윈도우 7 사용자는 WinHttp를 사용하려면 기본 보안 프로토콜을 TLS 1.2로 설정해야합니다. `n`n"
				msg .= "윈도우 8 이상부터는 TLS 1.2 이상이 기본이고 인터넷접속시 보안이 더 강화되는 설정입니다.`n"
				msg .= "최근 웹서버들은 보안에 취약한 프로토콜을 사용하면 접속자체를 거부해서 업데이트 기능을 사용할 수 없습니다. `n"
				msg .= "관련 정보는 아래 사이트에서 확인할수 있습니다`n`n"
				msg .= "https://docs.microsoft.com/ko-kr/mem/configmgr/core/plan-design/security/enable-tls-1-2-client`n`n"
				msg .= "지금 관리자권한으로 자동 설정하시겠습니까?"
				MsgBox, 4, WinHttp 보안프로토콜 설정, %msg%
				IfMsgBox, Yes
				{
					MsgBox, 관리자권한으로 다시 실행합니다. 프로그램이 재시작한 후 WinHttp사용(도움말->업데이트 확인)을 수작업으로 다시 해주셔야 설정이 완료됩니다.
					if A_IsCompiled
						Run *RunAs "%A_ScriptFullPath%" /restart
					else
						Run *RunAs "%A_AhkPath%" /restart "%A_ScriptFullPath%"
					ExitApp
				}
				else
				{
					MsgBox, 직접 HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\WinHttp아래에 DWORD키 DefaultSecureProtocols의 값을 16진수 A00 (10진수 2560) 으로 생성 혹은 설정해주세요.
				}
			}
		}
	}
	Get(url)
	{
		this.http.setTimeouts(1000, 1000, 1000, 1000)
		try
		{
			this.http.open("GET", url, False)
			if (A_OSVersion = "WIN_7")
			{
				; Msxml2.XMLHTTP 에서는 max-age=0 가 안 먹힘.
				this.http.setRequestHeader("Pragma", "no-cache")
				this.http.setRequestHeader("Cache-Control", "no-cache, no-store")
				this.http.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT")
			}
			else
			{
				this.http.setRequestHeader("Cache-Control", "max-age=0")
			}
			this.http.Send()
			return this.http.responseText
		}
		catch e
		{
			msg := e.Message
			MsgBox, %msg%
		}
		return ""
	}
	Post(url, form_urlencoded, file := "")
	{
		this.http.open("POST", url, false)
		this.http.setRequestHeader("Content-Type", "application/x-www-form-urlencoded")
		this.http.send(form_urlencoded)
		if (file && this.http.getResponseHeader("Content-Type") = "application/octet-stream")
		{
			ado := ComObjCreate("ADODB.Stream")
			ado.Type := 1 ; adTypeBinary
			ado.Open()
			ado.Write(this.http.responseBody)
			ado.SaveToFile(file, 2)
			ado.Close()			
			ObjRelease(ado)
			return file
		}
		return this.http.responseText
	}	
}
class CCUIAutomation extends CCOMInterface
{
	static CoreWindow_Pos := 1
	static TreeScope_Element := 1
	static TreeScope_Children := 2
	static TreeScope_Descendants := 3
	static TreeScope_Parent := 4
	static TreeScope_Ancestors := 5
	static TreeScope_Subtree := 6
	static UIA_InvokePatternId := 10000
	static UIA_ValuePatternId	:=	10002
	static UIA_ScrollPatternId := 10004
	static UIA_ScrollItemPatternId	:=	10017
	static UIA_LegacyIAccessiblePatternId	:=	10018
	static UIA_ControlTypePropertyId	:=	30003
	static UIA_LocalizedControlTypePropertyId	:=	30004
	static UIA_NamePropertyId	:=	30005	
	static UIA_ClassNamePropertyId	:=	30012
	static UIA_AutomationIdPropertyId	:=	30011
	static UIA_ButtonControlTypeId	:=	50000
	static UIA_CheckBoxControlTypeId	:=	50002
	static UIA_EditControlTypeId	:=	50004
	static UIA_ImageControlTypeId	:=	50006
	static UIA_ListItemControlTypeId	:=	50007
	static UIA_ListControlTypeId	:=	50008
	static UIA_GroupControlTypeId := 50026
	static UIA_DocumentControlTypeId := 50030
	static UIA_PaneControlTypeId	:=	50033
	__New()
	{
		this.clsid := "{ff48dba4-60ef-4201-aa87-54103eef594e}"
		this.iid := "{30cbe57d-d9d0-452a-ab13-7ac5ac4825ee}"
		base.__New(ComObjCreate(this.clsid, this.iid))
	}
	GetRootElement()
	{
		_Error(DllCall(vt(this.pi,5),"ptr",this.pi,"ptr*", element := 0), A_ThisFunc)
		return element
	}
	
	ElementFromHandle(hWnd)
	{
		_Error(DllCall(vt(this.pi, 6),"ptr",this.pi,"ptr",hWnd,"ptr*",element := 0), A_ThisFunc)
		return element
	}
	CreateTrueCondition()
	{
		_Error(DllCall(vt(this.pi, 21),"ptr",this.pi,"ptr*",newCondition := 0), A_ThisFunc)
		return newCondition
	}
	CreatePropertyCondition(propertyId, value, type := 8)
	{
		Variant(var, type, value)
		_Error(DllCall(vt(this.pi, 23), "ptr", this.pi, "int", propertyId,  "ptr", &var, "ptr*",newCondition := 0), A_ThisFunc)
		return newCondition
	}
	CreateAndCondition(condition1, condition2)
	{
		_Error(DllCall(vt(this.pi, 25), "ptr", this.pi, "ptr", condition1, "ptr", condition2, "ptr*",newCondition := 0), A_ThisFunc)
		return newCondition
	}
}
class CIUIAutomationElement extends CCOMInterface
{
	Click()
	{
		rc := this.CurrentBoundingRectangle()
		x := rc.left + Floor((rc.right-rc.left) / 2)
		y := rc.top + Floor((rc.bottom-rc.top) / 2)
		mode := A_CoordModeMouse
		CoordMode, Mouse, Screen
		MouseClick, left, x, y
		CoordMode, Mouse, %mode%
	}
	SetFocus()
	{
		return _Error(DllCall(vt(this.pi,3),"ptr",this.pi), A_ThisFunc)
	}
	FindAll(scope, condition)
	{
		_Error(DllCall(vt(this.pi, 6),"ptr",this.pi,"int",scope,"ptr",condition,"ptr*",found := 0), A_ThisFunc)
		return found
	}
	GetCurrentPattern(patternId)
	{
		_Error(DllCall(vt(this.pi,16),"ptr",this.pi,"int",patternId,"ptr*",patternObject := 0), A_ThisFunc)
		return patternObject
	}
	CurrentControlType()
	{
		_Error(DllCall(vt(this.pi,21),"ptr",this.pi,"uint*", type := 0), A_ThisFunc)
		return type
	}
	CurrentName()
	{
		_Error(DllCall(vt(this.pi, 23),"ptr",this.pi,"ptr*",retVal := 0), A_ThisFunc)
		return StrGet(retVal,"utf-16")
	}
	CurrentHasKeyboardFocus()
	{
		_Error(DllCall(vt(this.pi,26),"ptr",this.pi,"int*",retVal := 0), A_ThisFunc)
		return retVal
	}
	CurrentAutomationId()
	{
		_Error(DllCall(vt(this.pi, 29),"ptr",this.pi,"ptr*",retVal := 0), A_ThisFunc)
		return StrGet(retVal,"utf-16")
	}
	ClassName()
	{
		_Error(DllCall(vt(this.pi, 30),"ptr",this.pi,"ptr*",retVal := 0), A_ThisFunc)
		return StrGet(retVal,"utf-16")
	}
	CurrentNativeWindowHandle()
	{
		_Error(DllCall(vt(this.pi, 36),"ptr",this.pi,"ptr*",retVal := 0), A_ThisFunc)
		return retVal
	}
	CurrentBoundingRectangle()
	{
		VarSetCapacity(rect, 16, 0)
		_Error(DllCall(vt(this.pi, 43),"ptr",this.pi,"ptr", &rect), A_ThisFunc)
		return CWindow.GetRECTObject(&rect)
	}
	GetChildren(condition)
	{
		return this.FindAll(CCUIAutomation.TreeScope_Children, condition)
	}
	GetChild(index, condition)
	{
		children := new CIUIAutomationElementArray(this.GetChildren(condition))
		if (children.GetLength() > index)
		{
			return children.GetElement(index)
		}
		return 0
	}
}
class CIUIAutomationElementArray extends CCOMInterface
{
	GetLength()
	{
		_Error(DllCall(vt(this.pi, 3),"ptr",this.pi,"int*",length := 0), A_ThisFunc)
		return length
	}
	GetElement(index)
	{
		_Error(DllCall(vt(this.pi, 4),"ptr",this.pi,"int",index,"ptr*",element := 0), A_ThisFunc)
		return element
	}
}
class CIUIAutomationScrollPattern extends CCOMInterface
{
	Scroll(horizontalAmount,verticalAmount)
	{
		return _Error(DllCall(vt(this.pi,3),"ptr",this.pi,"int",horizontalAmount,"int",verticalAmount), A_ThisFunc)
	}
	SetScrollPercent(horizontalPercent,verticalPercent)
	{
		return _Error(DllCall(vt(this.pi,4),"ptr",this.pi,"double",horizontalPercent,"double",verticalPercent), A_ThisFunc)
	}
	CurrentVerticalScrollPercent()
	{
		_Error(DllCall(vt(this.pi,6),"ptr",this.pi,"double*",retVal := 0), A_ThisFunc)
		return retVal
	}
	CurrentVerticalViewSize()
	{
		_Error(DllCall(vt(this.pi,8),"ptr",this.pi,"double*",retVal := 0), A_ThisFunc)
		return retVal
	}
	CurrentVerticallyScrollable()
	{
		_Error(DllCall(vt(this.pi,10),"ptr",this.pi,"int*",retVal := 0), A_ThisFunc)
		return retVal
	}
	ScrollVerticalTop()
	{
		if (this.CurrentVerticallyScrollable())
		{
			this.SetScrollPercent(-1, 0)
		}
	}
	ScrollVerticalBottom()
	{
		if (this.CurrentVerticallyScrollable())
		{
			this.SetScrollPercent(-1, 100)
		}
	}
	ScrollVerticalNext(vm := 1)
	{
		if (this.CurrentVerticallyScrollable())
		{
			current := this.CurrentVerticalScrollPercent()
			viewsize := this.CurrentVerticalViewSize()
			if ((current + viewsize) >= 100)
			{
				return false
			}
			next := current + viewsize * vm
			if (next > 100)
			{
				next := 100
			}
			this.SetScrollPercent(-1, next)
			return true
		}
		return false
	}
}
class CIUIAutomationInvokePattern extends CCOMInterface
{
	Invoke()
	{
		return _Error(DllCall(vt(this.pi,3),"ptr",this.pi), A_ThisFunc)
	}
}
class CIUIAutomationScrollItemPattern extends CCOMInterface
{
	ScrollIntoView()
	{
		return _Error(DllCall(vt(this.pi,3),"ptr",this.pi), A_ThisFunc)
	}
}
class CIUIAutomationValuePattern extends CCOMInterface
{
	SetValue(value, type := 8)
	{
		Variant(var, type, value)
		return _Error(DllCall(vt(this.pi,3),"ptr",this.pi, "ptr", &var), A_ThisFunc)
	}
}
class CIUIAutomationLegacyIAccessiblePattern extends CCOMInterface
{
	Select(flagsSelect)
	{
		return _Error(DllCall(vt(this.pi,3),"ptr",this.pi, "int", flagsSelect), A_ThisFunc)
	}
	DoDefaultAction()
	{
		return _Error(DllCall(vt(this.pi,4),"ptr",this.pi), A_ThisFunc)
	}
	CurrentName()
	{
		_Error(DllCall(vt(this.pi, 7),"ptr",this.pi,"ptr*",retVal := 0), A_ThisFunc)
		return StrGet(retVal,"utf-16")
	}
	CurrentDescription()
	{
		_Error(DllCall(vt(this.pi, 9),"ptr",this.pi,"ptr*",retVal := 0), A_ThisFunc)
		return StrGet(retVal,"utf-16")
	}
}



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Chrome 기반 브라우저 지원 클래스들
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CChrome extends CWindow
{
	__New(port := 0, newtab := false)
	{
		if (port = 0)
		{
			base.__New("ahk_class Chrome_WidgetWin_1")
		}
		this.id := 1
		this.port := port
		this.exename := "chrome"
		this.lnkname := "Chrome"
		this.korname := "크롬"
		this.titlesuffix := "Chrome"
		this.html := new CHtmlUtil()
		this.newtab := newtab
		this.bLaunched := false
	}
	__Delete()
	{
		if (this.wb)
		{
			this.wb.Disconnect()
		}
		this.wb := ""
	}
	ClickById(id)
	{
		result := this.wb.Evaluate("document.getElementById('" id "').click()")
		if (result)
		{
			return true
		}
		return false
	}
	ClickByClassName(name)
	{
		result := this.wb.Evaluate("var ret = 0; var o=document.getElementsByClassName('" name "'); if (o.length ==1){o[0].click(); ret=1;} ret;")
		return result.value
	}
	Close()
	{
		this.wb.Disconnect()
		this.wb := ""
		base.Close()
	}
	CopyHtml()
	{
		if (this.IsComplete())
		{
			location := "document.location.href"
			result := this.wb.Evaluate(location)
			html := "====================================================`r`n"
			html .= location " = " result.value "`r`n"
			html .= "====================================================`r`n"
			result := this.wb.Evaluate("escape(document.body.parentElement.outerHTML)")
			html .= this.Unescape(result.value) "`r`n"
			clipboard := html
		}
	}
	CopyFrameHtml(nFrame)
	{
		if (this.IsFrameComplete(nFrame))
		{
			result := this.wb.Evaluate("escape(frames[" (nFrame - 1) "].document.body.parentElement.outerHTML)")
			clipboard := this.Unescape(result.value)
		}
	}
	Exist()
	{
		if (this.port)
		{
			for proc in ComObjGet("winmgmts:").ExecQuery("Select * from Win32_Process where name='" this.exename ".exe'")
			{
				if (InStr(proc.CommandLine, "--remote-debugging-port=" this.port " --user-data-dir"))
				{
					this.title := "ahk_pid " proc.ProcessId
					return base.Exist()
				}
			}
		}
		else
		{
			return base.Exist()
		}
		return false
	}
	GetBrowserInfo()
	{
		if (this.wb)
		{
			result := this.wb.GetVersion()
			return result.userAgent
		}
		return ""
	}
	GetWebSocketUrl(value, byUrl := false)
	{
		; 크롬 디버거용 로컬서버에서 디버깅주소가져오기임. 모두 로컬주소로 외부서버로 나가는 일 없음
		http := new CHTTP()
		list := JSON.Load(http.Get("http://127.0.0.1:" this.port "/json/list"))
		if (!list)
		{
			return -1
		}
		Loop, % list.MaxIndex()
		{
			if (byUrl)
			{
				if (InStr(list[A_Index].url, value))
				{
					return list[A_Index].webSocketDebuggerUrl
				}
			}
			else 
			{
				if (value = list[A_Index].title || this.html.ReplaceHtmlSpeicalChars(list[A_Index].title) = value)
				{
					return list[A_Index].webSocketDebuggerUrl
				}
			}
		}
		return ""
	}
	GetBoundingClientRectById(id)
	{
		result := this.wb.Evaluate("JSON.stringify(document.getElementById('" id "').getBoundingClientRect())")
		if (result.value)
		{
			return JSON.Load(result.value)
		}
		return ""
	}
	GetBoundingClientRectByClassName(name, idx := 0)
	{
		result := this.wb.Evaluate("JSON.stringify(document.getElementsByClassName('" name "')[" idx "].getBoundingClientRect())")
		if (result.value)
		{
			return JSON.Load(result.value)
		}
		return ""
	}
	
	GetRenderWidgetHostBoundingRect()
	{
		this.Activate()
		uia := new CCUIAutomation()
		app := new CIUIAutomationElement(uia.ElementFromHandle(this.hWnd))
		if (!app.pi)
		{
			return false
		}
		if (this.korname = "엣지")
		{
			cond_doc := uia.CreatePropertyCondition(CCUIAutomation.UIA_ControlTypePropertyId, CCUIAutomation.UIA_DocumentControlTypeId, 3)
			results := new CIUIAutomationElementArray(app.FindAll(CCUIAutomation.TreeScope_Subtree, cond_doc))
			if (results.GetLength())
			{
				return new CIUIAutomationElement(results.GetElement(0)).CurrentBoundingRectangle()
			}
			return false
		}
		cond_classname := uia.CreatePropertyCondition(CCUIAutomation.UIA_ClassNamePropertyId, "Chrome_RenderWidgetHostHWND")
		results := new CIUIAutomationElementArray(app.FindAll(CCUIAutomation.TreeScope_Children, cond_classname))
		
		if (results.GetLength() >= 1)
		{
			render := new CIUIAutomationElement(results.GetElement(0))
			return render.CurrentBoundingRectangle()
		}
		return false
	}
	ClickPopupButton(name)
	{
		uia := new CCUIAutomation()
		app := new CIUIAutomationElement(uia.ElementFromHandle(this.hWnd))
		if (!app.pi)
		{
			return false
		}
		cond_name := uia.CreatePropertyCondition(CCUIAutomation.UIA_NamePropertyId, name)
		cond_controltype := uia.CreatePropertyCondition(CCUIAutomation.UIA_ControlTypePropertyId, CCUIAutomation.UIA_ButtonControlTypeId, 3)
		cond := uia.CreateAndCondition(cond_name, cond_controltype)
		results := new CIUIAutomationElementArray(app.FindAll(CCUIAutomation.TreeScope_Subtree, cond))
		if (results.GetLength() = 1)
		{
			button := new CIUIAutomationElement(results.GetElement(0))
			button.Click()
			return true
		}
		return false
	}
	Init(url)
	{
		this.err := ""
		if (hWnd := this.Exist())
		{
			base.__New(hWnd)
		}
		else
		{
			this.err := "개발자모드로 실행된 " this.korname "창이 존재하지 않습니다. " this.korname "을 개발자모드로 실행합니다. `r`n"
			if (!this.Launch(this.port))
			{
				this.err .= "개발자모드로 실행된 " this.korname "창이 존재하지 않습니다"
				return false
			}
		}
		ws_url := this.GetWebSocketUrl(url, true)
		if (ws_url = -1)
		{
			this.err := this.korname " DevTool의 /json/list 엔드포인트에 연결할수 없습니다."
			return false
		}
		
		if (this.wb)
		{
			if (this.wb.url = ws_url && this.wb.bConnected)
			{
				return true
			}
			this.wb.Disconnect()
			this.wb := ""
		}
		this.bExistingTarget := false
		if (ws_url)
		{
			this.wb := new CChromeWSClient(ws_url)
			this.bExistingTarget := true
			this.wb.ActivateTarget()
			return true
		}
		if (InStr(this.GetTitle(), "새 탭") || InStr(this.GetTitle(), "New Tab"))
		{
			title := this.GetTitle()
			if (RegExMatch(title, " - " this.titlesuffix "$"))
			{
				title := RegExReplace(title, " - " this.titlesuffix "$")
			}
			else
			{
				title := RegExReplace(title, " - .+$")
			}
			ws_url := this.GetWebSocketUrl(title)
			if (ws_url)
			{
				this.wb := new CChromeWSClient(ws_url)
			}
			else
			{
				return false
			}
		}
		else if (!this.OpenNewTab())
		{
			this.err .= "새 탭을 열지못함"
			return false
		}
		if (this.wb.Navigate(url))
		{
			this.WaitComplete()
			return true
		}
		this.err .= url " 로 navigate 실패"
		return false
	}
	Launch(port := 0)
	{
		if (port)
		{
			this.SetPort(port)
		}
		exe := this.exename
		lnk := this.lnkname
		RegRead, path, HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\%exe%.exe
		if (!path)
		{
			FileGetShortcut, %A_StartMenuCommon%\Programs\%lnk%.lnk, path
			if (!path)
			{
				FileGetShortcut, %A_StartMenu%\Programs\%lnk%.lnk, path
			}
		}
		if (FileExist(path))
		{
			this.path := path
		}
		else
		{
			MsgBox, , %lnk% Error, "설치된 경로를 찾을수 없습니다"
			return false
		}
		profile := InStr(A_ScriptName, "autocoder") ? "profile_autocoder" : "profile"
		target := this.path (this.port ? " --remote-debugging-port=" this.port " --user-data-dir=""" A_ScriptDir "\" exe profile """" : "")
		Run, %target%, , , pid
		this.bLaunched := true
		this.title := "ahk_pid " pid
		Loop, 10
		{
			Sleep, 200
			if (this.Exist())
			{
				this.Reset()
				return true
			}
			else
			{
			}
		}
		return false
	}
	Navigate(url)
	{
		if (!this.port)
		{
			; Non debug mode
			if (!this.Exist())
			{
				return false
			}
			this.Activate()
			if (this.GetTitle() != ("새 탭 - " this.titlesuffix))
			{
				Send, ^t
			}
			Send, %url%
			Send, {Enter}
			return true
		}
		if (!this.wb)
		{
			if (this.Init(url))
			{
				this.ResetBrowserWindow()
				this.WaitComplete()
				return true
			}
			else
			{
				MsgBox, % this.err
				return false
			}
		}
		result := this.wb.Navigate(url)
		if (result && this.WaitComplete(200))
		{
			return true
		}
		return false
	}
	ResetBrowserWindow(target := 0)
	{
		if (!target)
		{
			target := this.wb.GetWindowForTarget()
		}
		if (A_ScreenDPI != 96)
		{
			m := A_ScreenDPI / 96
			for key, val in target.bounds
			{
				target.bounds[key] := Floor(target.bounds[key] * m)
			}
		}

		uia := new CCUIAutomation()
		root := new CIUIAutomationElement(uia.GetRootElement())
		cond_classname := uia.CreatePropertyCondition(CCUIAutomation.UIA_ClassNamePropertyId, "Chrome_WidgetWin_1")
		children := new CIUIAutomationElementArray(root.FindAll(CCUIAutomation.TreeScope_Children, cond_classname))
		hWnds := Array()
		Loop, % children.GetLength()
		{
			child := new CIUIAutomationElement(children.GetElement(A_Index -1))
			bounds := child.CurrentBoundingRectangle()
			bounds.width := bounds.right - bounds.left
			bounds.height := bounds.bottom - bounds.top

			if (bounds.left = target.bounds.left && bounds.top = target.bounds.top && bounds.width = target.bounds.width && bounds.height = target.bounds.height)
			{
				SetFormat, Integer, hex
				hWnd := child.CurrentNativeWindowHandle()
				SetFormat, Integer, d
				hWnds.Push(hWnd)
			}
		}
		if (!hWnds.Count())
		{
			return true
		}
		if (hWnds.Count() = 1)
		{
			base.__New(hWnds[1])
			return true
		}
		
		target.bounds.left += 1
		target.bounds.top += 1
		result := this.wb.SetWindowBounds(result.windowId, target.bounds)
		return this.ResetBrowserWindow()
	}	
	OpenNewTab()
	{
		this.wb.Disconnect()
		this.wb := ""
		this.Activate()
		Send, ^t
		Sleep, 200
		ws_url := this.WaitWebSocketUrl("새 탭")
		if (ws_url && ws_url != -1)
		{
			this.wb := new CChromeWSClient(ws_url)
			return true
		}
		return false
	}
	SetPort(port)
	{
		this.port := port
	}
	Unescape(value)
	{
		return this.html.Unescape(value)
	}
	IsComplete()
	{
		result := this.wb.Evaluate("document.readyState")
		return (result && result.value = "complete")
	}
	IsFrameComplete(nFrame)
	{
		result := this.wb.Evaluate("frames[" (nFrame - 1) "].document.readyState")
		return (result && result.value = "complete")
	}
	WaitComplete(iWait := 0, iTimeOut := 5000, iSleep := 100)
	{
		if (iWait)
		{
			Sleep, %iWait%
		}
		iLoop := Floor(iTimeOut / iSleep)
		Loop, %iLoop%
		{
			if (this.IsComplete())
			{
				return true
			}
			Sleep, %iSleep%
		}
		return false
	}	
	WaitTitle(title)
	{
		Loop, 10
		{
			Sleep, 500
			if (InStr(this.GetTitle(), title))
			{
				this.WaitComplete()
				return true
			}
		}
		return false
	}
	WaitWebSocketUrl(title)
	{
		Loop, 10
		{
			Sleep, 100
			url := this.GetWebSocketUrl(title)
			if (url)
			{
				return url
			}
		}
		return ""
	}
}
class CMicrosoftEdge extends CChrome
{
	__New(port := 0)
	{
		base.__New(port)
		this.id := 2
		this.exename := "msedge"
		this.lnkname := "Microsoft Edge"
		this.korname := "엣지"
		this.titlesuffix := "개인 - Microsoft​ Edge"
	}
}
class CNaverWhale extends CChrome
{
	__New(port := 0)
	{
		base.__New(port)
		this.id := 3
		this.exename := "whale"
		this.lnkname := "네이버 웨일"
		this.korname := "웨일"
		this.titlesuffix := "Whale"
	}
}
; WebSocket Protocol Component API 로 대체예정
;https://docs.microsoft.com/ko-kr/windows/win32/api/_websock/
class CWebSocket extends CWindow
{
	; 크롬 로컬 디버거 서버랑 WebSocket통신을 하기위한 용도로 익스플로러 ActiveX를 하는 호스팅하는 것임
	; 데이터교환흐름 AHK자동입력기<->익스플로러 로컬페이지<->크롬 로컬디버거서버
	__New(url)
	{
		static id := 0
		this.url := url
		guiname := "WebSocket" id++
		this.guiname := guiname
		
		Gui, %guiname%:+Owner1 +hWndhWnd
		Gui, %guiname%:Add, ActiveX, hWndhWndAX, about:<!DOCTYPE html><meta http-equiv='X-UA-Compatible' content='IE=edge'>
		Sleep, 100
		wb := WBGet("ahk_id " hWndAX)
		base.__New(hWnd)
		html =
(
<script>
var ws = null;
function Init(url)
{
	ws = new WebSocket(url);
	ws.onopen = EventHandler;
	ws.onclose = EventHandler;
	ws.onerror = EventHandler;
	ws.onmessage = EventHandler;
}
function EventHandler(e)
{
	if (_EventHandler)
	{
		_EventHandler(e);
	}
}
</script>
)
		wb.document.open()
		wb.document.write(html)
		wb.document.close()
		this.ie := wb.document.parentWindow
		this.ie._EventHandler := this._EventHandler.Bind(this)
		this.ie.Init(url)
	}
	__Delete()
	{
		this.ie := ""
		this.wb := ""
	}
	_EventHandler(e)
	{
		if (this["On" e.type])
		{
			this["On" e.type](e)
		}
	}
	Send(data)
	{
		this.ie.ws.send(data)
	}
	Close(code:=1000, reason:="")
	{
		this.ie.ws.close(code, reason)
	}
	Destroy()
	{
		this.ie._EventHandler := ""
		guiname := this.guiname
		Gui, %guiname%:Destroy
	}	
}
class CChromeWSClient extends CWebSocket
{
	__New(url)
	{
		this.boolean_false := {boolean : false}
		this.boolean_true := {boolean : true}
		this.bConnected := false
		this.responses := Array()
		this.fnPing := this.Ping.Bind(this)
		sp := StrSplit(url, "/")
		this.target_id := sp[sp.MaxIndex()]
		base.__New(url)
		Loop, 20
		{
			if (this.bConnected)
			{
				break
			}
			Sleep, 50
		}
	}
	__Delete()
	{
		base.__Delete()
	}
	Call(method, params:="", bWait := true)
	{
		if (!this.bConnected)
		{
			this.Close()
			return ""
		}
		id := 1
		if (this.responses.MaxIndex())
		{
			id := this.responses.MaxIndex() + 1
		}
		data := Object()
		data.id := id
		data.method := method
		if (params)
		{
			data.params := params
		}
		datastr := StrReplace(StrReplace(JSON.Dump(data), "{""boolean"":0}", "false"), "{""boolean"":1}", "true")
		this.Send(datastr)
		if (!bWait)
		{
			return
		}
		this.responses[id] := false
		Loop, 100
		{
			if (this.responses[id])
				break
			sleep, 50
		}
		response := this.responses.Delete(id)
		if (response)
		{
			if (response.error)
			{
			}
			;LogMessage("Response: " JSON.Dump(response.result))
			return response.result
		}
		return ""
	}
	HandleJavaScriptDialog(accept := true)
	{
		params := {}
		params.accept := accept ? this.boolean_true : this.boolean_false
		response := this.Call("Page.handleJavaScriptDialog", params)
		if (response.exceptionDetails)
		{
			return ""
		}
		return response.result
		
	}
	Navigate(url)
	{
		params := {}
		params.url := url
		response := this.Call("Page.navigate", params)
		if (response.exceptionDetails)
		{
			return ""
		}
		return response.frameId
		
	}
	Evaluate(expression)
	{
		params := {}
		params.expression := expression
		params.objectGroup := "console"
		params.includeCommandLineAPI := this.boolean_true
		params.silent := this.boolean_false
		params.returnByValue := this.boolean_false
		params.userGesture := this.boolean_true
		params.awaitPromise := this.boolean_false
		response := this.Call("Runtime.evaluate", params)
		if (response.exceptionDetails)
		{
			return ""
		}
		return response.result
	}
	
	Ping()
	{
		this.Call("Browser.getVersion", "",false)
	}
	SetWindowBounds(windowId, bounds)
	{
		params := {}
		params.windowId := windowId
		params.bounds := bounds
		response := this.Call("Browser.setWindowBounds", params)
		if (response.exceptionDetails)
		{
			return ""
		}
		return response
	}
	ActivateTarget()
	{
		params := {}
		params.targetId := this.target_id
		response := this.Call("Target.activateTarget", params)
		if (response.exceptionDetails)
		{
			return ""
		}
		return response
	}
	
	GetWindowForTarget()
	{
		params := {}
		params.targetId := this.target_id
		response := this.Call("Browser.getWindowForTarget", params)
		if (response.exceptionDetails)
		{
			return ""
		}
		return response
	}
	GetVersion()
	{
		return this.Call("Browser.getVersion")
	}
	OnOpen(e)
	{
		this.bConnected := true
		ping := this.fnPing
		SetTimer, %ping%, 15000
	}
	OnMessage(e)
	{
		data := JSON.Load(e.data)
		if (this.responses.HasKey(data.id))
		{
			this.responses[data.id] := data
		}
	}
	OnClose(e)
	{
		global _app
		this.Destroy()
		this.bConnected := false
		ping := this.fnPing
		SetTimer, %ping%,  Delete
		; 반드시 지워야 클래스오브젝트가 릴리스됨.
		this.fnPing := ""
		this.ie._EventHandler := ""
		this.ie.ws := ""
		if (_app)
		{
			_app.PostMessage(_app.WM_WEBSOCKET_DISCONNECTED, 0, 0)
		}
	}
	OnError(e)
	{
	}
	Disconnect()
	{
		if (this.bConnected)
			base.Close()
		Loop, 100
		{
			if (!this.bConnected)
				break
			Sleep, 50
		}
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Webbrowser classes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CWebBrowser extends CWindow
{
	__New(n, h, l := "", c := "")
	{
		this.wb := ""
		this.name := n
		this.homepage_url := h
		this.login_url := h l
		this.charging_url := h c
		this.need_restart := false
	}
	SetChargingUrl(url)
	{
		this.charging_url :=  this.homepage_url url
	}
	SetPageError()
	{
		this.err .= "활성화된 '" this.name "' 페이지를 찾을수 없습니다. `r`n"
		this.err .= this.name " 로그인 페이지로 이동합니다. 로그인 후 다시 실행을 눌러주세요"
	}
	SetHWnd(hwnd)
	{
		this.hwnd := hwnd
		this.title := "ahk_id " hwnd
		return WinExist(this.title)
	}
	GetDomain(url)
	{
		if (RegExMatch(url, "O)\/\/([\w\.]+)", matches))
		{
			return matches[1]
		}
		return ""
	}
}
class CWBInternetExplorer extends CWebBrowser
{
	__Delete()
	{
		this.wb := ""
	}
	GetBrowserInfo()
	{
		return this.wb.document.parentWindow.navigator.userAgent
	}
	Init()
	{
		this.err := ""
		if (!this.SetHWnd(WinExist("ahk_class IEFrame")))
		{
			RunWait, Taskkill /f /im iexplore.exe, , Hide
			this.err .= "인터넷 익스플로러가 실행중이지 않습니다`r`n"
			this.SetPageError()
			wb := ComObjCreate("InternetExplorer.Application")
			wb.Visible := true
			wb.Navigate(this.login_url)
			Loop, 50
			{
				Sleep, 200
				if (wb.document.readyState = "complete")
				{
					break
				}
			}
			ObjRelease(wb)
			return this.Init()
		}
		this.wb := WBGet()
		if (this.wb)
		{
			try
			{
				this.WaitComplete()
			}
			catch e
			{
				this.err := "웹브라우저 컨트롤 오류 : " e.message "`r`n"
				this.err .= "회복할수 없는 오류이니 IE 브라우저를 종료후 다시 실행해주세요"
				this.wb := ""
				return false
			}
			return true
		}
		this.err := "IWebBrowserApp Com Object를 가져올 수 없습니다. `r`n"
		this.err .= "회복할수 없는 오류이니 IE 브라우저를 종료후 다시 실행해주세요"
		return false
	}
	WaitComplete()
	{
		iTimeOut := 30 * 1000
		iSleep := 100
		iLoop := Floor(iTimeOut / iSleep)
		Loop, %iLoop%
		{
			Sleep, %iSleep%
			if (this.wb.document.readyState = "complete")
			{
				return true
			}
		}
		return false
	}
	GotoUrl(url)
	{
		this.Activate()
		current_url := SubStr(this.wb.document.location.href, 6)
		if (InStr(url, current_url))
		{
			this.wb.document.location.reload(false)
			return this.WaitComplete()
		}
		this.ControlSetText("Edit1", url)
		Sleep, 200
		this.ControlSend("Edit1", "{Enter}")
		Sleep, 500
		this.WaitComplete()
		Loop, 10
		{
			current_url := SubStr(this.wb.document.location.href, 6)
			if (InStr(url, current_url))
			{
				return true
			}
			else
			{

				this.wb := WBGet()
			}
		}
		return false
	}
	
	CheckState()
	{
		this.err := ""
		if (!InStr(this.wb.document.location.href, this.GetDomain(this.homepage_url)))
		{
			this.SetPageError()
			this.win := new CWindow(WinExist("ahk_class IEFrame"))
			title := this.win.GetTitle()
			if (title != "빈 페이지 - Internet Explorer" && title != "새 탭 - Internet Explorer")
			{
				; 새 탭 열기
				Send, ^t
				Loop, 20
				{
					Sleep, 200
					if (this.win.GetTitle() = "새 탭 - Internet Explorer")
					{
						break
					}
					else
					{
					}
				}
				Sleep, 1000
			}
			if (!this.GotoUrl(this.login_url))
			{
				; WB 재설정 해줌
				this.wb := ""
				return false
			}
		}
		return true
	}
}
class CWBChrome extends CWebBrowser
{
	__Delete()
	{
		if (this.wb)
		{
			this.wb.Disconnect()
		}
		this.wb := ""
	}
	Unescape(value)
	{
		return _app.chrome.Unescape(value)
	}
	GetBrowserInfo()
	{
		result := this.wb.GetVersion()
		return result.userAgent
	}
	Init(bLaunch := true)
	{
		this.err := ""
		name := _app.chrome.korname
		if (!this.SetHWnd(_app.chrome.Exist()) && bLaunch)
		{
			this.err := "개발자모드로 실행된 " name "창이 존재하지 않습니다. " name "을 개발자모드로 실행합니다. `r`n"
			_app.OnChromeLaunch()
			Loop, 40
			{
				Sleep, 250
				if (this.SetHWnd(_app.chrome.Exist()))
				{
					break
				}
			}
		}
		if (!this.Exist())
		{
			this.err .= "개발자모드로 실행된 " name "창이 존재하지 않습니다"
			return false
		}
		if (!this.InitWSClient())
		{
			return false
		}		
		this.Activate()
		return true
	}
	OpenNewTab()
	{
		; 새 탭 열기
		this.need_restart := true
		this.wb.Disconnect()
		this.wb := ""
		Send, ^t
		url := this.GetWebSocketUrl("새 탭")
		if (url)
		{
			this.wb := new CChromeWSClient(url)
		}
	}
	GetWebSocketUrl(title)
	{
		Loop, 10
		{
			Sleep, 100
			url := _app.chrome.GetWebSocketUrl(title)
			if (url)
			{
				return url
			}
		}
		return ""
	}
	InitWSClient()
	{
		if (this.homepage_url)
		{
			url := _app.chrome.GetWebSocketUrl(this.homepage_url, true)
		}
		if (!url)
		{
			title := this.GetTitle()
			if (RegExMatch(title, " - " _app.chrome.titlesuffix "$"))
			{
				title := RegExReplace(title, " - " _app.chrome.titlesuffix "$")
			}
			else
			{
				title := RegExReplace(title, " - .+$")
			}
			url := _app.chrome.GetWebSocketUrl(title)
		}
		if (url = -1)
		{
			this.err := _app.chrome.korname " DevTool의 /json/list 엔드포인트에 연결할수 없습니다."
			return false
		}
		else if (!url)
		{
			this.err := "현재 창에 대한 디버깅주소를 못찾음"
			return false
		}
		if (this.wb)
		{
			if (this.wb.url != url || !this.wb.bConnected)
			{
				this.need_restart := true
				this.wb.Disconnect()
				this.err := "연결을 재설정합니다"
				return false
				
			}
		}
		else
		{
			this.wb := new CChromeWSClient(url)
		}
		return true
	}
	CheckState()
	{
		result := this.wb.Evaluate("document.location.href")
		this.err := ""
		if (!InStr(result.value, this.GetDomain(this.homepage_url)))
		{
			this.SetPageError()
			if (!InStr(this.GetTitle(),"새 탭"))
			{
				this.OpenNewTab()
			}
			if (this.GotoUrl(this.login_url))
			{
				Send, {Tab}
				Sleep, 1000
				if (InStr(this.GetTitle(), "Edge"))
				{
					MouseGetPos, x, y
					MouseClick, left, 10, 500
					MouseMove, x, y
				}
				if (this.need_restart)
				{
					this.err := "새탭으로 브라우저와의 연결이 재설정 되었습니다"
					return false
				}
			}
			else
			{
				this.err .= "새탭을 못엶. 다시 실행시도해주세요"
				return false
			}
		}
		return true
	}
	GotoUrl(url)
	{
		if (!this.wb)
		{
			return false
		}
		result := this.wb.Navigate(url)
		if (result)
		{
			if (this.WaitComplete())
			{
				return true
			}
		}
		return false
	}
	WaitTitle(title)
	{
		Loop, 10
		{
			Sleep, 500
			if (InStr(this.GetTitle(), title))
			{
				this.WaitComplete()
				return true
			}
		}
		return false
	}
	WaitComplete()
	{
		iTimeOut := 30 * 1000
		iSleep := 100
		iLoop := Floor(iTimeOut / iSleep)
		Loop, %iLoop%
		{
			Sleep, %iSleep%
			result := this.wb.Evaluate("document.readyState")
			if (result && result.value = "complete")
			{
				return true
			}
		}
		return false
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GiftCode class
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CGiftCode
{
	codes := Object()
	__New(b, n, r, h, l, c, p := 10)
	{
		this.browser := b
		this.name := n
		this.regex := r
		this.win := b ? new CWBChrome(n, h, l, c) : new CWBInternetExplorer(n, h, l, c)
		this.npp := p
		this.npp_default := p
		this.issued_date := 0
		this.exchange := false
		this.issued_company := 0
		this.phone_number := ""
		this.exchange_urls := Object()
	}
	__Delete()
	{
	}
	ArrangeCode()
	{
	}
	ArrangeExCode()
	{
		arr := Array()
		Loop, % this.codes.MaxIndex()
		{
			codes := this.codes[A_Index]
			if (StrLen(codes) = 12)
			{
				if (this.name = "해피머니" && this.issued_company = "기프티콘")
				{
					arr.Push(Array(codes, this.phone_number))
				}
				else
				{
					arr.Push(Array(codes))
				}
			}
		}
		this.codes := arr
	}
	AutoInput()
	{
		return false
	}
	AutoInputEx()
	{
		if (this.codes.MaxIndex() = 0)
		{
			this.err := "선택된 상품권이 하나도 없습니다. 다시 선택해주세요"
			return false
		}
		if (this.exchange)
		{
			Loop, % this.npp
			{
				row := A_Index + this.page_base
				if (row > this.codes.MaxIndex())
				{
					break
				}
				if (this.GotoCharging())
				{
					if (_app.setting.ex_charging_interval)
					{
						_app.AppendLog(Format("{1:.2f}", _app.setting.ex_charging_interval/1000)  " 초간 쉽니다.")
						Sleep, % _app.setting.ex_charging_interval
					}
				}
				else
				{
					return false
				}
				if (!this.AutoExchangeInput(row))
				{
					return false
				}
			}
			return true
		}
		else
		{
			return this.GotoCharging() && this.AutoInput()
		}
	}
	AutoExchangeInput(row)
	{
		return false
	}
	AutoLogin(loginfo)
	{
		return false
	}
	ConfirmExchangeErrorGoNext(row)
	{
		_app.AppendLog("교환에 실패했습니다.")
		if (row < this.codes.MaxIndex())
		{
			MsgBox, 4, 자동입력기, 교환권 교환에 실패했습니다. 그래도 다음번호로 계속 진행하시겠습니까?, 30
			IfMsgBox, Yes
			{
				return true
			}
			return false
		}				
		return true
	}
	GetBrowserInfo()
	{
		return this.win.GetBrowserInfo()
	}
	GetName()
	{
		name := this.name
		if (this.exchange)
		{
			name .= " " this.issued_company
		}
		else
		{
			name .= " 상품권"
		}
		return name
	}
	GetNumberOnly(str)
	{
		return RegExReplace(str, "[^\d]")
	}
	GetError()
	{
		err := this.err 
		if (this.win.err)
		{
			err .= "`r`n" this.win.err
		}
		this.err := ""
		this.win.err := ""
		return err
	}
	GetExchangeInfo(ByRef content)
	{
		regexp := "Oi)(기프티쇼|기프티콘|기프트팝|아이넘버|giftishow|gifticon|giftpop|inumber)"
		if (RegExMatch(content, regexp, matches))
		{
			cnames_ko := ["기프티쇼", "기프티콘", "기프트팝", "아이넘버", "카카오톡"]
			cnames_en := ["giftishow", "gifticon", "giftpop", "inumber", "kakaotalk"]
			this.issued_company := matches[1]
			Loop, % cnames_en.MaxIndex()
			{
				if (this.issued_company = cnames_en[A_Index])
				{
					this.issued_company := cnames_ko[A_Index] 
					break
				}
			}
		}
		if (RegExMatch(content, "O)수신.*(01[\d\-]{9,})", matches))
		{
			this.phone_number := SubStr(RegExReplace(matches[1], "-"), 1, 11)
		}
		if (!this.issued_company && !this.GetUserInputExchangeInfo())
		{
			return false
		}
		if ((this.name = "컬쳐랜드" || (this.name = "해피머니" && this.issued_company = "기프티콘")) && ! this.phone_number && !this.GetUserInputExchangeInfo())
		{
			return false
		}
		url := this.exchange_urls[this.issued_company]
		if (url)
		{
			this.win.SetChargingUrl(url)
		}
		else
		{
			this.err := this.issued_company " 의 " this.name " 교환권은 지원하지 않습니다."
			return false
		}
		return true
	}
	GetCode(row)
	{
		if (this.codes[row])
		{
			code := ""
			Loop, % this.codes[row].MaxIndex()
			{
				code .= this.codes[row][A_Index] "-"
			}
			StringTrimRight, code, code, 1
			return code
		}
		return 0
	}
	GetCurrentPageInfo()
	{
		return "다음 실행될 페이지는 " this.page " / " this.total_page " 페이지입니다"	
	}
	GetRowCountPrefix(row)
	{
		max_len := StrLen(this.codes.MaxIndex())
		prefix := "0000"
		return SubStr(prefix, 1, max_len - StrLen(row)) row "/" this.codes.MaxIndex() " : "
	}
	GetUserInputExchangeInfo()
	{
		dlg := new CExchangeInfoDialog(this.name, this.issued_company)
		if (dlg.DoModal())
		{
			if (!this.issued_company)
			{
				_app.editContent.AppendText("`r`n`r`n발행회사 : "  dlg.issued_company "`r`n")
			}
			if (!this.phone_number && dlg.phone_number)
			{
				_app.editContent.AppendText("`r`n수신 : " dlg.phone_number "`r`n")
			}
			this.issued_company := dlg.issued_company
			this.phone_number := dlg.phone_number
			return true
		}
		this.err := "필요한 정보입력을 취소하였습니다"
		return false
	}
	GetUserInputIssuedDate()
	{
		dlg := new CIssuedDateDialog()
		if (dlg.DoModal())
		{
			_app.editContent.AppendText("`r`n`r`n발행일 : "  dlg.issued_date "`r`n")
			this.issued_date := dlg.issued_date
			return true
		}
		this.err := "필요한 정보입력을 취소하였습니다"
		return false
	}	
	GotoCharging()
	{
		_app.ExitIfStop()
		this.err := ""
		if (!this.win.GotoUrl(this.win.charging_url))
		{
			this.err := "충전페이지 이동에 실패했습니다"
			return false
		}
		this.win.Activate()
		Sleep, 1000
		return true
	}
	InitWebBrowser()
	{
		if (this.win.Init())
		{
			this.win.Activate()
			this.win.Move(0, 0)
			this.err := "로그인 해주세요"
			return this.win.CheckState()
		}
		return false
	}
	IsLogined()
	{
		return false
	}
	Load()
	{
		if (!this.view.bItemChanged)
		{
			return true
		}
		this.view.Activate()
		if (this.view.GetCount("S") = 0)
		{
			this.err := "선택된 상품권이 하나도 없습니다"
			return false
		}
		names := StrSplit(this.view.name, " ")
		this.name := names[1]
		this.exchange := (names[2] != "상품권")
		if (this.exchange)
		{
			this.issued_company := names[2]
			this.win.SetChargingUrl(this.exchange_urls[this.issued_company])
			this.npp_default := _app.setting.ex_charging_auto ? 10000 : 1
		}
		this.codes := Array()
		this.view.selections := Array()
		row := 0
		while(row := this.view.GetNext(row))
		{
			this.codes.Push(StrSplit(this.view.rows[row][2], "-"))
			this.view.selections.Push(row)
			this.view.SetUsed(row, false)
		}
		this.view.bItemChanged := false
		this.SetPage(1)
		return true
	}
	Parse(ByRef content)
	{
		this.ParseRegex(content)
		this.ArrangeCode()
		if (this.codes.MaxIndex() > 0)
		{
			if (this.name = "해피머니" && this.codes[1][5] = 0)
			{
				if (RegExMatch(content, "O)발행일[^\d]*(20[\d\_\-]{6,})", matches))
				{
					this.issued_date := this.GetNumberOnly(matches[1])
					if (StrLen(this.issued_date) != 8)
					{
						this.issued_date := 0
					}
				}
				else if (RegExMatch(content, "Os)발행일.*(20\d{6})", matches))
				{
					this.issued_date := matches[1]
				}
				if (!this.issued_date && !this.GetUserInputIssuedDate())
				{
					return false
				}
				Loop, % this.codes.MaxIndex()
				{
					this.codes[A_Index][5] := this.issued_date
				}
			}
		}
		else
		{
			this.regex :=  "O)[\s\n\,\:]([\d\-\_]{12,})"
			this.ParseRegex(content)
			if (this.codes.MaxIndex() > 0)
			{
				this.exchange := this.GetExchangeInfo(content)
				if (!this.exchange)
				{
					return false
				}
				this.npp_default := 10000
				this.ArrangeExCode()
			}
		}
		if (this.codes.MaxIndex() < 1)
		{
			if (this.exchange)
			{
				this.err := this.issued_company " " this.name " 교환 쿠폰번호를 하나도 찾을수 없습니다."
			}
			else
			{
				this.err := this.name " 핀번호를 하나도 찾을수 없습니다."
			}
			return false
		}
		this.SetPage(1)
		return true
	}
	ParseRegex(ByRef content)
	{
		pos := 1
		while (pos := RegExMatch(content, this.regex, matches, pos))
		{
			code := matches[1]
			pos += matches.Len(0)
			if (matches.Count() = 3)
			{
				if (!matches[2] || InStr(matches[2], "인증번호") || InStr(matches[2], "/"))
				{
					code .= matches[3]
				}
				else
				{
					pos -= matches.Len(3)
				}
			}
			code := this.GetNumberOnly(code)
			this.codes.Push(code)
		}
	}
	Send(row, col, skip := false)
	{
		_app.ExitIfStop()
		if (!skip)
		{
			Sleep, % _app.setting.send_interval
			Send, % this.codes[row][col]
		}
		if (col = this.codes[row].MaxIndex())
		{
			this.SetUsed(row)
		}
		if (_app.setting.skip_send_logging)
		{
			return
		}
		if (col = 1)
		{
			_app.editLog.AppendText(this.GetRowCountPrefix(row))
		}
		_app.editLog.AppendText(this.codes[row][col])
		if (col = this.codes[row].MaxIndex())
		{
			_app.editLog.AppendText("`r`n")
		}
		else
		{
			_app.editLog.AppendText("-")
		}
	}
	SendExchange(row)
	{
		_app.ExitIfStop()
		code := this.codes[row][1]
		_app.editLog.AppendText(this.GetRowCountPrefix(row) code "`r`n")
		Send %code%
	}
	SetInputElementsError()
	{
		this.err := this.name " 입력창의 구성요소를 찾을수 없습니다. 상품권 번호 입력창이 띄워져 있는지 확인하세요"
	}
	SetPage(page)
	{
		this.npp := (this.exchange && !_app.setting.ex_charging_auto) ? 1 : this.npp_default
		this.total_page := Ceil(this.codes.MaxIndex() / this.npp)
		if (page >= 1 && page <= this.total_page)
		{
			this.page := page
			this.page_base := (this.page - 1) * this.npp
			if (this.total_page > 1 && this.view)
			{
				this.view.Activate()
				this.view.Modify(0, "-Select")
				Loop, % this.npp
				{
					row := this.page_base + A_Index
					if (row > this.view.selections.MaxIndex())
					{
						break
					}
					if (A_Index = 1)
					{
						this.view.EnsureVisible(this.view.selections[row] - 1)
					}
					this.view.Modify(this.view.selections[row], "Select")
				}
			}
			return true
		}
		return false
	}
	SetUsed(row)
	{
		this.view.SetUsed(this.view.selections[row])
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DataSender
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CSTKDataSenderCR extends CGiftCode
{
	__New()
	{
		send_path := "/normal.do?serviceId=S_ETC_0051&viewId=V_CENT5000"
		base.__New(1, "티월드", "", "https://www.tworld.co.kr/", send_path, send_path)
		this.sms := ""
		this.cool_down := 0
	}
	IsLogined()
	{
		result := this.win.wb.Evaluate("escape(document.getElementById('gnb_login').innerText)")
		if (InStr(_app.chrome.Unescape(result.value), "로그아웃"))
		{
			return true
		}
		return false
	}
	Init(fetcher)
	{
		if (fetcher = 0)
		{
			this.sms := new CMSYourPhoneMessageReader()
		}
		else if (fetcher = 1)
		{
			this.sms := new CGoogleMessageReader()
		}
		else if (fetcher = 2)
		{
			this.sms := new CPushbulletMessageReader()
		}
		else
		{
			this.AppendLog("지원하지 않는 문자수신 방식입니다")
			return
		}
		if (!this.sms.Init())
		{
			this.err := this.sms.err
			return false
		}
		if (!this.sms.GetLastMessage(msg, prefix))
		{
			this.err := "문자어플에서 SK텔레콤을 선택하세요"
		}
		this.err := msg
		return this.InitWebBrowser()
	}
	AutoSend(ByRef lv)
	{
		if (!lv.GetCount())
		{
			this.err := "보낼 번호가 없습니다"
			return false
		}
		if (lv.GetCount("S"))
		{
			row := 0
			while(row := lv.GetNext(row))
			{
				if (!this.AutoSendLVRow(lv, row))
				{
					return false
				}
			}
		}
		else
		{
			Loop, % lv.GetCount()
			{
				if (!this.AutoSendLVRow(lv, A_Index))
				{
					return false
				}
			}
		}
		return true
	}
	WaitCoolDown()
	{
		if (this.cool_down)
		{
			while((left := this.cool_down - A_TickCount) > 0)
			{
				_app.ExitIfStop()
				_app.AppendLog("데이터선물 재전송 가능시간까지 " Round(left/1000) " 초 남았습니다")
				if (left > 2000)
				{
					Sleep, 2000
				}
				else
				{
					Sleep, %left%
				}
			}
		}
	}
	HandleCertPopup()
	{
		url := this.win.GetWebSocketUrl("SMS 인증 | T world")
		if (!url)
		{
			this.err := "SMS 인증 창을 찾을수 없습니다"
			return false
		}
		this.SaveLastMessage()
		WinActivate, SMS 인증 | T world - Chrome
		popup := new CChromeWSClient(url)
		popup.Evaluate("document.getElementsByClassName('btnXs btnDgray')[0].click()")
		bSMSConfirm := false
		;; 확인창 닫기 solution 1 : 엔터키로, 2 : 마우스클릭으로
		solution := 1
		if (solution = 1)
		{
			Loop, 50
			{
				Sleep, 200
				Send, {Enter}
				result := popup.Evaluate("document.form2.target")
				if (result.value = "SMSAuth")
				{
					bSMSConfirm := true
					break
				}
			}
		}
		else
		{
			win := new CWindow("SMS 인증 | T world - Chrome")
			chrome := new CChrome()
			chrome.hWnd := win.hWnd
			Loop, 50
			{
				Sleep, 200
				if (chrome.ClickPopupButton("확인") || chrome.ClickPopupButton("OK"))
				{
					bSMSConfirm := true
					break
				}
			}
		}
		if (!bSMSConfirm)
		{
			this.err := "SMS 확인창을 닫을 수 없습니다"
			return false
		}
		if (!this.GetCertNumber(certno))
		{
			this.err := "인증번호를 가져오지 못했습니다"
			return false
		}
		popup.Evaluate("document.getElementById('certNum').value='" certno "'")
		popup.Evaluate("document.getElementsByClassName('btnS btnBlack')[0].click()")
		return true
	}
	SendData(name, m1, m2, m3, amount)
	{
		this.WaitCoolDown()
		if (!this.GotoCharging())
		{
			return false
		}
		result := this.win.wb.Evaluate("document.getElementById('mobile2')")
		if (result.subtype != "node")
		{
			this.SetInputElementsError()
			return false
		}
		
		m1_index := this.GetM1Index(m1)
		if (m1_index > 0)
		{
			this.win.wb.Evaluate("document.getElementsByClassName('con')[0].getElementsByTagName('A')[" m1_index "].click()")
		}
		this.win.wb.Evaluate("document.getElementById('mobile2').value='" m2 "'")
		this.win.wb.Evaluate("document.getElementById('mobile3').value='" m3 "'")
		this.win.wb.Evaluate("document.getElementsByClassName('btnL btnRed')[0].click()")
		;---------------------------- 인증창 --------------------------
		Sleep, 2000
		iRetry := _app.setting.cert_retry
		Loop, %iRetry%
		{
			if (this.HandleCertPopup())
			{
				break
			}
			else if (A_Index = iRetry)
			{
				this.err := "인증번호 수신에 실패했습니다"
				return false
			}
			else
			{
				this.sms.Refresh()
				_app.AppendLog("인증번호 수신에 실패했습니다. 새로고침 후 인증번호를 재요청 합니다 (" (iRetry-A_Index) "회 남음)")
			}
		}
		;---------------------------- 1단계 선택 --------------------------
		if (!this.win.WaitTitle("1단계 데이터량 선택"))
		{
			this.err := "1단계 데이터량 선택 화면을 찾지 못했습니다"
			return false
		}
		Sleep, 1000
		
		result := this.win.wb.Evaluate("document.getElementsByClassName('dataResidual')[0].innerText")
		if (RegExMatch(result.value, "O)잔여 데이터 :[^\d]+([\d\.]+)GB", matches))
		{
			_app.AppendLog("잔여 데이터량 : " matches[1] " GB")
			if (amount > matches[1])
			{
				this.err := "데이터 잔여량이 부족합니다"
				return false
			}
		}
		result := this.win.wb.Evaluate("document.getElementsByClassName('phoneNum')[1].innerText")
		if (!RegExMatch(result.value, "O)^(.+)님의", matches))
		{
			this.err := "받을 사람 이름 정보를 찾을수 없습니다"
			return false
		}
		_app.AppendLog(matches[1])
		re := StrReplace(matches[1], "*", ".*")
		if (!RegExMatch(name, re))
		{
			this.err := "받을 사람 이름 정보가 다릅니다"
			return false
		}
		select_id := "data" Round(amount * 1000)
		
		this.win.wb.Evaluate("document.getElementById('" select_id "').click()")
		this.win.wb.Evaluate("document.getElementsByClassName('btnM btnRed')[0].click()")
		this.win.Activate()
		Send, {Enter}
		;---------------------------- 2단계 완료 --------------------------
		if (!this.win.WaitTitle("2단계 완료"))
		{
			this.err := "2단계 완료 화면을 찾지 못했습니다"
			return false
		}
		result := this.win.wb.Evaluate("document.getElementsByClassName('endTxt')[0].innerText")
		_app.AppendLog(result.value)
		this.cool_down := A_TickCount + _app.setting.cert_cooldown * 1000
		return true
	}
	AutoSendLVRow(ByRef lv, row)
	{
		_app.ExitIfStop()
		name := lv.GetItemText(row, 1)
		phone := lv.GetItemText(row, 2)
		sent := lv.GetItemText(row, 4)
		left := lv.GetItemText(row, 5)
		m1 := SubStr(phone, 1, 3)
		m2 := SubStr(phone, 5, 4)
		m3 := SubStr(phone, 10, 4)
		_app.AppendLog(phone " " name " 님에게 총 " left " GB 데이터 선물을 시작합니다")
		while (left > 0)
		{
			amount := 1
			if (left < amount)
			{
				amount := left
			}
			if (this.SendData(name, m1, m2, m3, amount))
			{
				sent += amount
				left -= amount
				left := Format("{1:.1f}", left)
				lv.Modify(row, "Col4", Format("{1:.1f}", sent))
				lv.Modify(row, "Col5", left)
				_app.AppendLog(amount " GB 선물 성공 - " left "GB 남았습니다")
			}
			else
			{
				return false
			}
		}
		_app.AppendLog(phone " " name " 님에게 데이터 선물을 완료했습니다")
		return true
	}
	SaveLastMessage()
	{
		this.sms.GetLastMessage(msg, prefix)
		this.lastmsg := msg
	}
	GetCertNumber(ByRef n)
	{
		bFound := false
		timeout := 60
		Loop, %timeout%
		{
			_app.ExitIfStop()
			Sleep, 1000
			this.sms.GetLastMessage(msg, prefix)
			if (msg && msg != this.lastmsg)
			{
				bFound := true
				break
			}
			else
			{
				_app.AppendLog(A_Index "/" timeout " : 새로운 문자 수신대기합니다.")
			}
		}
		if (!bFound)
		{
			this.err := "새로운 인증번호를 찾을수 없습니다"
			return false
		}
		if (RegExMatch(msg, "O)인증번호는 (\d{6})", matches))
		{
			n := matches[1]
			_app.AppendLog("새로 발견한 인증번호 :" n)
			return true
		}
		this.err := "마지막 메세지가 인증번호 관련 메세지가 아닙니다"
		return false
	}
	GetM1Index(m1)
	{
		avail := [ "010", "011", "016", "017", "018", "019" ]
		Loop, % avail.MaxIndex()
		{
			if (m1 = avail[A_Index])
			{
				return A_Index -1
			}
		}
		return -1
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Phone Message Readers
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CMessageReader
{
	__New(n)
	{
		this.name := n
		this.messages := []
		this.page := ""
		this.last := ""
		this.skip_pincheck := false
	}
	Init()
	{
		return true
	}
	SetCurrentPage(name)
	{
		this.page := "[ " name " ]"
	}
	Fetch()
	{
		return false
	}
	SkipPinCheck(bCheck)
	{
		this.skip_pincheck := bCheck
	}
	AddMessage(msg, prefix)
	{
		bFound := this.skip_pincheck 
		pos := 1
		while (!bFound && pos := RegExMatch(msg, "O)([\d\-\_ ]{12,})", matches, pos))
		{
			if (StrLen(RegExReplace(matches[1], "[^\d]")) >= 12)
			{
				bFound := true
				break
			}
			pos += matches.Len(0)
		}
		if (bFound)
		{
			o := Object()
			o.prefix := prefix ? prefix : this.last
			o.time := this.GetTime(o.prefix)
			o.msg := msg
			this.last := o.prefix
			this.messages.Push(o)
		}
	}
	Filter(time, regex)
	{
		arr := Array()
		Loop, % this.messages.MaxIndex()
		{
			if (time = 0 || time <= this.messages[A_Index].time)
			{
				if (!regex || RegExMatch(this.messages[A_Index].msg, regex))
				{
					arr.Push(this.messages[A_Index])
				}
			}
			else
			{
			}
		}
		this.messages := arr
	}
	GetTime(prefix)
	{
		return A_Now
	}
	GetLastMessage(ByRef msg, ByRef prefix)
	{
	}
	Refresh()
	{
	}
}
class CMSYourPhoneMessageReader extends CMessageReader
{
	__New()
	{
		RegRead, FriendlyTypeName, HKEY_CURRENT_USER\SOFTWARE\Classes\AppXjqedpv07t7z06q4p8d1w11gptbb3wee1, FriendlyTypeName
		VarSetCapacity(buffer, 1024, 0)
		DllCall("Shlwapi.dll\SHLoadIndirectString", "str", FriendlyTypeName, "ptr", &buffer, "UInt", 1024, "ptr", 0)
		name := StrGet(&buffer)
		if (!name)
		{
			name := "휴대폰과 연결"
		}
		base.__New(name)
		this.uia := new CCUIAutomation()
		this.cond_true := this.uia.CreateTrueCondition()	
		this.elm_messages := ""
	}
	GetChild(ByRef parent, current_name, class_name := "")
	{
		children := new CIUIAutomationElementArray(parent.FindAll(CCUIAutomation.TreeScope_Children, this.cond_true))
		Loop, % children.GetLength()
		{
			child := new CIUIAutomationElement(children.GetElement(A_Index -1))
			if (current_name = child.CurrentName())
			{
				if (!class_name || class_name = child.ClassName())
				{
					return child
				}
			}
		}
	}
	AddChildInfo(pi, depth)
	{
		ObjAddRef(pi)
		parent := new CIUIAutomationElement(pi)
		name := parent.CurrentName()
		classname := parent.ClassName()
		if (classname = "ListViewItem"  || classname = "HyperLink" || classname = "TextBlock")
		{
			return
		}
		children := new CIUIAutomationElementArray(parent.FindAll(CCUIAutomation.TreeScope_Children, this.cond_true))
		if (children.GetLength())
		{
			this.tree .= StrReplace( Format( "{:0" depth "}", "" ), 0, "|") "-" "[" name "][" classname "]`r`n"
		}
		Loop, % children.GetLength()
		{
			child := new CIUIAutomationElement(children.GetElement(A_Index -1))
			this.AddChildInfo(child.pi, depth + 1)
		}		
	}
	GetTree()
	{
		if (!this.uia.pi)
		{
			this.err := "오류 : UI Automation 프레임워크를 사용할수 없습니다"
			return false
		}
		root := new CIUIAutomationElement(this.uia.GetRootElement())
		phone_app := this.GetChild(root, this.name, "ApplicationFrameWindow")
		if (!phone_app)
		{
			this.err := this.name "이 실행중이지 않습니다"
			return false
		}
		this.tree := "`r`n"
		this.tree .= this.name " TREE 시작`r`n"
		this.tree .= "========================`r`n"
		this.AddChildInfo(phone_app.pi, 1)
		this.tree .= "========================`r`n"
		this.tree .= this.name " TREE 끝`r`n"
		return this.tree
	}
	Init()
	{
		if (!this.uia.pi)
		{
			this.err := "오류 : UI Automation 프레임워크를 사용할수 없습니다"
			return false
		}
		root := new CIUIAutomationElement(this.uia.GetRootElement())
		phone_app := this.GetChild(root, this.name, "ApplicationFrameWindow")
		if (!phone_app)
		{
			this.err := this.name "이 실행중이지 않습니다"
			return false
		}
		cond_messages_name := this.uia.CreatePropertyCondition(CCUIAutomation.UIA_NamePropertyId, "메시지")
		cond_messages_controltype := this.uia.CreatePropertyCondition(CCUIAutomation.UIA_ControlTypePropertyId, CCUIAutomation.UIA_ListControlTypeId, 3)
		cond_messages := this.uia.CreateAndCondition(cond_messages_name, cond_messages_controltype)
		results := new CIUIAutomationElementArray(phone_app.FindAll(CCUIAutomation.TreeScope_Subtree, cond_messages))
		if (results.GetLength() = 0)
		{
			this.err := this.name "의 메시지 Elements를 찾을수 없습니다"
			return false
		}
		else if (results.GetLength() > 1)
		{
			this.err := this.name "의 메세지 Elements가 2개 이상 존재합니다`r`n"
			Loop, % results.GetLength()
			{
				child := new CIUIAutomationElement(results.GetElement(A_Index -1))
				this.err .= A_Index " : " child.CurrentName() " : " child.ClassName() "`r`n"
			}
			return false
		}
		this.elm_messages := new CIUIAutomationElement(results.GetElement(0))
		this.elm_messages_scroll := new CIUIAutomationScrollPattern(this.elm_messages.GetCurrentPattern(CCUIAutomation.UIA_ScrollPatternId))
		return true
	}
	GetMessages(bLast := false, nWait := 200)
	{
		if (bLast)
		{
			this.elm_messages_scroll.ScrollVerticalBottom()
		}
		else
		{
			this.elm_messages_scroll.ScrollVerticalTop()
		}
		this.msglist := Array()
		while(1)
		{
			Sleep, %nWait%
			children := new CIUIAutomationElementArray(this.elm_messages.FindAll(CCUIAutomation.TreeScope_Children, this.cond_true))
			Loop, % children.GetLength()
			{
				child := new CIUIAutomationElement(children.GetElement(A_Index -1))
				msg := child.CurrentName()
				if (!RegExMatch(msg, "의 메시지$"))
				{
					msg .= "의 메시지"
				}
				bFound := false
				Loop, % this.msglist.MaxIndex()
				{
					if (this.msglist[A_Index] = msg)
					{
						bFound := true
						break
					}
				}
				if (!bFound)
				{
					this.msglist.Push(msg)
				}
			}
			if (!this.elm_messages_scroll.ScrollVerticalNext(5))
			{
				break
			}
		}
		return this.msglist.MaxIndex()
	}
	GetLastMessage(ByRef msg, ByRef prefix)
	{
		this.SkipPinCheck(true)
		this.GetMessages(true, 100)
		this.ParseMessages()
		if (this.messages.MaxIndex())
		{
			o := this.messages[this.messages.MaxIndex()]
			msg := o.msg
			prefix := o.prefix
			return true
		}
		msg := ""
		prefix := ""
		this.err := "메세지가 하나도 없습니다"
		return false
	}	
	Copy()
	{
		this.GetMessages(false, 500)
		msg := ""
		Loop, % this.msglist.MaxIndex()
		{
			msg .= StrReplace(this.msglist[A_Index], "`n", "`r`n") "`r`n"
		}
		clipboard := msg
		return true
	}
	ParseMessages()
	{
		Loop, % this.msglist.MaxIndex()
		{
			msg := StrReplace(StrReplace(this.msglist[A_Index], ", 메시지 내용을 탐색하려면 Tab 키를 누르세요."), "의 메시지의 메시지", "의 메시지")
			if (RegExMatch(msg, "O)\. +([^\.]+)\.?의 메시지", matches))
			{
				prefix := StrReplace(matches[1], chr(8206))
				msg := StrReplace(msg, matches[0])
				if (RegExMatch(msg, "O)^([^\.]+)\.", matches))
				{
					msg := StrReplace(msg, matches[0])
					prefix := matches[1] " : " prefix
					this.SetCurrentPage(matches[1])
				}
				this.AddMessage(msg, prefix)
			}
			else
			{

			}
		}
	}
	Fetch()
	{
		this.GetMessages(false, 500)
		;LogMessage(this.msglist)
		this.ParseMessages()
		return true
	}
	GetTime(prefix)
	{
		;[+82 1588-4763 : ‎2020‎-‎03‎-‎04 ‎오후‎ ‎9‎:‎50]
		if (RegExMatch(prefix, "O)([\d\-]+) +(오전|오후) +([^ ]+)$", matches))
		{
			time := RegExReplace(matches[3], "[^\d]")
			if (Instr(matches[2], "오후"))
			{
				time += 1200
			}
			time := RegExReplace(matches[1], "[^\d]") . Format("{1:04d}", time) . "00"
			return time
		}
		else
		{
		}
		return A_Now
	}
	Refresh()
	{
		win := new CWindow(this.name)
		if (win.hWnd)
		{
			win.Activate()
			Send, {F5}
		}
	}
}
class CChromeMessageReader extends CMessageReader
{
	__New(n, h)
	{
		base.__New(n)
		this.win := new CWBChrome(n, h)
	}
	Init()
	{
		if (this.win.Init())
		{
			this.win.Activate()
			this.win.Move(0, 0)
			this.err := "로그인 해주세요"
			return this.win.CheckState()
		}
		this.err := this.win.err
		return false
	}
}
class CGifticonMessageReader extends CChromeMessageReader
{
	__New()
	{
		CMessageReader.__New("기프티콘 선물함")
		this.win := new CWBChrome(this.name, "https://www.gifticon.com", "/util/util_login.do", "/mygifticon/present.do?kind=recive")
	}
	Init()
	{
		if (!base.Init())
		{
			this.err := this.win.err
			return false
		}
		if (!this.IsLogined())
		{
			this.err := "로그인 해주세요"
			return false
		}
		if (!this.GotoGiftBox())
		{
			return false
		}
		return true
	}
	IsLogined()
	{
		result := this.win.wb.Evaluate("document.getElementsByClassName('topsearch')[0].innerText") 
		return InStr(result.value, "로그아웃")
	}
	GotoGiftBox()
	{
		this.err := ""
		result := this.win.wb.Evaluate("document.location.href")
		if (!InStr(result.value, this.win.charging_url) && !this.win.GotoUrl(this.win.charging_url))
		{
			this.err := "받은 선물함이동에 실패했습니다"
			return false
		}
		this.win.Activate()
		Sleep, 1000
		return true
	}
	Fetch()
	{
		script =
(
	var t = document.getElementsByClassName('tablestyle2')[0].children[0]; 
	var codes = ''; 
	for (var i= 1; i < t.rows.length; i++)
	{ 
		if (t.rows[i].cells.length < 7)
		{
			continue;
		} 
		t.rows[i].cells[4].children[0].click();
		codes += t.rows[i].cells[1].innerText + '\t';
		codes += t.rows[i].cells[7].innerText + '\t';
		codes += document.getElementById('reProdAcepInfo').innerText + ' 기프티콘\t';
		codes += document.getElementById('reProdCpnoInfo').innerText + '\t';
		codes += '\r\n';
	} 
	reProdInfoPopupClose();
	escape(codes);
)
		result := this.win.wb.Evaluate(script) 
		messages := this.win.Unescape(result.value)
		Loop, parse, messages, `n, `r
		{
			msginfo := StrSplit(A_LoopField, "`t")
			if (msginfo[2] = "교환대기")
			{
				msg := "`r`n" msginfo[3] "`t" msginfo[4] "`r`n"
				this.AddMessage(msg, StrReplace(msginfo[1], ".") "000000000")
			}
		}
		if (!this.messages.MaxIndex())
		{
			this.err := "`r`n`r`n교환대기중인 기프티콘이 없습니다 `r`n`r`n"
			this.err .= "날짜`t`t상태`t상품명`t`t`t번호`r`n" messages "`r`n"
			return false
		}
		return true
	}
	GetTime(prefix)
	{
		return prefix
	}
}
class CGoogleMessageReader extends CChromeMessageReader
{
	__New()
	{
		base.__New("구글 메시지", "https://messages.google.com/web")
	}
	Init()
	{
		if (!base.Init())
		{
			return false
		}
		result := this.win.wb.Evaluate("escape(document.getElementsByClassName('title-container')[0].innerText)")
		if (!result.value)
		{
			this.err := this.name "에서 문자를 선택해 열어주세요"
			return false
		}
		this.SetCurrentPage(this.win.Unescape(result.value))
		return true
	}
	Fetch()
	{
		result := this.win.wb.Evaluate("document.getElementsByTagName('mws-tombstone-message-wrapper')[0].parentElement.children.length")
		if (result.value < 1)
		{
			this.err := "구성요소를 찾을수 없습니다. 문자가 열려있는지 확인해주세요"
			return false
		}
		prefix := ""
		Loop, % result.value
		{
			root_i := A_Index - 1
			result := this.win.wb.Evaluate("document.getElementsByTagName('mws-tombstone-message-wrapper')[0].parentElement.children[" root_i "].tagName")
			if (result.value = "MWS-TOMBSTONE-MESSAGE-WRAPPER")
			{
				result := this.win.wb.Evaluate("escape(document.getElementsByTagName('mws-tombstone-message-wrapper')[0].parentElement.children[" root_i "].innerText)")
				prefix := this.win.Unescape(result.value)
			}
			else if (result.value = "MWS-MESSAGE-WRAPPER")
			{
				result := this.win.wb.Evaluate("document.getElementsByTagName('mws-tombstone-message-wrapper')[0].parentElement.children[" root_i "].getElementsByClassName('text-msg-content').length")
				if (result.value)
				{
					Loop, % result.value
					{
						result := this.win.wb.Evaluate("escape(document.getElementsByTagName('mws-tombstone-message-wrapper')[0].parentElement.children[" root_i "].getElementsByClassName('text-msg-content')[" A_Index - 1 "].innerText)")
						this.AddMessage(this.win.Unescape(result.value), prefix)
					}
				}
			}
		}
		return true
	}	
	GetTime(prefix)
	{
		static wdays := {"일요일" : 1 , "월요일" : 2, "화요일" : 3, "수요일" : 4, "목요일" : 5, "금요일" : 6, "토요일" : 7}
		if (RegExMatch(prefix, "O)(\d+년)?\s*(\d+월)?\s*(\d+일)?\s*([^ ]+요일)?.+(오전|오후) ([^ ]+)",matches))
		{
			year := matches[1] ? RegExReplace(matches[1], "[^\d]") : A_Year
			month := matches[2] ? Format("{1:02d}", RegExReplace(matches[2], "[^\d]")) : A_MM
			day := matches[3] ? Format("{1:02d}", RegExReplace(matches[3], "[^\d]")) : A_DD
			wday := matches[4] ? wdays[matches[4]] : A_Wday
			time := RegExReplace(matches[6], "[^\d]")
			if (matches[5] = "오후")
			{
				time += 1200
			}
			date := year month day Format("{1:04d}", time) "00"
			if (!matches[3])
			{
				day_before := wday - A_Wday
				if (day_before > 0)
				{
					day_before -= 7
				}
				date += %day_before%, D
			}
			return date
		}
		return A_Now
	}	
	GetLastMessage(ByRef msg, ByRef prefix)
	{
		msg := ""
		prefix := ""
		result := this.win.wb.Evaluate("document.getElementsByTagName('mws-relative-timestamp').length")
		if (result.value > 0)
		{
			result := this.win.wb.Evaluate("escape(document.getElementsByTagName('mws-relative-timestamp')[" (result.value - 1) "].innerText)")
			prefix := this.win.Unescape(result.value)
		}
		result := this.win.wb.Evaluate("document.getElementsByClassName('text-msg').length")
		if (result.value > 0)
		{
			result := this.win.wb.Evaluate("escape(document.getElementsByClassName('text-msg')[" (result.value - 1) "].innerText)")
			msg := this.win.Unescape(result.value)
			return true
		}
		return false
	}
}
class CPushbulletMessageReader extends CChromeMessageReader
{
	__New()
	{
		base.__New("Pushbullet", "https://www.pushbullet.com")
	}
	Init()
	{
		if (!base.Init())
		{
			return false
		}
		result := this.win.wb.Evaluate("document.getElementById('innerlist').children.length")
		if (result.value < 1)
		{
			this.err := this.name "에서 문자를 선택해 열어주세요"
			return false
		}
		return true
	}
	Fetch()
	{
		result := this.win.wb.Evaluate("document.getElementById('innerlist').children.length")
		if (result.value > 0)
		{
			length := result.value
			Loop, %length%
			{
				result := this.win.wb.Evaluate("document.getElementById('innerlist').children[" (A_Index - 1) "].children.length")
				if (result.value = 2)
				{
					result := this.win.wb.Evaluate("escape(document.getElementById('innerlist').children[" (A_Index - 1) "].children[0].innerText)")
					prefix := this.win.Unescape(result.value)
					result := this.win.wb.Evaluate("escape(document.getElementById('innerlist').children[" (A_Index - 1) "].children[1].innerText)")
					msg := this.win.Unescape(result.value)
				}
				else
				{
					result := this.win.wb.Evaluate("escape(document.getElementById('innerlist').children[" (A_Index - 1) "].innerText)")
					msg := this.win.Unescape(result.value)
				}
				this.AddMessage(msg, prefix)
			}
		}
		return true
	}
	GetTime(prefix)
	{
		static wdays := {"Sunday" : 1 , "Monday" : 2, "Tuesday" : 3, "Wednesday" : 4, "Thursday" : 5, "Friday" : 6, "Saturday" : 7, "Today" : A_Wday, "Yesterday" : A_Wday -1 }
		static today := A_Year A_MM A_DD
		;  02/07/2020 
		; [Last Monday at 9:21 PM]
		if (RegExMatch(prefix, "O)(\d{2})/(\d{2})/(\d{4})", matches))
		{
			return matches[3] matches[1] matches[2] "000000"
		}
		else if (RegExMatch(prefix, "O)([^ ]+) at ([^ ]+) ([AP]M)", matches))
		{
			time := RegExReplace(matches[2], "[^\d]")
			if (matches[3] = "PM")
			{
				time += 1200
			}
			date := today Format("{1:04d}", time)
			wday := wdays[matches[1]]
			day_before := wday - A_Wday
			if (day_before > 0)
			{
				day_before -= 7
			}
			date += %day_before%, D
			return date
		}
		return A_Now
	}
	GetLastMessage(ByRef msg, ByRef prefix)
	{
		result := this.win.wb.Evaluate("document.getElementById('innerlist').children.length")
		if (result.value > 0)
		{
			index := result.value - 1
			result := this.win.wb.Evaluate("escape(document.getElementById('innerlist').children[" index "].children[0].innerText)")
			prefix := this.win.Unescape(result.value)
			result := this.win.wb.Evaluate("escape(document.getElementById('innerlist').children[" index "].children[1].innerText)")
			msg := this.win.Unescape(result.value)
			return true
		}
		return false
	}
}
class CKakaoTalkMessageReader extends CMessageReader
{
	__New()
	{
		base.__New("카카오톡")
		this.win := ""
	}
	Init()
	{
		WinGet, windows, List
		Loop, %windows%
		{
			win := new CWindow(windows%A_Index%)
			if (win.GetClass() = "#32770" && win.GetProcessName() = "KakaoTalk.exe")
			{
				win.Activate()
				this.SetCurrentPage(win.GetTitle()) 
				this.win := new CWindow(win.ControlGet("EVA_VH_ListControl_Dblclk1"))
				if (this.win.Exist())
				{
					return true
				}
				this.err .= "카카오톡 대화창이 아닙니다"
				return false
			}
		}
		this.err := this.name " 대화창을 찾을수 없습니다"
		return false
	}
	Fetch()
	{
		; 전체선택
		this.win.SendMessage(0x07E9, 0x65, 0)
		; 복사
		this.win.SendMessage(0x07E9, 0x64, 0)
		txt := Clipboard
		arr_daily := Array()
		arr_daily_date := Array()
		pos := 1
		while (pos := RegExMatch(txt, "Om)^(\d{4}년.*요일)$", matches, pos))
		{
			arr_daily.Push(pos)
			arr_daily_date.Push(matches[1])
			pos += matches.Len(0)
		}
		Loop, % arr_daily.MaxIndex()
		{
			daily_date := arr_daily_date[A_Index]
			pos_start := arr_daily[A_Index] + StrLen(daily_date) + 2
			if (A_Index = arr_daily.MaxIndex())
			{
				daily_msg := SubStr(txt, pos_start)
			}
			else
			{
				daily_msg := Substr(txt, pos_start, arr_daily[A_Index +1] - pos_start)
			}
			arr_msg := Array()
			arr_msg_prefix := Array()
			arr_msg_datetime := Array()
			pos := 1
			while (pos := RegExMatch(daily_msg, "Om)^\[[^\]]+\]\s+\[(오. [\d\:]+)\] ", matches, pos))
			{
				arr_msg.Push(pos)
				arr_msg_prefix.Push(matches[0])
				arr_msg_datetime.Push(matches[1])
				pos += matches.Len(0)
			}
			Loop, % arr_msg.MaxIndex()
			{
				msg_date := daily_date " " arr_msg_datetime[A_Index]
				pos_start := arr_msg[A_Index] + StrLen(arr_msg_prefix[A_Index])
				if (A_Index = arr_msg.MaxIndex())
				{
					msg := SubStr(daily_msg, pos_start)
				}
				else
				{
					msg := Substr(daily_msg, pos_start, arr_msg[A_Index +1] - pos_start - 2)
				}
				this.AddMessage(msg, msg_date)
			}
		}
		return true
	}
	GetTime(prefix)
	{
		;[2020년 3월 4일 수요일 오전 10:28]
		if (RegExMatch(prefix, "O)(\d{4})년 (\d+)월 (\d+)일(.+)", matches))
		{
			time := RegExReplace(matches[4], "[^\d]")
			if (InStr(matches[4], "오후"))
			{
				time += 1200
			}
			return matches[1] . Format("{1:02d}", matches[2]) . Format("{1:02d}", matches[3]) .  Format("{1:04d}", time) . "00"
		}
		return A_Now
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 이하는 외부의 공개 WBGet함수, JSON 라이브러리 코드입니다. 
;; 자동입력기를 하나의 파일로 배포하기 위해 따로 Include하지 않고 
;; 원본소스에서 주석, 공백제거한후 코드에 이어 삽입했습니다.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; [WBGet function for AHK v1.1]
; WBGet function - AutoHotkey Community
; https://autohotkey.com/boards/viewtopic.php?f=6&t=39869
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WBGet(WinTitle="ahk_class IEFrame", Svr#=1) {               ;// based on ComObjQuery docs
   static msg := DllCall("RegisterWindowMessage", "str", "WM_HTML_GETOBJECT")
        , IID := "{0002DF05-0000-0000-C000-000000000046}"   ;// IID_IWebBrowserApp
;//     , IID := "{332C4427-26CB-11D0-B483-00C04FD90119}"   ;// IID_IHTMLWindow2
   SendMessage msg, 0, 0, Internet Explorer_Server%Svr#%, %WinTitle%
   if (ErrorLevel != "FAIL") {
      lResult:=ErrorLevel, VarSetCapacity(GUID,16,0)
      if DllCall("ole32\CLSIDFromString", "wstr","{332C4425-26CB-11D0-B483-00C04FD90119}", "ptr",&GUID) >= 0 {
         DllCall("oleacc\ObjectFromLresult", "ptr",lResult, "ptr",&GUID, "ptr",0, "ptr*",pdoc :=0)
         return ComObj(9,ComObjQuery(pdoc,IID,IID),1), ObjRelease(pdoc)
      }
   }
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; JSON lib for AutoHotkey v2.1.3 [updated 04/18/2016 (MM/DD/YYYY)]
; 배포사이트 : https://github.com/cocobelgica/AutoHotkey-JSON
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class JSON
{
class Load extends JSON.Functor
{
Call(self, ByRef text, reviver:="")
{
this.rev := IsObject(reviver) ? reviver : false
this.keys := this.rev ? {} : false
static quot := Chr(34), bashq := "\" . quot
, json_value := quot . "{[01234567890-tfn"
, json_value_or_array_closing := quot . "{[]01234567890-tfn"
, object_key_or_object_closing := quot . "}"
key := ""
is_key := false
root := {}
stack := [root]
next := json_value
pos := 0
while ((ch := SubStr(text, ++pos, 1)) != "") {
if InStr(" `t`r`n", ch)
continue
if !InStr(next, ch, 1)
this.ParseError(next, text, pos)
holder := stack[1]
is_array := holder.IsArray
if InStr(",:", ch) {
next := (is_key := !is_array && ch == ",") ? quot : json_value
} else if InStr("}]", ch) {
ObjRemoveAt(stack, 1)
next := stack[1]==root ? "" : stack[1].IsArray ? ",]" : ",}"
} else {
if InStr("{[", ch) {
static json_array := Func("Array").IsBuiltIn || ![].IsArray ? {IsArray: true} : 0
(ch == "{")
? ( is_key := true
, value := {}
, next := object_key_or_object_closing )
: ( value := json_array ? new json_array : []
, next := json_value_or_array_closing )
ObjInsertAt(stack, 1, value)
if (this.keys)
this.keys[value] := []
} else {
if (ch == quot) {
i := pos
while (i := InStr(text, quot,, i+1)) {
value := StrReplace(SubStr(text, pos+1, i-pos-1), "\\", "\u005c")
static tail := A_AhkVersion<"2" ? 0 : -1
if (SubStr(value, tail) != "\")
break
}if (!i)
this.ParseError("'", text, pos)
  value := StrReplace(value,  "\/",  "/")
, value := StrReplace(value, bashq, quot)
, value := StrReplace(value,  "\b", "`b")
, value := StrReplace(value,  "\f", "`f")
, value := StrReplace(value,  "\n", "`n")
, value := StrReplace(value,  "\r", "`r")
, value := StrReplace(value,  "", "`t")
pos := i
i := 0
while (i := InStr(value, "\",, i+1)) {
if !(SubStr(value, i+1, 1) == "u")
this.ParseError("\", text, pos - StrLen(SubStr(value, i+1)))
uffff := Abs("0x" . SubStr(value, i+2, 4))
if (A_IsUnicode || uffff < 0x100)
value := SubStr(value, 1, i-1) . Chr(uffff) . SubStr(value, i+6)
}if (is_key) {
key := value, next := ":"
continue
}} else {
value := SubStr(text, pos, i := RegExMatch(text, "[\]\},\s]|$",, pos)-pos)
static number := "number", integer :="integer"
if value is %number%
{
if value is %integer%
value += 0
}else if (value == "true" || value == "false")
value := %value% + 0
else if (value == "null")
value := ""
else
this.ParseError(next, text, pos, i)
pos += i-1
}next := holder==root ? "" : is_array ? ",]" : ",}"
}is_array? key := ObjPush(holder, value) : holder[key] := value
if (this.keys && this.keys.HasKey(holder))
this.keys[holder].Push(key)
}}
return this.rev ? this.Walk(root, "") : root[""]
}ParseError(expect, ByRef text, pos, len:=1)
{
static quot := Chr(34), qurly := quot . "}"
line := StrSplit(SubStr(text, 1, pos), "`n", "`r").Length()
col := pos - InStr(text, "`n",, -(StrLen(text)-pos+1))
msg := Format("{1}`n`nLine:`t{2}`nCol:`t{3}`nChar:`t{4}"
,     (expect == "")     ? "Extra data"
: (expect == "'")    ? "Unterminated string starting at"
: (expect == "\")    ? "Invalid \escape"
: (expect == ":")    ? "Expecting ':' delimiter"
: (expect == quot)   ? "Expecting object key enclosed in double quotes"
: (expect == qurly)  ? "Expecting object key enclosed in double quotes or object closing '}'"
: (expect == ",}")   ? "Expecting ',' delimiter or object closing '}'"
: (expect == ",]")   ? "Expecting ',' delimiter or array closing ']'"
: InStr(expect, "]") ? "Expecting JSON value or array closing ']'"
:                      "Expecting JSON value(string, number, true, false, null, object or array)"
, line, col, pos)
static offset := A_AhkVersion<"2" ? -3 : -4
throw Exception(msg, offset, SubStr(text, pos, len))
}Walk(holder, key)
{
value := holder[key]
if IsObject(value) {
for i, k in this.keys[value] {
v := this.Walk(value, k)
if (v != JSON.Undefined)
value[k] := v
else
ObjDelete(value, k)
}}
return this.rev.Call(holder, key, value)
}}
class Dump extends JSON.Functor
{
Call(self, value, replacer:="", space:="")
{
this.rep := IsObject(replacer) ? replacer : ""
this.gap := ""
if (space) {
static integer := "integer"
if space is %integer%
Loop, % ((n := Abs(space))>10 ? 10 : n)
this.gap .= " "
else
this.gap := SubStr(space, 1, 10)
this.indent := "`n"
}return this.Str({"": value}, "")
}Str(holder, key)
{
value := holder[key]
if (this.rep)
value := this.rep.Call(holder, key, ObjHasKey(holder, key) ? value : JSON.Undefined)
if IsObject(value) {
static type := A_AhkVersion<"2" ? "" : Func("Type")
if (type ? type.Call(value) == "Object" : ObjGetCapacity(value) != "") {
if (this.gap) {
stepback := this.indent
this.indent .= this.gap
}is_array := value.IsArray
if (!is_array) {
for i in value
is_array := i == A_Index
until !is_array
}str := ""
if (is_array) {
Loop, % value.Length() {
if (this.gap)
str .= this.indent
v := this.Str(value, A_Index)
str .= (v != "") ? v . "," : "null,"
}} else {
colon := this.gap ? ": " : ":"
for k in value {
v := this.Str(value, k)
if (v != "") {
if (this.gap)
str .= this.indent
str .= this.Quote(k) . colon . v . ","
}}
}if (str != "") {
str := RTrim(str, ",")
if (this.gap)
str .= stepback
}if (this.gap)
this.indent := stepback
return is_array ? "[" . str . "]" : "{" . str . "}"
}} else
return ObjGetCapacity([value], 1)=="" ? value : this.Quote(value)
}Quote(string)
{
static quot := Chr(34), bashq := "\" . quot
if (string != "") {
  string := StrReplace(string,  "\",  "\\")
, string := StrReplace(string, quot, bashq)
, string := StrReplace(string, "`b",  "\b")
, string := StrReplace(string, "`f",  "\f")
, string := StrReplace(string, "`n",  "\n")
, string := StrReplace(string, "`r",  "\r")
, string := StrReplace(string, "`t",  "")
static rx_escapable := A_AhkVersion<"2" ? "O)[^\x20-\x7e]" : "[^\x20-\x7e]"
while RegExMatch(string, rx_escapable, m)
string := StrReplace(string, m.Value, Format("\u{1:04x}", Ord(m.Value)))
}return quot . string . quot
}}
Undefined[]
{
get {
static empty := {}, vt_empty := ComObject(0, &empty, 1)
return vt_empty
}}
class Functor
{
__Call(method, ByRef arg, args*)
{
if IsObject(method)
return (new this).Call(method, arg, args*)
else if (method == "")
return (new this).Call(arg, args*)
}}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
